#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
using namespace std;
struct nz
{
    int x,y;
    nz() {};
    nz(int _x, int _y)
    {
        x=_x;
        y=_y;
    }
};
double eps=1e-8;
int rvn(double d1, double d2)
{
    //cout<<d1<<" "<<d2<<endl;
    if(d1+eps>d2&&d1-eps<d2) return 1;
    return 0;
}
vector<nz> v;
int n;
double a[1002][1002];
double b[1002][1002];
int fb[1002][1002];
int sp[1002][1002];
void comp()
{
    int i,j,k;
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            if(v[j].x-v[i].x==0)
            {
                a[i][j]=b[i][j]=1e9;
                sp[i][j]=1;
                continue;
            }
            a[i][j]=double(v[j].y-v[i].y)/(double)(v[j].x-v[i].x);
            b[i][j]=double(v[i].y-a[i][j]*v[i].x);
        }
    }
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            for(k=j+1;k<n;k++)
            {
                if(sp[i][j])
                {
                    if(v[k].x==v[i].x)
                    {
                        fb[i][j]=fb[i][k]=fb[j][k]=1;
                    }
                }
                else if(sp[i][k])
                {
                    if(v[k].x==v[j].x)
                    {
                        fb[i][j]=fb[i][k]=fb[j][k]=1;
                    }
                }
                else if(sp[j][k])
                {
                    if(v[i].x==v[k].x)
                    {
                        fb[i][j]=fb[i][k]=fb[j][k]=1;
                    }
                }
                else if(rvn(a[i][j],a[j][k])||rvn(b[i][j],b[j][k]))
                {
                    fb[i][j]=fb[i][k]=fb[j][k]=1;
                }
            }
        }
    }
}
nz pres(int i1, int i2, int i3, int i4)
{
    if(sp[i1][i2]&&sp[i3][i4])
    {
        return nz(1e9,1e9);
    }
    int xx,yy;
    if(sp[i1][i2])
    {
        xx=v[i1].x;
        yy=xx*a[i3][i4]+b[i3][i4];
        if(!rvn((double)(xx*a[i3][i4]+b[i3][i4]),(double)yy)) return nz(1e9,1e9);
        return nz(xx,yy);
    }
    else if(sp[i3][i4])
    {
        xx=v[i3].x;
        yy=xx*a[i1][i2]+b[i1][i2];
        if(!rvn((double)(xx*a[i1][i2]+b[i1][i2]),(double)yy)) return nz(1e9,1e9);
        return nz(xx,yy);
    }
    else
    {
    int xx=(b[i3][i4]-b[i1][i2])/(a[i1][i2]-a[i3][i4]);
    int yy=a[i1][i2]*xx+b[i1][i2];
    if(!rvn((double)(xx)*((a[i1][i2]-a[i3][i4])),b[i3][i4]-b[i1][i2])) return nz(1e9,1e9);
    if(!rvn((double)yy,(double)(a[i1][i2]*xx+b[i1][i2]))) return nz(1e9,1e9);
    return nz(xx,a[i1][i2]*xx+b[i1][i2]);
    }
}
int used[1005];
int check(int i1, int i2, int i3, int i4)
{
    nz ppr=pres(i1,i2,i3,i4);
    if(ppr.x==1e9&&ppr.y==1e9) return 0;
    int i,j;
    memset(used,0,sizeof(used));
    used[i1]=used[i2]=used[i3]=used[i4]=1;
    for(i=0;i<n;i++)
    {
        if(ppr.x==v[i].x&&ppr.y==v[i].y) return 0;
        if(used[i]) continue;
        for(j=i+1;j<n;j++)
        {
            if(used[j]) continue;
            if(pres(i,j,i1,i2).x==ppr.x&&pres(i,j,i1,i2).y==ppr.y)
            {
                used[i]=used[j]=1;
                break;
            }
        }
        if(!used[i]) return 0;
    }
    return 1;
}
int main()
{
	int i,j;
	cin>>n;
	if(n>25)
    {
        cout<<"No"<<endl;
        return 0;
    }
	n*=2;
	int x,y;
	for(i=0;i<n;i++)
    {
        cin>>x>>y;
        v.push_back(nz(x,y));
    }
    comp();
    int k,l;
    //cout<<pres(0,1,2,3).x<<endl;
    for(i=0;i<n;i++)
    {
        for(j=i+1;j<n;j++)
        {
            if(fb[i][j]) continue;
            for(k=i+1;k<n;k++)
            {
                if(k==j) continue;
                for(l=k+1;l<n;l++)
                {
                    if(l==j||fb[k][l]) continue;
                    if(check(i,j,k,l))
                    {
                        cout<<"Yes"<<endl;
                        cout<<pres(i,j,k,l).x<<" "<<pres(i,j,k,l).y<<endl;
                        return 0;
                    }
                }
            }
        }
    }
    cout<<"No"<<endl;
	return 0;
}
