#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

vector <int> g[maxn];
priority_queue <int> heap;

int h[maxn], n, t[maxn], cost[maxn], subtree[maxn];
long long answer;

void dfs(int node, int dad) {
    subtree[ node ] = 1;
    for (int son: g[ node ]) {
        if (son != dad) {
            dfs(son, node);
            subtree[ node ] += subtree[ son ];
        }
    }
}

void computeTree(int node, int dad) {
    if (g[ node ].empty())
        return;

    while (!heap.empty())
        heap.pop();

    for (int son: g[ node ]) {
        if (son == dad)
            continue;
        heap.push(subtree[ son ]);
        answer += subtree[ son ];
    }

    int m1, m2;
    while (heap.size() > 1) {
        m1 = heap.top();
        heap.pop();
        m2 = heap.top();
        heap.pop();
        if (m1 - m2 > 0)
            heap.push(m1 - m2);
    }

    if (!heap.empty()) {
        answer += heap.top();
        heap.pop();
    }

    for (int son: g[ node ]) {
        if (son != dad)
            computeTree( son, node );
    }
}

int main()
{
    ios::sync_with_stdio(false);
    //freopen( "raphael.in", "r", stdin );
    //freopen( "raphael.out","w", stdout);

    cin >> n;

    for (int i = 2; i <= n; i++) {
        cin >> t[ i ];
        g[ t[ i ] ].push_back( i );
    }

    int ok = 1;
    for (int i = 2; i <= n; i++) {
        cin >> cost[ i ];
        if (cost[ i ] != 1)
            ok = 0;
    }

    if (ok == 0) {
        cout << 0;
        return 0;
    }

    dfs(1, 0);
    computeTree(1, 0);

    cout << answer;

    return 0;
}
