#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 2005;
const int INF = 1e9 + 7;

class Tree {
public:
	class Node {
	public:
		int id, val, sumInSubtree, minInSubtree, sizeOfSubtree;
		vector< Node* > v;

		Node() {
			sumInSubtree = 0;
			sizeOfSubtree = 1;
			minInSubtree = INF;
			v.clear();
		}
	};

	int cntNodes;
	Node nodes[MAX_N];

	void Init(int cntNodes) {
		this->cntNodes = cntNodes;
		
		for(int i = 1; i <= cntNodes; i++) {
			nodes[i].id = i;
		}
	}

	void PrecomputeDfs(Node *nd) {
		nd->sumInSubtree = nd->val;
		nd->minInSubtree = nd->val;
		
		for(Node *x : nd->v) {
			PrecomputeDfs(x);

			nd->sumInSubtree += x->sumInSubtree;
			nd->minInSubtree = min(nd->minInSubtree, x->minInSubtree);
			nd->sizeOfSubtree += x->sizeOfSubtree;
		}
	}
};

Tree tree;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	
	tree.Init(n);
	for(int i = 2; i <= n; i++) {
		int p;
		cin >> p;

		tree.nodes[p].v.push_back(&tree.nodes[i]);
	}

	for(int i = 2; i <= n; i++) {
		cin >> tree.nodes[i].val;
	}

	tree.PrecomputeDfs(&tree.nodes[1]);

	long long ans = 0;
	for(int i = 1; i <= n; i++) {
		if(tree.nodes[i].v.size() == 0) {
			continue;
		}

		pair< int, int > min1 = { -1, INF }, min2 = { -1, INF };
		for(auto x : tree.nodes[i].v) {
			if(x->minInSubtree <= min1.second) {
				min2 = min1;
				min1 = { x->id, x->minInSubtree };
			}
			else if(x->minInSubtree < min2.second) {
				min2 = { x->id, x->minInSubtree };
			}
		}

		//cout << i << " " << min1.first << " " << min1.second << " " << min2.first << " " << min2.second << endl;

		for(auto x : tree.nodes[i].v) {
			//cout << "   " << x->id << " " << x->sumInSubtree << endl;

			if(x->id == min1.first) {
				ans += 1ll * x->sumInSubtree + 1ll * x->sizeOfSubtree * min2.second;
			}
			else {
				ans += 1ll * x->sumInSubtree + 1ll * x->sizeOfSubtree * min1.second;
			}
		}

		ans -= 1ll * min1.second;
		ans -= 1ll * min2.second;
		
		//cout << ans << endl;
	}

	cout << ans << endl;
	return 0;
}
