#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 2005;
const int INF = 1e9 + 7;

class Tree {
public:
	class Node {
	public:
		int id, val, sumInSubtree, minInSubtree, sizeOfSubtree;
		vector< Node* > v;

		Node() {
			sumInSubtree = 0;
			sizeOfSubtree = 1;
			minInSubtree = INF;
			v.clear();
		}
	};

	int cntNodes;
	Node nodes[MAX_N];

	void Init(int cntNodes) {
		this->cntNodes = cntNodes;
		
		for(int i = 1; i <= cntNodes; i++) {
			nodes[i].id = i;
		}
	}

	void PrecomputeDfs(Node *nd) {
		nd->sumInSubtree = nd->val;
		nd->minInSubtree = nd->val;
		
		for(Node *x : nd->v) {
			PrecomputeDfs(x);

			nd->sumInSubtree += x->sumInSubtree;
			nd->minInSubtree = min(nd->minInSubtree, x->minInSubtree);
			nd->sizeOfSubtree += x->sizeOfSubtree;
		}
	}
};

Tree tree;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	
	tree.Init(n);
	for(int i = 2; i <= n; i++) {
		int p;
		cin >> p;

		tree.nodes[p].v.push_back(&tree.nodes[i]);
	}

	bool areAllCOnes = true;
	for(int i = 2; i <= n; i++) {
		cin >> tree.nodes[i].val;
		
		if(tree.nodes[i].val != 1) {
			areAllCOnes = false;
		}
	}

	tree.PrecomputeDfs(&tree.nodes[1]);
	
	if(areAllCOnes) {
		int ans = 0;
		for(int i = 1; i <= n; i++) {
			if(tree.nodes[i].v.size() == 0) {
				continue;
			}
			
			int aux = 0;
			for(auto x : tree.nodes[i].v) {
				if(aux <= x->sizeOfSubtree) {
					ans += 2 * aux;
					aux = x->sizeOfSubtree - aux;
				}
				else {
					ans += 2 * x->sizeOfSubtree;
					aux -= x->sizeOfSubtree;
				}
			}

			ans += 2 * aux;
		}
		
		cout << ans << endl;
	}

	return 0;
}
