#include <bits/stdc++.h>
using namespace std;

int n;
vector<pair<int, int>> a;
const int INF = 1000000000;
const int MAXX = 1000000;

pair<int, int> inters(pair<int, int> &a, pair<int, int> &b, pair<int, int> &c, pair<int, int> &d) {
    long long a1 = b.second - a.second;
    long long b1 = a.first - b.first;
    __int128 c1 = -(a.first * a1 + a.second * b1);

    long long a2 = d.second - c.second;
    long long b2 = c.first - d.first;
    __int128 c2 = -(c.first * a2 + c.second * b2);

    long long dd = a1 * b2 - b1 * a2;
    if (dd == 0) {
        return {INF, INF};
    }
    __int128 d1 = (-c1) * b2 - b1 * (-c2);
    __int128 d2 = a1 * (-c2) - (-c1) * a2;

    if (d1 % dd != 0 || d2 % dd != 0 || abs(d1 / dd) > MAXX || abs(d2 / dd) > MAXX) {
        return {INF, INF};
    } else {
        return {d1 / dd, d2 / dd};
    }
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

bool check(pair<int, int> p) {
    vector<pair<int, int>> vs;
    for (int i = 0; i < n; i++) {
        if (a[i] == p) {
            return false;
        }
        int x = p.first - a[i].first;
        int y = p.second - a[i].second;
        if (y < 0) {
            y *= -1;
            x *= -1;
        } else if (y == 0 && x < 0) {
            x *= -1;
        }
        int g = gcd(abs(x), y);
        x /= g;
        y /= g;
        vs.push_back({x, y});
    }

    sort(vs.begin(), vs.end());

    for (int i = 0; i < n; i += 2) {
        if (vs[i] != vs[i + 1]) {
            return false;
        }
        if (i > 0 && vs[i] == vs[i - 1]) {
            return false;
        }
    }

    return true;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    n *= 2;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = 0; k < n; k++) {
                if (k == i || k == j) continue;
                for (int l = k + 1; l < n; l++) {
                    if (l == i || l == j) continue;

                    auto p = inters(a[i], a[j], a[k], a[l]);
                    if (p.first != INF) {
                        if (check(p)) {
                            cout << "Yes" << endl;
                            cout << p.first << " " << p.second << endl;
                            return 0;
                        }
                    }
                }
            }
        }
    }

    cout << "No" << endl;

    return 0;
}