#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <ctime>
#include <cassert>

using namespace std;
const long long MAXN = 501;
const long long INF = 1e18 + 100;

struct Point{
    long long x;
    long long y;

    Point(){
    }

    Point(long long xx, long long yy){
        x = xx;
        y = yy;
    }
};

struct Line{
    long long a;
    long long b;
    long long c;

    Line(Point& p1, Point& p2){
        a = p1.y - p2.y;
        b = p2.x - p1.x;
        c = -a * p1.x - b * p1.y;
    }
};

bool operator < (const Point& a, const Point& b){
    if (a.x == b.x){
        return a.y < b.y;
    } else {
        return a.x < b.x;
    }
}

bool operator == (const Line& l1, const Line& l2){
    return (l1.a * l2.b == l1.b * l2.a) && (l1.a * l2.c == l1.c * l2.a) && (l1.c * l2.b == l1.b * l2.c);
}

long long n;
Point mas[MAXN];

Point Intersect(Line& l1, Line& l2){
    long long a = l1.a * l2.c - l1.c * l2.a;
    long long b = l1.c * l2.b - l1.b * l2.c;
    long long c = l1.b * l2.a - l1.a * l2.b;

    if (c == 0){
        return Point(INF, INF);
    }

    if (a % c != 0){
        return Point(INF, INF);
    }

    if (b % c != 0){
        return Point(INF, INF);
    }

    return Point(b / c, a / c);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    n *= 2;
    for (long long i = 0; i < n; ++i){
        cin >> mas[i].x >> mas[i].y;
    }

    vector<Line> kek;

    for (long long i = 0; i < n; ++i){
        for (long long j = i + 1; j < n; ++j){
            kek.push_back(Line(mas[i], mas[j]));
        }
    }

    vector<bool> zi(kek.size(), true);

    for (long long i = 0; i < (long long)kek.size(); ++i){
        for (long long j = i + 1; j < (long long)kek.size(); ++j){
            if (kek[i] == kek[j]){
                zi[i] = zi[j] = false;
            }
        }
    }

    vector<Line> v;

    for (long long i = 0; i < (long long)kek.size(); ++i){
        if (zi[i]){
            v.push_back(kek[i]);
        }
    }

    map<Point, long long> mp2;

    for (long long i = 0; i < (long long)v.size(); ++i){
        for (long long j = i + 1; j < (long long)v.size(); ++j){
            Point p = Intersect(v[i], v[j]);
            if ((abs(p.x) <= 1000 * 1000) && (abs(p.y) <= 1000 * 1000)){
                mp2[p]++;
            }
        }
    }

    for (long long i = 0; i < n; ++i){
        mp2.erase(mas[i]);
    }

    n /= 2;
    for (auto e : mp2){
        if (2 * e.second == n * (n - 1)){
            cout << "Yes" << endl;
            cout << e.first.x << ' ' << e.first.y << endl;
            return 0;
        }
    }

    cout << "No" << endl;

    return 0;
}
