#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <cassert>
#include <bitset>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

struct point{
    ll x, y;

    point(ll _x = 0, ll _y = 0) {
        x = _x;
        y = _y;
    }

    point operator + (point a) {
        return point(x + a.x, y + a.y);
    }

    point operator - (point a) {
        return point(x - a.x, y - a.y);
    }

    bool operator == (point a) {
        return x == a.x && y == a.y;
    }

    ll operator * (point a) {
        return x * a.y - y * a.x;
    }

    ll operator % (point a) {
        return x * a.x + y * a.y;
    }

    friend istream&operator >> (istream &in, point &a) {
        return in >> a.x >> a.y;
    }

    friend ostream&operator << (ostream &out, point &a) {
        return out << a.x << ' ' << a.y;
    }
};

ll sgn(ll a){
    if (!a)
        return 0;
    return a > 0 ? 1 : -1;
}

const int maxn = 2 * 2600;
point p[maxn];
int us[maxn];
int n;

struct ver{
    ll a, b, c;

    ver() {}

    ver(point x, point y) {
        a = y.y - x.y;
        b = x.x - y.x;
        c = x.y * (y.x - x.x) - x.x * (y.y - x.y);
    }

    bool operator == (ver x) {
        return a == x.a && b == x.b && c == x.c;
    }

    bool operator || (ver t) {
        return a * t.b == t.a * b;
    }

    bool on(point x) {
        return a * x.x + b * x.y + c == 0;
    }
};

point inter(ver f, ver s) {
    point x;
    assert(f.a * s.b - s.a * f.b != 0);
    x.x = -(f.c * s.b - s.c * f.b) / (f.a * s.b - s.a * f.b);
    x.y = -(f.c * s.a - s.c * f.a) / (f.b * s.a - f.a * s.b);
    return x;
}

bool check(point M) {
    bool f = true;
    for (int i = 0; i < n && f; ++i) {
        int cnt = 0;
        ver A(p[i], M);
        for (int j = 0; cnt < 2 && j < n && f; ++j) {
            if (i == j)
                continue;
            cnt += A.on(p[j]);
        }
        if (cnt == 2)
            f = 0;
    }
    return f;
}

int main() {
 //   freopen("inp3.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    n <<= 1;
    for (int i = 0; i < n; ++i)
        cin >> p[i];
    if (n == 2) {
        ver A(p[0], p[1]);
        point M;
        bool f = false;
        if (A.b != 0)
            for (ll x = -1e6; x <= 1e6; ++x)
                if ((-A.c - x * A.a) % A.b == 0 && (-A.c - x * A.a) / A.b <= 1e6 && (-A.c - x * A.a) / A.b >= -1e6) {
                    M = point(x, (-A.c - x * A.a) / A.b);
                    f = 1;
                    break;
                }
        else
            for (ll y = -1e6; y <= 1e6; ++y)
                if ((-A.c - y * A.b) % A.a == 0 && (-A.c - y * A.b) / A.a <= 1e6 && (-A.c - y * A.b) / A.a >= -1e6) {
                    M = point(x, (-A.c - y * A.b) / A.a);
                    f = 1;
                    break;
                }
        if (f)
            cout << "Yes\n" << M;
        else
            cout << "No";
        return 0;
    }
    {
        ver A(p[0], p[1]);
        for (int i = 3; i < n; ++i) {
            ver B(p[2], p[i]);
            if (B || A)
                continue;
            auto M = inter(A, B);
            if (!A.on(M) || !B.on(M) || M == p[0] || M == p[1] || M == p[2] || M == p[i] || abs(M.x) > 1e6 || abs(M.y) > 1e6)
                continue;
            if (check(M)) {
                cout << "Yes\n";
                cout << M;
                return 0;
            }
        }
    }
    for (int i = 2; i < n; ++i)
        for (int j = 2; j < n; ++j) {
            if (i == j)
                continue;
            ver A(p[0], p[i]), B(p[1], p[j]);
            if (B || A)
                continue;
            auto M = inter(A, B);
            if (!A.on(M) || !B.on(M) || M == p[0] || M == p[1] || M == p[j] || M == p[i] || abs(M.x) > 1e6 || abs(M.y) > 1e6)
                continue;
            if (check(M)) {
                cout << "Yes\n";
                cout << M;
                return 0;
            }
        }
    cout << "No";
    return 0;
}