#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <iterator>
#include <functional>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <bitset>
#include <cinttypes>
#include <unordered_map>
#include <unordered_set>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cmath>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define sqr(x) ((x)*(x))
#define cube(x) (sqr(x)*(x))
#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vii vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define vpll vector<pll>
#define vvii vector<vii>
#define vvll vector<vll>
#define vvpii vector<vpii>
#define vvpll vector<vpll>
#define forn(i,n) for(int i=0;i<n;i++)
#define forab(i,a,b) for(int i=a;i<=b;i++)
#define fornout(i,n,c) for(int i=0;i<n;i++,cout<<c)

const ld PI = acos(-1);
const ll INF = 1e18;
const ld EPS = 1e-7;
const short int MOD1 = 101;
const short int MOD2 = 103;
const short int MOD3 = 107;
const short int MOD4 = 109;
const int MAXN = 1e5;

bool isInt(ld x) {
    return abs(x - int(x)) < EPS;
}

struct Point {
    ld x, y;

    Point() {}
    Point(ld xx, ld yy) : x(xx), y(yy) {}

    void in() {
        cin >> x >> y;
    }

    void out() {
        cout << x << ' ' << y << '\n';
    }

    Point operator +(const Point &t) const {
        return Point(x + t.x, y + t.y);
    }

    Point operator -(const Point &t) const {
        return Point(x - t.x, y - t.y);
    }

    bool operator <(const Point &p) const {
        return abs(x - p.x) < EPS ? p.y - y > EPS : p.x - x > EPS;
    }
};

struct Line {
    ld a, b, c;

    Line() {}
    Line(ld aa, ld bb, ld cc) :
        a(aa / aa),
        b(bb / bb),
        c(cc / cc)
    {}

    Line(Point a, Point b) :
        a((a.y - b.y)             / (abs(a.y - b.y) < EPS ? b.x - a.x : a.y - b.y)),
        b((b.x - a.x)             / (abs(a.y - b.y) < EPS ? b.x - a.x : a.y - b.y)),
        c((a.x * b.y - a.y * b.x) / (abs(a.y - b.y) < EPS ? b.x - a.x : a.y - b.y))
    {}

    bool operator ||(const Line &l) const {
        return abs(a - l.a) < EPS && abs(b - l.b) < EPS;
    }

    bool operator ==(const Line &l) const {
        return abs(a - l.a) < EPS && abs(b - l.b) < EPS && abs(c - l.c) < EPS;
    }

    Point operator *(const Line &l) const {
        if (abs(a) < EPS) {
            return Point((-l.c - l.b * (l.c * a / l.a - c) / (b - l.b * a / l.a)) / l.a, (l.c * a / l.a - c) / (b - l.b * a / l.a));
        }
        else {
            return Point((-c - b * (c * l.a / a - l.c) / (l.b - b * l.a / a)) / a, (c * l.a / a - l.c) / (l.b - b * l.a / a));
        }
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;

    vector <Point> p(2 * n);
    set <Point> cp;
    for (int i = 0; i < 2 * n; i++) p[i].in(), cp.insert(p[i]);

    vector <Line> l;
    for (int i = 0; i < 2 * n; i++) {
        for (int j = i + 1; j < 2 * n; j++) {
            Line q = Line(p[i], p[j]);
            bool fr = true;
            for (auto f : l)
                if (q == f)
                    fr = false;
            if (fr)
                l.push_back(q);
        }
    }

    map <Point, int> cnt;
    Point ans;
    bool bl = true;
    for (int i = 0; i < l.size() && bl; i++) {
        for (int j = i + 1; j < l.size() && bl; j++) {
            if (l[i] || l[j]) {
                continue;
            }
            auto w = l[i] * l[j];

            if (isInt(w.x) && isInt(w.y) && cp.find(w) == cp.end() && abs(1e6 - w.x) > -EPS && abs(1e6 - w.y) > -EPS) {
                cnt[w] += 4;
                if (cnt[w] == 2 * n * (n - 1)) bl = false, ans = w;
            }
        }
    }

    if (bl)
        cout << "No";
    else
        cout << "Yes\n", ans.out();

    return 0;
}