#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <vector>

using namespace std;


int64_t gcd(int64_t a, int64_t b) {
	if (a > b) swap(a, b);
	if (a == 0 && b == 0) return 1;
	if (a == 0) return b;
	if (b == 0) return a;
	return __gcd(a, b);
}	

struct line 
{
	int64_t a, b, c;
	void norm() {
		int64_t qa = abs(a), qb = abs(b), qc = abs(c);
		int64_t x = gcd(gcd(qa, qb), qc);
		if (x != 0) {
			a /= x; b /= x; c /= x;
		}
		if (a < 0 || ((a == 0) && (b < 0))) {
			a *= -1;
			b *= -1;
			c *= -1;
		}
	}
};

bool operator < (line a, line b) {
	if (a.a < b.a) return true;
	if (a.a > b.a) return false;
	if (a.b < b.b) return true;
	if (a.b > b.b) return false;
	if (a.c < b.c) return true;
	return false;
}

map <line, int> m;
vector <int> x;
vector <int> y;

int main() 
{
	int n;
	cin >> n;
	n *= 2;
	x.resize(n, 0);
	y.resize(n, 0);
	for (int i = 0;i < n; i++) {
		cin >> x[i] >> y[i];
	}
	m.clear();
	for (int center_x = -100; center_x <= 100; center_x++) {
		for (int center_y = -100; center_y <= 100; center_y++) {
			m.clear();
			//cout << center_x << ' ' << center_y << endl;
			bool ok = true;
			for (int i = 0; i < n; i++) {
				if (center_x == x[i] && center_y == y[i]) {
					ok = false;
					break;
				}
				line l;
				l.a = y[i] - center_y;
				l.b = center_x - x[i];
				l.c = -1 * l.a * x[i] - l.b * y[i];
				l.norm();
				m[l]++;
			}
			if (!ok) continue;
			for (auto i:m) {
				if (i.second != 2) {
					ok = false;
					break;
				}
			}
			if (ok) {
				cout << "Yes\n";
				cout << center_x << ' ' << center_y;
				return 0;
			}
		}
	}
	
	cout << "No";
	
}	
