#pragma GCC optimize("O2")
#ifdef AC
    #define __GLIBCXX_DEBUG
    #define __GLIBCXX_ASSERT
#endif // AC
#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef int ll;
typedef double ld;
template<class A>void addlog(A a)
{ cerr<<a<<endl; }
template<class A,class... B>void
addlog(A a,B... b){ cerr<<a<<' ';addlog(b...); }

const ld EPS = 1e-12;
struct Point {ld x, y;};
const Point NO_POINT{-19,-19};
struct Line  {ld a, b, c;};

inline bool eq(ld a,ld b){return abs(a-b)<EPS;}
inline bool eq(const Point &a, const Point &b)
{return eq(a.x,b.x)&&eq(a.y,b.y);}
void norm (Line &l) {
    ld z = hypot(l.a, l.b);
    if ((l.a < 0) || (eq(l.a,0)&&l.b<0))
        z = -z;
    l.a/=z;l.b/=z;l.c/=z;
}
#define neq(x,y) (!eq((x),(y)))
ostream &operator<<(ostream &out,const Point &p)
{ return out<<p.x<<' '<<p.y; }
istream &operator>>(istream &in,Point &p)
{ return in>>p.x>>p.y; }
ostream &operator<<(ostream &out,const Line &l)
{ return out<<l.a<<' '<<l.b<<' '<<l.c; }
ld vecMul (ld ax,ld ay,  ld bx,ld by)
{ return ax*by - ay*bx; }
bool operator< (Line a, Line b) {
    if (eq(a.a,b.a)) {
        if (eq(a.b,b.b))
            return a.c<b.c;
        return a.b<b.b;
    } return a.a < b.a;
}
Point intersectLines (const Line &I, const Line &II) {
    ld D0   = vecMul(I.a, I.b,  II.a, II.b);
    ld Dx   = vecMul(I.b, I.c,  II.b, II.c);
    ld Dy   = vecMul(I.c, I.a,  II.c, II.a);
    if (D0 == 0)
        return NO_POINT;
    return Point{Dx / D0, Dy / D0};
}
Line getLine (const Point p, const Point q) {
    ld a = p.y - q.y; ld b = q.x - p.x;
    ld c = -(a*p.x + b*p.y);
    return Line{a,b,c};
}
inline bool integer(ld a)
{return eq(a,floor(a));}
inline bool integer(Point &x) {
    return integer(x.x)&&integer(x.y);
}
ll N;
vector<Point> points;

void start () {
    freopen("input.txt", "r", stdin);
    cin >> N; N *= 2;
    points.resize(N);
    for (ll i = 0; i < N; ++ i)
        cin >> points[i];
}

bool check (Point m) {
    //addlog("Checking", m);
    if (neq(m, NO_POINT)) {
        //addlog("Normal point.");
        for (Point p : points)
        if (eq(m, p))return false;
        //addlog("Not eq to other.");
        map<Line, ll> cnt;
        for (Point p : points) {
            Line l = getLine(m, p);
            norm(l); ++ cnt[l];
        }

        for (auto par : cnt)
        if (par.second != 2) {
            //addlog("    Bad line:", par.first, par.second);
            return false;
        }
        //addlog("Strictly 2 points on every line.");
        return true;
    } else
        return false;
}

int main () {
    start();

    for (Point a : points)
    for (Point b : points) if (neq(a,b))
    for (Point c : points) if (neq(a,c)&&neq(b,c))
    for (Point d : points) if (neq(a,d)&&neq(b,d)&&neq(c,d)){
        Line ab = getLine(a, b);
        Line cd = getLine(c, d);
        Point m = intersectLines(ab, cd);
        if (integer(m) && check(m)) {
            cout << "Yes" << endl;
            cout << m << endl;
            return 0;
        }
    }
    cout << "No" << endl;
    return 0;
}
