#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(228);

struct pt
{
    int x, y;
};

pt operator - (const pt &a, const pt &b)
{
    return {a.x - b.x, a.y - b.y};
}

ll operator * (const pt &a, const pt &b)
{
    return a.x * (ll) b.y - a.y * (ll) b.x;
}

int gcd(int x, int y)
{
    if (!x || !y)
    {
        return (x | y);
    }
    else
    {
        return __gcd(x, y);
    }
}

pt ok(pt a)
{
    if (a.x < 0 || (a.x == 0 && a.y < 0))
    {
        a.x *= -1;
        a.y *= -1;
    }
    int g = gcd(abs(a.x), abs(a.y));
    a.x /= g, a.y /= g;
    return a;
}

struct line
{
    ll a, b, c;
};

line get(const pt &a, const pt &b)
{
    ll A = b.y - a.y;
    ll B = a.x - b.x;
    ll C = -(A * a.x + B * a.y);
    return {A, B, C};
}

ll det(ll a, ll b, ll c, ll d)
{
    return a * d - b * c;
}

bool bad(ll x)
{
    return abs(x) > 1e6;
}

pt inter(const pt &a, const pt &b, const pt &c, const pt &d)
{
    line A = get(a, b);
    line B = get(c, d);
    ll denum = det(A.a, A.b, B.a, B.b);
    ll x = -det(A.a, A.c, B.a, B.c);
    ll y = -det(A.c, A.b, B.c, B.b);
    swap(x, y);
    if (denum == 0 || x % denum != 0 || y % denum != 0 || bad(x / denum) || bad(y / denum))
    {
        return {(int) -1e9, (int) -1e9};
    }
    else
    {
        return {x / denum, y / denum};
    }
}

const int LIM = 1e6;

struct hsh
{
    ll operator () (const pair <int, int> &a) const
    {
        return (a.first + LIM) * (ll) 2 * LIM + (a.second + LIM);
    }
};

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
   // freopen("a.out", "w", stdout);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n = 2600;
    //cin >> n;
    n *= 2;
    vector <pt> e;
    unordered_set <pair <int, int>, hsh> s;
    for (int i = 0; i < n / 2; i++)
    {
        int x = i, y = 0;
        //cin >> x >> y;
        e.push_back({x, y});
        s.insert({x, y});
    }
    for (int i = 0; i < n / 2; i++)
    {
        int x = i, y = 1000000;
        //cin >> x >> y;
        e.push_back({x, y});
        s.insert({x, y});
    }
    shuffle(e.begin(), e.end(), rnd);// :)
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if (i != j)
            {
                bool bad = false;
                for (int p = 0; p < n; p++)
                {
                    if (p != i && p != j && (e[j] - e[i]) * (e[p] - e[i]) == 0)
                    {
                        bad = true;
                        break;
                    }
                }
                if (bad)
                {
                    continue;
                }
                for (int k = 0; k < n; k++)
                {
                    if (i != k && j != k)
                    {
                        for (int t = 0; t < n; t++)
                        {
                            if (t != i && t != j && t != k)
                            {
                                pt p = inter(e[i], e[j], e[k], e[t]);
                                if (p.x == -1e9 || s.count({p.x, p.y}))
                                {
                                    continue;
                                }
                                s.insert({p.x, p.y});
                                unordered_map <pair <int, int>, int, hsh> cnt;
                                for (int ot = 0; ot < n; ot++)
                                {
                                    pt vt = ok(e[ot] - p);
                                    cnt[{vt.x, vt.y}]++;
                                    if (cnt[{vt.x, vt.y}] > 2 || (int) cnt.size() > n / 2)
                                    {
                                        break;
                                    }
                                }
                                bool bad = false;
                                for (auto c : cnt)
                                {
                                    if (c.second != 2)
                                    {
                                        bad = true;
                                    }
                                }
                                if (!bad)
                                {
                                    cout << "Yes\n";
                                    cout << p.x << ' ' << p.y << '\n';
                                    return 0;
                                }
                            }
                        }
                        break;
                    }
                }
            }
        }
        break;
    }
    cout << "No\n";
}
