#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <math.h>

using namespace std;

class pt
{
public:
    long long x, y;
    int num;
};

class ln
{
public:
    long long a, b, c;
};

class item
{
public:
    ln l;
    pt a, b;
};

void showln(ln l)
{
    cout << l.a << "x + " << l.b << "y + " << l.c << " = 0";
}

void showpt(pt a)
{
    cout << "(" << a.x << ", " << a.y << ") ";
}

ln getln(pt p1, pt p2)
{
    ln l;
    l.a = p1.y - p2.y;
    l.b = p2.x - p1.x;
    l.c = p2.y * p1.x - p2.x * p1.y;
    if (l.a < 0) {
        l.a = -l.a;
        l.b = -l.b;
        l.c = -l.c;
    }
    if (l.a == 0) {
        if (l.b < 0) {
            l.a = -l.a;
            l.b = -l.b;
            l.c = -l.c;
        }
    }
    long long a = abs(l.a), b = abs(l.b), c = abs(l.c), d = 0, y;
    if (a > b) {
        swap(a, b);
    }
    while (a > 0) {
        y = a;
        a = b % a;
        b = y;
        if (a > b) {
            swap(a, b);
        }
    }
    d = b;
    if (d < c) {
        swap(d, c);
    }
    while (c > 0) {
        y = c;
        c = d % c;
        d = y;
        if (d < c) {
            swap(c, d);
        }
    }
    l.a /= d;
    l.b /= d;
    l.c /= d;
    return l;
}

int ptonl(pt p, ln l)
{
    long long t = l.a * p.x + l.b * p.y + l.c;
    if (t == 0) {
        return 0;
    }
    if ((t > 0 && l.b > 0) || (t < 0 && l.b < 0)) {
        return 1;
    }
    return -1;
}

pt inter(ln l1, ln l2)
{
    long long k1 = l1.a * l2.b - l2.a * l1.b;
    long long k2 = l1.b * l2.c - l2.b * l1.c;/*
    showln(l1);
    cout << "   ||   ";
    showln(l2);
    cout << endl;
    cout << k1 << ' ' << k2 << endl;*/
    pt p;
    p.x = 10000000;
    p.y = 10000000;
    if (k1 == 0) {
        return p;
    }
    if (abs(k2) % abs(k1) == 0) {
        p.x = k2 / k1;
        if (abs(p.x) > 1000000) {
            return p;
        }
        if (l1.b == 0 && l2.b == 0) {
            p.x == 10000000;
            return p;
        }
        if (l1.b != 0) {
            long long k3 = l1.a * p.x + l1.c;
            if (abs(k3) % abs(l1.b) == 0) {
                p.y = -k3 / l1.b;
            }
        }
        else {
            long long k3 = l2.a * p.x + l2.c;
            if (abs(k3) % abs(l2.b) == 0) {
                p.y = -k3 / l2.b;
            }
        }
    }
    if (abs(p.x) > 1000000 || abs(p.y) > 1000000) {
        p.x = 10000000;
        p.y = 10000000;
    }
    return p;
}

bool comppt(pt a, pt b)
{
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
}

bool compln(ln a, ln b)
{
    if (a.a != b.a) {
        return a.a < b.a;
    }
    if (a.b != b.b) {
        return a.b < b.b;
    }
    return a.c < b.c;
}

bool compit(item i1, item i2)
{
    return compln(i1.l, i2.l);
}

bool eqlp(pt a, pt b)
{
    return (a.x == b.x) && (a.y == b.y);
}

bool eqlp1(pt a, pt b)
{
    return a.num == b.num;
}

bool eqll(ln a, ln b)
{
    return (a.a == b.a) && (a.b == b.b) && (a.c == b.c);
}

bool compn (item i1, item i2)
{
    return min(i1.a.num, i1.b.num) < min(i2.a.num, i2.b.num);
}

bool compa (item i1, item i2)
{
    ln l1 = i1.l;
    ln l2 = i2.l;
    if (l1.b == 0) {
        return true;
    }
    if (l2.b == 0) {
        return false;
    }
    if (l1.b * l2.b > 0) {
        return l1.a * l2.b >= l2.a * l1.b;
    }
    else {
        return l1.a * l2.b <= l2.a * l1.b;
    }
}

int main()
{
    ifstream fin("input.txt");
    int n;
    fin >> n;
    n *= 2;
    vector<pt> p(n);
    for (int i = 0; i < n; i++) {
        pt pt1;
        fin >> pt1.x >> pt1.y;
        pt1.num = i;
        p[i] = pt1;
    }
    vector<item> ls0;
    vector<item> ls;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            item it;
            it.a = p[i];
            it.b = p[j];
            it.l = getln(it.a, it.b);
            ls0.push_back(it);
        }
    }
    sort(ls0.begin(), ls0.end(), compit);
    /*for (int i = 0; i < ls0.size(); i++) {
        cout << "(" << ls0[i].a.x << ", " << ls0[i].a.y << ") - (";
        cout << ls0[i].b.x << ", " << ls0[i].b.y << "): ";
        cout << ls0[i].l.a << "x + " << ls0[i].l.b << "y + " << ls0[i].l.c << " = 0" <<endl;
    }
    cout << "-" << endl;*/
    int ind = 0;
    while (ind < ls0.size()) {
        int i1 = ind;
        ind++;
        while (ind < ls0.size() && eqll(ls0[i1].l, ls0[ind].l)) {
            ind++;
        }
        if (ind - i1 > 1) {
            continue;
        }
        ls.push_back(ls0[i1]);
    }
    sort(ls.begin(), ls.end(), compn);
    //cout << ls[i].l.a << "x + " << ls[i].l.b << "y + " << ls[i].l.c << " = 0"
    /*for (int i = 0; i < ls.size(); i++) {
        cout << ls[i].a.num << "(" << ls[i].a.x << ", " << ls[i].a.y << ") - " << ls[i].b.num << "(";
        cout << ls[i].b.x << ", " << ls[i].b.y << "): ";
        cout << ls[i].l.a << "x + " << ls[i].l.b << "y + " << ls[i].l.c << " = 0" <<endl;
    }*/
    vector< vector<item> > lnf(n);
    for (int i = 0; i < ls.size(); i++) {
        lnf[ls[i].a.num].push_back(ls[i]);
        //swap(ls[i].a, ls[i].b);
        //lnf[ls[i].b.num].push_back(ls[i]);
    }
    vector< pair<pt, int> > nt;
    for (int i = 0; i < n; i++) {
        sort(lnf[i].begin(), lnf[i].end(), compa);
    }
    for (int i = 0; i < lnf[0].size(); i++) {
        for (int j = 0; j < lnf[1].size(); j++) {
            pt pnt = inter(lnf[0][i].l, lnf[1][j].l);
            if (abs(pnt.x) > 1000000 || abs(pnt.y) > 1000000) {
                continue;
            }
            if (eqlp(pnt, lnf[0][i].a) || eqlp(pnt, lnf[0][i].b) || eqlp(pnt, lnf[1][j].a) || eqlp(pnt, lnf[1][j].b)) {
                continue;
            }
            nt.push_back(pair<pt, int> (pnt, i));
        }
    }
    for (int i = 0; i < nt.size(); i++) {
        pt p0 = nt[i].first;
        bool can = true;
        for (int j = 2; j < n; j++) {
            if (lnf[j].size() == 0) {
                continue;
            }
            int L = 0, R = lnf[j].size() + 1;
            while (R - L > 1) {
                int c = (R + L) / 2;
                if (compa(lnf[j][c], lnf[0][nt[i].second])) {
                    L = c;
                }
                else {
                    R = c;
                }
            }
            int m = L;
            L = 0;
            R = m + 1;
            item it;
            it.l = getln(p[j], p0);
            while (R - L > 1) {
                int c = (R + L) / 2;
                if (compa(lnf[j][c], it)) {
                    L = c;
                }
                else {
                    R = c;
                }
            }
            int l1 = L;
            L = m;
            R = lnf[j].size() + 1;
            while (R - L > 1) {
                int c = (R + L) / 2;
                if (compa(lnf[j][c], it)) {
                    L = c;
                }
                else {
                    R = c;
                }
            }
            int l2 = L;
            if (!ptonl(p0, lnf[j][l1].l) && !ptonl(p0, lnf[j][l2].l)) {
                can = false;
                break;
            }
        }
        if (can) {
            cout << "Yes" << endl;
            cout << p0.x << ' ' << p0.y;
            return 0;
        }
    }
    /*
    int first0 = 0;
    while (first0 < ls.size() && ls[first0].a.num == 0) {
        first0++;
    }
    for (int j = 0; j < first0; j++) {
        if (j >= ls.size()) {
            break;
        }
        nt.clear();
        int n1 = ls[j].a.num, n2 = ls[j].b.num;
        if (n1 != 0 && n2 != 0) {
            break;
        }
        for (int i = first0; i < ls.size(); i++) {
            if (ls[i].a.num != n1 && ls[i].a.num != n2 && ls[i].b.num != n1 && ls[i].b.num != n2) {
                pt pnt = inter(ls[j].l, ls[i].l);
                if (abs(pnt.x) > 1000000 || abs(pnt.y) > 1000000) {
                    continue;
                }
                if (eqlp(pnt, ls[i].a) || eqlp(pnt, ls[i].b) || eqlp(pnt, ls[j].a) || eqlp(pnt, ls[j].b)) {
                    continue;
                }
                nt.push_back(pnt);
            }
        }
        if (nt.size() < n / 2 - 1) {
            continue;
        }
        sort(nt.begin(), nt.end(), comppt);
        int ind = 0;
        while (ind < nt.size()) {
            int i1 = ind;
            ind++;
            while (ind < nt.size() && eqlp(nt[i1], nt[ind])) {
                ind++;
            }
            if (ind - i1 == n / 2 - 1) {
                pt p1 = nt[i1];
                bool can = true;
                if (can) {
                    cout << "Yes" << endl;
                    cout << nt[i1].x << ' ' << nt[i1].y;
                    return 0;
                }
            }
        }
    }*/
    cout << "No";
}
