//#pragma gcc optimize("OFast")
//#pragma target("sse,sse2,sse3,sse4,tune=native")
//#pragma gcc optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 200000 + 100;
const int INF = 1000000000;

vector<int> g[N];
int c[N];

ll ans;

struct subtree
{
	ll sm;
	int mn, sz;

	bool operator<(const subtree &a) const
	{
		return mn < a.mn;
	}
};

subtree dfs(int v)
{
	if (g[v].size() == 0)
	{
		return { c[v], c[v], 1 };
	}

	vector<subtree> vv;
	for (int to : g[v])
	{
		vv.push_back(dfs(to));
	}

	assert(vv.size() > 1);

	sort(all(vv));

	vector<int> mn(vv.size(), INF);

	ll sm = 0;
	int mmn = INF;
	int szsm = 0;

	for (int i = 0; i < vv.size(); i++)
	{
		ans += vv[i].sm;
		sm += vv[i].sm;
		szsm += vv[i].sz;
		mmn = min(mmn, vv[i].mn);
	}

	for (int i = 0; i + 1 < vv.size(); i++)
	{
		mn[i + 1] = min(mn[i + 1], min(vv[i].mn, mn[i]));
	}

	for (int i = (int)vv.size() - 1; i >= 1; i--)
	{
		mn[i - 1] = min(mn[i - 1], min(vv[i].mn, mn[i]));
	}

	int ptr1 = 0, ptr2 = (int)vv.size() - 1;

	while (1)
	{
		if (ptr1 >= ptr2)
		{
			break;
		}
		if (vv[ptr1].sz == vv[ptr2].sz)
		{
			vv[ptr1].sz = 0;
			vv[ptr2].sz = 0;
			++ptr1;
			--ptr2;
		}
		else if (vv[ptr1].sz > vv[ptr2].sz)
		{
			vv[ptr1].sz -= vv[ptr2].sz;
			vv[ptr2].sz = 0;
			--ptr2;
		}
		else
		{
			vv[ptr2].sz -= vv[ptr1].sz;
			vv[ptr1].sz = 0;
			++ptr1;
		}
	}

	for (int i = 0; i < vv.size(); i++)
	{
		ans += (ll)vv[i].sz * (ll)mn[i];
	}

	return { sm + c[v], min(mmn, c[v]), szsm + 1 };
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	for (int i = 1; i < n; i++)
	{
		int x;
		cin >> x;
		g[x - 1].push_back(i);
	}

	for (int i = 1; i < n; i++)
	{
		cin >> c[i];
	}

	dfs(0);

	cout << ans;


#ifdef _DEBUG
	while (1);
#endif
}