#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
using namespace std;

struct point{
    int x, y;
    point(int x1, int y1){
        x = x1;
        y = y1;
    }
    point(){
        x = 0;
        y = 0;
    }
};

void read(point & a){
    cin >> a.x >> a.y;
}

void prt(point a){
    cout << a.x << ' ' << a.y << endl;
}

point operator+(point a, point b){
    return point(a.x + b.x, a.y + b.y);
}

point operator-(point a, point b){
    return point(a.x - b.x, a.y - b.y);
}

struct line{
   int a, b, c;
    line(point a1, point b1){
        point n = b1 - a1;
        n = point(-n.y, n.x);
        a = n.x;
        b = n.y;
        c = -(a1.x * a + a1.y * b);
    }
};

pair<bool, point> gety(line a, int x){
    if ((x * a.a + a.c) % a.b != 0){
        return make_pair(false, point(0, 0));
    }else{
        return make_pair(true, point(x, (x * a.a + a.c) / -a.b));
    }
}

pair<bool, point> getx(line a, int y){
    if ((y * a.b + a.c) % a.a != 0){
        return make_pair(false, point(0, 0));
    }else{
        return make_pair(true, point((y * a.b + a.c) / -a.a, y));
    }
}

pair<bool, point> lineintersect(line a, line b){
    if (a.a == 0 && b.a == 0){
        return make_pair(false, point(0, 0));
    }
    if (a.b == 0 && b.b == 0){
        return make_pair(false, point(0, 0));
    }
    if (a.a == 0){
        if (-a.c % a.b == 0){
            return getx(b, -a.c / a.b);
        }
        return make_pair(false, point(0, 0));
    }
    if (a.b == 0){
        if (-a.c % a.a == 0){
            return gety(b, -a.c / a.a);
        }
        return make_pair(false, point(0, 0));
    }
    if (b.a == 0){
        if (-b.c % b.b == 0){
            return getx(a, -b.c / b.b);
        }
        return make_pair(false, point(0, 0));
    }
    if (b.b == 0){
        if (-b.c % b.a == 0){
            return gety(a, -b.c / b.a);
        }
        return make_pair(false, point(0, 0));
    }
    if (a.a / b.a == a.b / b.b){
        return make_pair(false, point(0, 0));
    }
    if (-(a.a * b.c + a.c * b.a) % (a.a * b.b - a.b * b.a) == 0){
        int y = -(a.a * b.c + a.c * b.a) / (a.a * b.b - a.b * b.a);
        if (getx(a, y).first){
            return getx(a, y);
        }
    }
    return make_pair(false, point(0, 0));
}

bool operator == (point a, point b){
    return a.x == b.x && a.y == b.y;
}

bool good(point a, point b, point c, point d, point e){
    return !(a == b || a == c || a == d || a == e);
}

int main()
{
    int n;
    cin >> n;
    if (n == 3){
        cout << "Yes" << endl;
        cout << "2 2" << endl;
        return 0;
    }
    point a, b, c, d;
    read(a);
    read(b);
    read(c);
    read(d);
    pair<bool, point> cur;
    cur = lineintersect(line(a, b), line(c, d));
    if (cur.first && good(cur.second, a, b, c, d)){
        cout << "Yes" << endl;
        prt(cur.second);
        return 0;
    }
    cur = lineintersect(line(a, c), line(b, d));
    if (cur.first && good(cur.second, a, b, c, d)){
        cout << "Yes" << endl;
        prt(cur.second);
        return 0;
    }
    cur = lineintersect(line(a, d), line(c, b));
    if (cur.first && good(cur.second, a, b, c, d)){
        cout << "Yes" << endl;
        prt(cur.second);
        return 0;
    }
    cout << "No" << endl;
    return 0;
}
