#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
using namespace std;

struct poll{
    ll x, y;
    poll(ll x1, ll y1){
        x = x1;
        y = y1;
    }
    poll(){
        x = 0;
        y = 0;
    }
};

void read(poll & a){
    cin >> a.x >> a.y;
}

void prt(poll a){
    cout << a.x << ' ' << a.y << endl;
}

poll operator+(poll a, poll b){
    return poll(a.x + b.x, a.y + b.y);
}

poll operator-(poll a, poll b){
    return poll(a.x - b.x, a.y - b.y);
}

struct line{
   ll a, b, c;
    line(poll a1, poll b1){
        poll n = b1 - a1;
        n = poll(-n.y, n.x);
        a = n.x;
        b = n.y;
        c = -(a1.x * a + a1.y * b);
    }
};

pair<bool, poll> gety(line a, ll x){
    if ((x * a.a + a.c) % a.b != 0){
        return make_pair(false, poll(0, 0));
    }else{
        return make_pair(true, poll(x, (x * a.a + a.c) / -a.b));
    }
}

pair<bool, poll> getx(line a, ll y){
    if ((y * a.b + a.c) % a.a != 0){
        return make_pair(false, poll(0, 0));
    }else{
        return make_pair(true, poll((y * a.b + a.c) / -a.a, y));
    }
}

pair<bool, poll> linellersect(line a, line b){
    if (a.a == 0 && b.a == 0){
        return make_pair(false, poll(0, 0));
    }
    if (a.b == 0 && b.b == 0){
        return make_pair(false, poll(0, 0));
    }
    if (a.a == 0){
        if (-a.c % a.b == 0){
            return getx(b, -a.c / a.b);
        }
        return make_pair(false, poll(0, 0));
    }
    if (a.b == 0){
        if (-a.c % a.a == 0){
            return gety(b, -a.c / a.a);
        }
        return make_pair(false, poll(0, 0));
    }
    if (b.a == 0){
        if (-b.c % b.b == 0){
            return getx(a, -b.c / b.b);
        }
        return make_pair(false, poll(0, 0));
    }
    if (b.b == 0){
        if (-b.c % b.a == 0){
            return gety(a, -b.c / b.a);
        }
        return make_pair(false, poll(0, 0));
    }
    if (a.a / b.a == a.b / b.b){
        return make_pair(false, poll(0, 0));
    }
    if (-(a.a * b.c + a.c * b.a) % (a.a * b.b - a.b * b.a) == 0){
        ll y = -(a.a * b.c + a.c * b.a) / (a.a * b.b - a.b * b.a);
        if (getx(a, y).first){
            return getx(a, y);
        }
    }
    return make_pair(false, poll(0, 0));
}

bool operator == (poll a, poll b){
    return a.x == b.x && a.y == b.y;
}

bool good(poll a, poll b, poll c, poll d, poll e){
    return !(a == b || a == c || a == d || a == e);
}

int main()
{
    ll n;
    cin >> n;
    if (n == 3){
        cout << "Yes" << endl;
        cout << "2 2" << endl;
        return 0;
    }
    poll a, b, c, d;
    read(a);
    read(b);
    read(c);
    read(d);
    pair<bool, poll> cur;
    cur = linellersect(line(a, b), line(c, d));
    if (cur.first && good(cur.second, a, b, c, d)){
        cout << "Yes" << endl;
        prt(cur.second);
        return 0;
    }
    cur = linellersect(line(a, c), line(b, d));
    if (cur.first && good(cur.second, a, b, c, d)){
        cout << "Yes" << endl;
        prt(cur.second);
        return 0;
    }
    cur = linellersect(line(a, d), line(c, b));
    if (cur.first && good(cur.second, a, b, c, d)){
        cout << "Yes" << endl;
        prt(cur.second);
        return 0;
    }
    cout << "No" << endl;
    return 0;
}
