#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <cstring>
#include <queue>
#pragma GCC optimize("Ofast")
typedef long long ll;
typedef long double ld;
using namespace std;

const int N = 5201;

ll gcd(ll x, ll y) {
    return y ? gcd(y, x % y) : x;
}

struct pt {
    ll x, y;
    pt() : x(0), y(0) {}
    pt(ll x, ll y) : x(x), y(y) {}

    pt operator-(pt p) {
        return {x - p.x, y - p.y};
    }
    pt operator+(pt p) {
        return {x + p.x, y + p.y};
    }
    ll operator*(pt p) {
        return x * p.y - y * p.x;
    }
    ll s(pt p1, pt p2) {
        return (p1 - *this) * (p2 - *this);
    }
    bool operator<(const pt &p) const {
        return tie(x, y) < tie(p.x, p.y);
    }
};
pt a[N];
set<pt> s, q, q1;

void add(pt a1, pt b1, pt a2, pt b2) {
    ll s1 = a1.s(a2, b2), s2 = s1 - b1.s(a2, b2);
    if (s2 == 0)
        return;
    pt v = {(b1.x - a1.x) * s1, (b1.y - a1.y) * s1};
    if (v.x % s2 == 0 && v.y % s2 == 0) {
        pt p = a1 + pt(v.x / s2, v.y / s2);
        if (!s.count(p))
            q.insert(p);
    }
}

vector<ll> num(pt p1, pt p2) {
    vector<ll> ans = {p2.y - p1.y, p1.x - p2.x, p1.x * p2.y - p1.y * p2.x};
    ll g = gcd(gcd(abs(ans[0]), abs(ans[1])), abs(ans[2]));
    assert(g != 0);
    if (ans[2] < 0)
        g = -g;
    return {ans[0] / g, ans[1] / g, ans[2] / g};
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n;
    scanf("%d", &n);
    n *= 2;
    for (int i = 0; i < n; i++) {
        scanf("%lld%lld", &a[i].x, &a[i].y);
        s.insert(a[i]);
    }
    for (int k = 0; k < 2; k++) {
        for (int i = 2; i < n; i++) {
            for (int j = 2; j < n; j++) {
                if (i != j)
                    add(a[0], a[i], a[1], a[j]);
            }
        }
        swap(a[1], a[2]);
    }
    /*for (pt p : q) {
        cout << p.x << ' ' << p.y << '\n';
    }*/
    set<vector<ll>> ln;
    for (int i = 0; i < min(n, 10); i++) {
        q1.clear();
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            for (pt p : q)
                if (p.s(a[i], a[j]) == 0)
                    q1.insert(p);
        }
        q = q1;
    }
    /*for (pt p : q) {
        cout << p.x << ' ' << p.y << "!\n";
    }*/
    map<pt, int> mp;
    vector<pair<pt, pt>> lines;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < i; j++) {
            vector<ll> h = num(a[i], a[j]);
            if (!ln.count(h)) {
                ln.insert(h);
                lines.push_back({a[i], a[j]});
            }
        }
    for (pt p : q) {
        int ir = 0;
        for (auto pp : lines)
            if (p.s(pp.first, pp.second) == 0)
                ir++;
        if (ir == n / 2) {
            printf("Yes\n%lld %lld", p.x, p.y);
            return 0;
        }
    }
    /*for (auto pp : mp) {
        if (pp.second == n / 2 && abs(pp.first.x) <= 1000000 && abs(pp.first.y) <= 1000000) {
            printf("Yes\n%lld %lld", pp.first.x, pp.first.y);
            return 0;
        }
    }*/
    printf("No");
}
