#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

int alph = 26;

const int mod = 1000000007;

int hashed(vector <int> arr) {
    int64_t hashsh = 0;
    for (int i = 0; i < arr.size(); ++i) {
        hashsh *= 37;
        hashsh += arr[i];
        hashsh %= mod;
    }
    return hashsh;
}

unordered_set <int> mapa;
vector <int> cnt;

bool check(int sz, int n) {
    int k = sz / n;
    for (auto & x : cnt)
        x /= k;
    int need = hashed(cnt);
    int now = need;
    for (int i = 1; i <= k; ++i) {
        if (!mapa.count(now)) {
            for (auto & x : cnt)
                x *= k;
            return false;
        }
        now += need;
        now = (now >= mod ? now - mod : now);
    }
    for (auto & x : cnt)
        x *= k;
    return true;
}

int gcd(int a, int b) {
    while (b > 0) {
        int c = a % b;
        a = b;
        b = c;
    }
    return a;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    int n = s.size();
    bool flag = true;
    vector <int> pow(alph);
    pow[0] = 1;
    for (int i = 1; i < pow.size(); ++i)
    {
        pow[i] = ((long long)pow[i - 1] * 37) % mod;
    }
    for (auto c : s)
        if (c != 'a' && c != 'b')
            flag = false;
    if (flag)
        alph = 2;
    cnt.resize(alph);
    int hashn = 0;
    int it = 1;
    for (auto c : s) {
        cnt[c - 'a']++;
        hashn += pow[alph - 1 - (c - 'a')];
        hashn = (hashn >= mod ? hashn - mod : hashn);
        if (gcd(it, n) != 1)
            mapa.insert(hashn);
        it++;
    }
    int a = n;
    for (auto x : cnt) {
        a = __gcd(a, x);
    }
    int cntt = 0;
    for (auto x : cnt)
        cntt += (x != 0);
    if (cntt == 1) {
        cout << n << endl;
        return 0;
    }
    int p = 1;
    int ans = 1;
    while (p * p <= a) {
        if (a % p == 0) {
            if (check(s.size(), n / p)) {
                ans = max(ans, p);
            }
            if (p * p != a) {
                if (check(s.size(), n / (a / p))) {
                    ans = max(ans, a / p);
                    break;
                }
            }
        }
        ++p;
    }
    cout << ans << endl;
    return 0;
}
