#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<string>
#include<cmath>
#include<ctime>
#include<stack>
#include<functional>
#include<queue>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const ld e = 1e-7;
const ll mod = 1e9 + 7;
const ll gr = 1e6;

ll gcd(ll a, ll b) {
	return ((b) ? gcd(b, a % b) : a);
}


class point {
public:
	ll x, y;
	point()
		:x()
		, y()
	{}
	point(ll x, ll y)
		:x(x)
		, y(y)
	{}
	point operator +(point &a) {
		return { x + a.x, y + a.y };
	}
	point operator -(point &a) {
		return { x - a.x, y - a.y };
	}
	point operator *(ll z) {
		return { x * z, y * z };
	}
	point operator /(ll z) {
		return { x / z, y / z };
	}
	void operator+=(point &a) {
		x += a.x, y += a.y;
	}
	void operator-=(point &a) {
		x -= a.x, y -= a.y;
	}
	void operator*=(ll z) {
		x *= z, y *= z;
	}
	void operator/=(ll z) {
		x /= z, y /= z;
	}
	void norm() {
		ll d = gcd(llabs(x), llabs(y));
		x /= d;
		y /= d;
	}
	bool operator!=(point &a) {
		return (a.x != x || a.y != y);
	}
	bool operator==(point &a) {
		return (a.x == x && a.y == y);
	}
	bool ass(point &a) {
		return ((x == a.x && y == a.y) || (x == -a.x && y == -a.y));
	}
	void reav() {
		x = -x, y = -y;
	}
};

class line {
public:
	point t1, t2;
	line()
		:t1()
		, t2()
	{}
	line(point t1, point t2)
		:t1(t1)
		,t2(t2)
	{}
	ll get_A() {
		return t1.y - t2.y;
	}
	ll get_B() {
		return t2.x - t1.x;
	}
	ll get_C() {
		return -(t1.x * get_A() + t1.y * get_B());
	}
	bool intersect(line &a) {
		ll del = get_A() * a.get_B() - get_B() * a.get_A();
		if (del == 0)
			return false;
		ll x = a.get_C() * get_B() - get_C() * a.get_B(), y = a.get_C() * get_A() - get_C() * a.get_A();
		if (x % del != 0 || y % del != 0)
			return false;
		return true;
	}
	point inter(line &a) {
		ll x = a.get_C() * get_B() - get_C() * a.get_B(), y = a.get_C() * get_A() - get_C() * a.get_A();
		ll del = get_A() * a.get_B() - get_B() * a.get_A();
		return { x / del, -y / del };
	}
};


int main() {
	ios_base::sync_with_stdio(false);
	ll n;
	cin >> n;
	vector<point> t(2 * n);
	for (int i = 0; i < 2 * n; ++i) {
		cin >> t[i].x >> t[i].y;
	}





	for (int i = 2; i < 2 * n; ++i) {
		for (int j = 2; j < 2 * n; ++j) {
			if (i != j) {
				line deb1 = { t[0], t[i] };
				line deb2 = { t[1], t[j] };
				if (deb1.intersect(deb2)) {
					point c = deb1.inter(deb2);
					bool fl = true;
					unordered_map<ll, ll> cnt;
					for (int k = 0; k < 2 * n; ++k) {
						if (c == t[k]) {
							fl = false;
							break;
						}
						point pip = c - t[k];
						pip.norm();
						if (pip.y < 0 || pip.y == 0 && pip.x < 0) {
							pip.reav();
						}
						++cnt[pip.x * gr + pip.y];
						if (cnt[pip.x * gr + pip.y] > 2) {
							fl = false;
							break;
						}
					}
					if (fl) {
						for (auto i = cnt.begin(); i != cnt.end(); ++i)
							if (i->second != 2) {
								fl = false;
								break;
							}
						if (fl) {
							cout << "Yes\n" << c.x << ' ' << c.y;
							return 0;
						}
					}
				}
			}
		}
	}
	cout << "No";
	/*if (n <= 100) {
		for (int i = 1; i < 2 * n; ++i) {
			line deb1 = { t[0], t[i] };
			unordered_map<ll, ll> cnt;
			bool fl;
			for (int j = 1; j < 2 * n; ++j) {
				
			}
		}
	}
	vector<ll> used(2 * n);
	vector<point> answers;
	for (int i = 1; i < 2 * n; ++i) {
		if (!used[i]) {
			point pip = t[i] - t[0];
			pip.norm();
			for (int j = i + 1; j < 2 * n; ++j) {
				point fal = t[j] - t[0];
				fal.norm();
				if (fal.ass(pip)) {
					used[i] = used[j] = 1;
					break;
				}
			}
			if (!used[i]) {
				point up = t[0] + pip;
				while (up.x <= gr && up.x >= -gr && up.y <= gr && up.y >= -gr) {
					if (up != t[i]) {
						answers.push_back(up);
					}
					up += pip;
				}
				up = t[0] - pip;
				while (up.x <= gr && up.x >= -gr && up.y <= gr && up.y >= -gr) {
					if (up != t[i]) {
						answers.push_back(up);
					}
					up -= pip;
				}
			}
		}
	}
	for (int q = 0; q < answers.size(); ++q) {
		point c = answers[q];
		bool fl = true;
		unordered_map<ll, ll> cnt;
		for (int i = 0; i < 2 * n; ++i) {
			point pip = c - t[i];
			pip.norm();
			if (pip.y < 0 || pip.y == 0 && pip.x < 0) {
				pip.reav();
			}
				
			cnt[pip.x * gr + pip.y]++;
			if (cnt[pip.x * gr + pip.y] > 2) {
				fl = false;
				break;
			}
		}
		if (fl) {
			for (auto i = cnt.begin(); i != cnt.end(); ++i)
				if (i->second != 2) {
					fl = false;
					break;
				}
			if (fl) {
				cout << "Yes\n" << c.x << ' ' << c.y;
				return 0;
			}
		}
	}
	cout << "No";*/
	return 0;
}