#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e6;

struct point
{
	ll x, y;

	point() {};

	point(ll nx, ll ny) : x(nx), y(ny) {};

	point operator - (point p)
	{
		return point(x - p.x, y - p.y);
	}

	point operator + (point p)
	{
		return point(x + p.x, y + p.y);
	}

	ll operator * (point p)
	{
		return x * p.x + y * p.y;
	}

	ll operator % (point p)
	{
		return x * p.y - y * p.x;
	}

	ll sqrlen()
	{
		return x * x + y * y;
	}

	dl len()
	{
		return sqrt(sqrlen());
	}

	void turn()
	{
		swap(x, y);
		x *= (-1);
	}
};

struct line
{
	ll a, b, c;
	ll n1, n2;

	line() {};

	line(point p1, point p2, ll in1, ll in2)
	{
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = p2.y * p1.x - p1.y * p2.x;

		n1 = in1;
		n2 = in2;
	}
};

ll sign(ll a)
{
	if (a > 0)
		return 1;

	if (a < 0)
		return -1;

	return 0;
}

bool inters(line l1, line l2, point &res)
{
	if (l1.a * l2.b - l2.a * l1.b == 0)
		return false;

	res.x = (l1.b * l2.c - l1.c * l2.b) / (l1.a * l2.b - l2.a * l1.b);
	res.y = (l2.c * l1.a - l2.a * l1.c) / (l2.a * l1.b - l2.b * l1.a);

	if (abs(l1.b * l2.c - l1.c * l2.b) % abs(l1.a * l2.b - l2.a * l1.b) == 0 &&
		abs(l2.c * l1.a - l2.a * l1.c) % abs(l2.a * l1.b - l2.b * l1.a) == 0)
	{
		return 1;
	}
	return 0;
}

bool operator < (point p1, point p2)
{
	if (p1.x == p2.x)
		return p1.y < p2.y;
	return p1.x < p2.x;
}

int main()
{
   // freopen("inputB.txt", "r", stdin);
    //freopen("outputB.txt", "w", stdout);
	ll n;
	cin >> n;

	vector<point> vp(2 * n);

	map<point, ll> bad;

	for (ll i = 0; i < 2 * n; ++i)
	{
		cin >> vp[i].x >> vp[i].y;
		bad[vp[i]] = 1;
	}
	
	vector<line> vl;

	for (ll i = 0; i < 2 * n; ++i)
	{
		for (ll j = i + 1; j < 2 * n; ++j)
		{
			vl.push_back(line(vp[i], vp[j], i, j));
		}
	}

	map<point, set<ll>> mapp;
	for (ll i = 0; i < vl.size(); ++i)
	{
		for (ll j = i + 1; j < vl.size(); ++j)
		{
			point intr;

			if (inters(vl[i], vl[j], intr) && bad[intr] == 0 && abs(intr.x) <= inf && abs(intr.y) <= inf)
			{
				mapp[intr].insert(vl[i].n1);
				mapp[intr].insert(vl[i].n2);

				mapp[intr].insert(vl[j].n1);
				mapp[intr].insert(vl[j].n2);
			}
		}
	}

	vector<point> con;

	for (auto iter : mapp)
	{
		point p = iter.first;

		if (iter.second.size() == 2 * n)
		{
			con.push_back(p);
		}
	}

	if (con.size() == 0)
	{
		puts("No");
	}
	else
	{
		puts("Yes");
		
		cout << con[0].x << " " << con[0].y << endl;
		return 0;
	}
    return 0;
}

