//double
#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()
#define int ll

struct IPoint {
    int x;
    int y;

    IPoint() {
        x = 0;
        y = 0;
    }

    IPoint(int _x, int _y) {
        x = _x;
        y = _y;
    }

    IPoint operator+(const IPoint& s) const {
        return IPoint(x + s.x, y + s.y);
    }

    IPoint operator-(const IPoint& s) const {
        return IPoint(x - s.x, y - s.y);
    }

    IPoint operator*(int k) const {
        return IPoint(x * k, y * k);
    }

    IPoint operator/(int k) const {
        return IPoint(x / k, y / k);
    }

    friend ostream& operator<<(ostream& out, const IPoint& p) {
        out << p.x << " " << p.y;
        return out;
    }

    //cos
    int operator*(const IPoint& s) const {
        return x * s.x + y * s.y;
    }

    //sin
    int operator/(const IPoint& s) const {
        return x * s.y - y * s.x;
    }

    int abs() {
        return x * x + y * y;
    }
};

typedef double val;

struct Point {
    val x;
    val y;

    Point() {
        x = 0;
        y = 0;
    }

    Point(val _x, val _y) {
        x = _x;
        y = _y;
    }

    Point(IPoint v) {
        x = v.x;
        y = v.y;
    }

    Point operator+(const Point& s) const {
        return Point(x + s.x, y + s.y);
    }

    Point operator-(const Point& s) const {
        return Point(x - s.x, y - s.y);
    }

    Point operator*(val k) const {
        return Point(x * k, y * k);
    }

    Point operator/(val k) const {
        return Point(x / k, y / k);
    }

    friend ostream& operator<<(ostream& out, const Point& p) {
        out << p.x << " " << p.y;
        return out;
    }

    //cos
    val operator*(const Point& s) const {
        return x * s.x + y * s.y;
    }

    //sin
    val operator/(const Point& s) const {
        return x * s.y - y * s.x;
    }

    val abs() {
        return x * x + y * y;
    }
};

int n;
vector<IPoint> arr;

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

const double smk = 2e6;

pair<IPoint, bool> intersect(IPoint aa, IPoint bb, IPoint cc, IPoint dd) {
    Point a(aa);
    Point b(bb);
    Point c(cc);
    Point d(dd);
    val ky = (b.y - a.y);
    val kx = (b.x - a.x);
    a = a - Point(kx * smk, ky * smk);
    b = b + Point(kx * smk, ky * smk);
    ky = (d.y - c.y);
    kx = (d.x - c.x);
    c = c - Point(kx * smk, ky * smk);
    d = d + Point(kx * smk, ky * smk);
    val s = abs((a - d) / (c - d));
    val ss = abs((b - d) / (c - d));
    if (s + ss == 0) {
        return { IPoint(0, 0), false };
    }
    Point p = a + (b - a) * (s / (s + ss));
    IPoint ip(p.x, p.y);
    fors(i, -5, 6) {
        fors(j, -5, 6) {
            IPoint t = ip + IPoint(i, j);
            if ((bb.y - aa.y) * (t.x - aa.x) == (bb.x - aa.x) * (t.y - aa.y) &&
                (dd.y - cc.y) * (t.x - cc.x) == (dd.x - cc.x) * (t.y - cc.y)) {
                return { t, true };
            }
        }
    }
    return { ip, false };
}

int sign(int i) {
    return (i > 0 ? 1 : (i < 0 ? -1 : 0));
}

pair<IPoint, bool> check(int i, int j) {
    auto r = intersect(arr[0], arr[i], arr[1], arr[j]);
    if (!r.second) {
        return r;
    }
    map<pair<int, pair<int, int>>, vector<int>> m;
    forn(i, n) {
        Point a = (arr[i] - r.first);
        int g = gcd(abs(a.x), abs(a.y));
        int s = sign(a.x) * sign(a.y);
        a.x = abs(a.x);
        a.y = abs(a.y);
        if (g) {
            a.x /= g;
            a.y /= g;
        }
        if (a.x == 0 && a.y == 0) {
            r.second = false;
            return r;
        }
        m[{s, { a.x, a.y }}].push_back(i);
    }
    for (auto i : m) {
        if (i.second.size() != 2) {
            r.second = false;
            return r;
        }
    }
    return r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    n *= 2;
    arr.resize(n);
    forn(i, n) {
        cin >> arr[i].x >> arr[i].y;
    }
    fors(i, 2, n) {
        fors(j, 2, n) {
            if (i == j) continue;
            auto v = check(i, j);
            if (v.second) {
                cout << "Yes" << endl;
                cout << v.first << endl;
                return 0;
            }
        }
    }
    auto t = arr[1];
    arr[1] = arr[2];
    arr[2] = t;
    fors(i, 2, n) {
        fors(j, 2, n) {
            if (i == j) continue;
            auto v = check(i, j);
            if (v.second) {
                cout << "Yes" << endl;
                cout << v.first << endl;
                return 0;
            }
        }
    }
    cout << "No" << endl;
#ifdef _MSC_VER
    system("pause");
#endif
    return 0;
}