#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

//const int HP = 3;
const int HP = 3;
const int RALPH = 30;

int MOD[HP] = { 1000000007, 1000099999, 1000097179 };
int P[HP] = { 199457, 197957, 197257 };
//int MOD[HP] = { 1000099999, 1000097179 };
//int P[HP] = { 157, 257 };
int POW[HP][RALPH];

struct Hash {
    int val[HP];

    Hash() {
        for (int i = 0; i < HP; ++i)
            val[i] = 0;
    }

    Hash(Hash& ot) {
        for (int i = 0; i < HP; ++i)
            val[i] = ot.val[i];
    }

    void operator+= (char c) {
        for (int i = 0; i < HP; ++i) {
            val[i] += POW[i][c - 'a'];
            if (val[i] >= MOD[i])
                val[i] -= MOD[i];
        }
    }

    bool operator== (Hash other) {
        for (int i = 0; i < HP; ++i)
            if (val[i] != other.val[i])
                return false;
        return true;
    }

    Hash operator+ (Hash other) {
        Hash res;
        for (int i = 0; i < HP; ++i) {
            res.val[i] = val[i] + other.val[i];
            if (res.val[i] >= MOD[i])
                res.val[i] -= MOD[i];
        }
        return res;
    }
};

const int MAXN = 5e6 + 1;

Hash hack[MAXN];

int main() {
    for (int i = 0; i < HP; ++i) {
        POW[i][0] = 1;
        for (int j = 1; j < RALPH; ++j) {
            POW[i][j] = ((ll)POW[i][j - 1] * (ll)P[i]) % (ll)MOD[i];
        }
    }
    string s;
    cin >> s;
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        hack[i + 1] = hack[i];
        hack[i + 1] += s[i];
    }
    //Hash a;
    //a = hack[3] + hack[3];
    for (int i = 1; i <= n; ++i) {
        if (n % i) continue;
        bool retarded = false;
        for (int j = i; j <= n; j += i) {
            if (!(hack[i] + hack[j - i] == hack[j])) {
                retarded = true;
                break;
            }
        }
        if (!retarded) {
            cout << n / i << '\n';
            return 0;
        }
    }
}

