#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 7;
//  ,  257 --- .

const ll INF = 1e18;

vector<int> g[MAXN];
ll d[MAXN];
int sz[MAXN];
ll sum[MAXN];
ll prv[MAXN];

ll res = 0;

void DFS(int v) {
    if (g[v].size() == 0) {
        sum[v] = prv[v];
        d[v] = prv[v];
        sz[v] = 1;
        return;
    }
    sum[v] = 0;
    d[v] = INF;
    sz[v] = 0;
    for (int u : g[v]) {
        DFS(u);
        chkmin(d[v], d[u]);
        sz[v] += sz[u];
        sum[v] += sum[u];
    }
    int candu = -1;
    for (int u : g[v])
        if (sz[u] > sz[v] / 2)
            candu = u;
    if (candu == -1) {
        res += sum[v] + d[v] * (sz[v] % 2);
    } else {
        ll candy = INF;
        for (int u : g[v])
            if (candy > d[u] && u != candu)
                candy = d[u];
        res += sum[v] + candy * (2 * sz[candu] - sz[v]);
    }
    chkmin(d[v], prv[v]);
    ++sz[v];
    sum[v] += prv[v];
}

int main() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> prv[i];
    }
    DFS(0);
    cout << res << '\n';
}

