#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
//  , 179 ---  .

struct Point {
    ll x, y;
    
    Point(ll x, ll y) : x(x), y(y) {}
    Point() : x(0), y(0) {}

    Point operator+ (Point ot) {
        if (ot == Point(INF, INF) || *this == Point(INF, INF))
            return Point(INF, INF);
        return Point(x + ot.x, y + ot.y);
    }

    Point operator- () {
        return Point(-x, -y);
    }

    Point operator- (Point ot) {
        return *this + (-ot);
    }

    ll operator% (Point ot) {
        return x * ot.y - y * ot.x;
    }

    ll operator* (Point ot) {
        return x * ot.x + y * ot.y;
    }

    Point operator* (ll d) {
        return Point(x * d, y * d);
    }

    Point operator/ (ll d) {
        if (x % d || y % d)
            return Point(INF, INF);
        return Point(x / d, y / d);
    }

    ll len() {
        return x * x + y * y;
    }

    bool operator== (Point ot) {
        return ot.x == x && ot.y == y;
    }

    bool operator!= (Point ot) {
        return !(*this == ot);
    }
};

bool operator< (Point a, Point b) {
    return a.len() < b.len();
}

bool operator > (Point a, Point b) {
    return b < a;
}

Point operator* (ll d, Point p) {
    return p * d;
}

istream& operator>> (istream& fin, Point& p) {
    return fin >> p.x >> p.y;
}

ostream& operator<< (ostream& fout, Point p) {
    return fout << p.x << ' ' << p.y;
}

Point Intersect(Point a, Point b, Point c, Point d) {
    // AC & BD
    if ((c - a) % (d - b) == 0) {
        return Point(INF, INF);
    }
    return a + ((c - a) * ((b - a) % (d - b))) / ((c - a) % (d - b));
}

const int MAXN = 2695;

Point puent[MAXN];
Point ans;

bool Less(Point a, Point b) {
    if (a.y * b.y <= 0) {
        if ((a.y > 0 || a.y == 0 && a.x > 0) && (b.y < 0 || b.y == 0 && b.x < 0))
            return true;
        swap(a, b);
        if ((a.y > 0 || a.y == 0 && a.x > 0) && (b.y < 0 || b.y == 0 && b.x < 0))
            return false;
        swap(a, b);
        assert(a.x * b.x > 0);
        return abs(a.x) < abs(b.x);
    }
    return a % b > 0 || a % b == 0 && a < b;
}

int t = 0;
int used[MAXN];

int main() {
    int n;
    cin >> n;
    n = 2 * n;
    for (int i = 0; i < n; ++i) {
        cin >> puent[i];
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < 3; ++j) {
            for (int k = 1; k < n; ++k) {
                if (i == j) break;
                if (j == k) continue;
                if (i == k) continue;
                ans = Intersect(puent[0], puent[j], puent[i], puent[k]);
                if (abs(ans.x) > 1e6 || abs(ans.y) > 1e6) continue;
                if (ans == Point(INF, INF)) continue;
                if ((ans - puent[0]) % (ans - puent[i])) continue;
                if ((ans - puent[j]) % (ans - puent[k])) continue;
                if (ans == puent[0] || ans == puent[i]) continue;
                if (ans == puent[j] || ans == puent[k]) continue;
                ++t;
                vector<Point> pull;
                for (int q = 1; q < n; ++q) {
                    if (q == i || q == j || q == k) continue;
                    pull.push_back(puent[q] - ans);
                }
                sort(pull.begin(), pull.end(), Less);
                int m = pull.size();
                assert(m == n - 4);
                bool cul = true;
                for (int q = 0; q < 3 * m; ++q) {
                    pull.push_back(pull[q]);
                    if (pull[q] == Point()) {
                        cul = false;
                        break;
                    }
                }
                int w = 0;
                for (int q = 0; q < m; ++q) {
                    if (used[q % m] == t) continue;
                    while (w < 2 * m && (pull[q] % pull[w] > 0 || pull[q] % pull[w] == 0 && pull[q] * pull[w] > 0)) ++w;
                    if (w > 2 * m && pull[q] % pull[w] == 0) {
                        if (pull[w] == pull[q]) {
                            cul = false;
                            break;
                        }
                        if (pull[w] % pull[w + 1] == 0 && pull[w + 1] != pull[q]) {
                            cul = false;
                            break;
                        }
                        if (pull[q] % pull[q + 1] == 0 && pull[w] != pull[q + 1]) {
                            cul = false;
                            break;
                        }
                        used[q] = t;
                        used[w >= m ? w - m : w] = t;
                        continue;
                    }
                    if (pull[q] % pull[q + 1]) {
                        cul = false;
                        break;
                    }
                    if (pull[q] % pull[q + 2] == 0 && pull[q] != pull[q + 2]) {
                        cul = false;
                        break;
                    }
                    used[q] = t;
                    used[q + 1 == m ? 0 : q + 1] = t;
                }
                if (cul) {
                    cout << "Yes\n";
                    cout << ans << '\n';
                    return 0;
                }
            }
        }
    }
    cout << "No\n";
    //assert(puent[0] == Point(1, 1) || puent[1] == Point(1, 1));
}

