#include <unordered_map>
#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
//  , 179 ---  .

ll gcd(ll x, ll y) {
    while (y) {
        x %= y;
        swap(x, y);
    }
    return x;
}

struct Point {
    ll x, y;
    
    Point(ll x, ll y) : x(x), y(y) {}
    Point() : x(0), y(0) {}

    Point operator+ (Point ot) {
        return Point(x + ot.x, y + ot.y);
    }

    Point operator- () {
        return Point(-x, -y);
    }

    Point operator- (Point ot) {
        return *this + (-ot);
    }

    ll operator% (Point ot) {
        return x * ot.y - y * ot.x;
    }

    ll operator* (Point ot) {
        return x * ot.x + y * ot.y;
    }

    Point operator* (ll d) {
        return Point(x * d, y * d);
    }

    Point operator/ (ll d) {
        if (x % d || y % d)
            return Point(INF, INF);
        return Point(x / d, y / d);
    }

    ll len() {
        return x * x + y * y;
    }

    bool operator== (Point ot) {
        return ot.x == x && ot.y == y;
    }

    bool operator!= (Point ot) {
        return !(*this == ot);
    }

    Point norm() {
        ll x1 = x / gcd(x, y);
        ll y1 = y / gcd(x, y);
        if (x1 < 0 || x1 == 0 && y1 < 0)
            return Point(-x1, -y1);
        return Point(x1, y1);
    }
};

bool operator== (Point const& a, Point const& b) {
    return a.x == b.x && a.y == b.y;
}

bool operator!= (Point const& a, Point const& b) {
    return a.x != b.x || a.y != b.y;
}

class PointHash {
public:
    ll operator() (Point const& p) const {
        return (p.x + 1000000) * 10000000 + p.y + 1000000;
    }
};

bool Sign(Point p) {
    //assert(p != Point());
    return p.y > 0 || p.y == 0 && p.x > 0;
}

bool operator< (Point a, Point b) {
    if (!Sign(a)) a = -a;
    if (!Sign(b)) b = -b;
    return a % b > 0;
}

bool operator> (Point a, Point b) {
    return b < a;
}

Point operator* (ll d, Point p) {
    return p * d;
}

istream& operator>> (istream& fin, Point& p) {
    return fin >> p.x >> p.y;
}

ostream& operator<< (ostream& fout, Point p) {
    return fout << p.x << ' ' << p.y;
}

Point Intersect(Point a, Point b, Point c, Point d) {
    // AC & BD
    if ((c - a) % (d - b) == 0) {
        return Point(INF, INF);
    }
    return a + ((c - a) * ((b - a) % (d - b))) / ((c - a) % (d - b));
}

const int MAXN = 3000;

Point puent[MAXN];
Point ans;

int main() {
    int n;
    cin >> n;
    n = 2 * n;
    for (int i = 0; i < n; ++i) {
        cin >> puent[i];
    }
    int cnt = 0;
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < 3; ++j) {
            if (i == j) continue;
            for (int k = j + 1; k < n; ++k) {
                if (i == k) continue;
                ans = Intersect(puent[0], puent[j], puent[i], puent[k]);
                if (abs(ans.x) > 1e6 || abs(ans.y) > 1e6) continue;
                if (ans == puent[0] || ans == puent[i]) continue;
                if (ans == puent[j] || ans == puent[k]) continue;
                map<Point, int> push;
                bool cul = true;
                for (int q = 0; q < n; ++q) {
                    Point cp = puent[q] - ans;
                    if (push.find(cp) == push.end())
                        push[cp] = 1;
                    else
                        ++push[cp];
                    if (push[cp] > 2 || ans == puent[q]) {
                        cul = false;
                        break;
                    }
                }
                if (push.size() != n / 2)
                    cul = false;
                if (cul && push.size() == n / 2) {
                    cout << "Yes\n" << ans << '\n';
                    return 0;
                }
                ++cnt;
                if (cnt > 2e7)
                    cout << "No\n";
            }
        }
    }
    cout << "No\n";
}

