#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define mt make_tuple
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//template<typename T>
//inline void read(T &x){
//  x = 0;
//  bool _ = false;
//  char c = getchar();
//  while (c < '0' || c >= '9') _ |= (c == '-'), c = getchar();
//  while (c >= '0' && c <= '9'){
//    x *= 10;
//    x += c - '0';
//  }
//  if (_) x = -x;
//}

const int N = 200200;

typedef long double ld;

const ld EPS = 1e-8;
const ld Nld = numeric_limits<ld>::quiet_NaN();

bool isnan(pair<ld, ld> p){
  return isnan(p.F) || isnan(p.S);
}

bool eq(ld x, ld y){
  return abs(x - y) <= 40 * EPS;
}

ll toint(ld x){
  if (eq(x, 0)) return 0;
  if (x < 0) return (ll)(x - EPS * 10);
  return (ll)(x + EPS * 10);
}

bool isint(ld x){
  return eq(x, (ld)toint(x));
}

struct point{
  ld x, y;
  point():x(Nld), y(Nld){}
  point(ld x, ld y):x(x), y(y){}
  bool isNull(){
//    if (isnan(x) || isnan(y)) return true;
//    cout << "kek1" << endl;
    if (!isint(x) || !isint(y)) return true;
    return false;
  }
  point operator-(point to){
    return point(x - to.x, y - to.y);
  }
  bool operator==(point to){
    return eq(x, to.x) && eq(y, to.y);
  }
};

ld sq(ld x){
  return x * x;
}

struct line{
  ld a, b, c;
  line():a(Nld), b(Nld), c(Nld){}
  line(point p1, point p2){
    if (!eq(p1.y, p2.y)){
      a = 1;
      b = (p1.x - p2.x) / (p2.y - p1.y);
    } else {
      b = 1;
      a = (p2.y - p1.y) / (p1.x - p2.x);
    }
    c = -(a * p1.x + b * p1.y);
  }
  point projection(point p){
    ld t = (-a * p.x + b * p.y + c) / (sq(a) + sq(b));
    return point(p.x + t * a, p.y + t * b);
  }
};

point intersect(line t1, line t2){
  point r(0.5, 0.5);
  if (eq(t2.a * t1.b - t2.b * t1.a, 0)) return r;
//  if (eq(t1.a, 0)) swap(t1, t2);
  r.y = (t1.a * t2.c - t1.c * t2.a) / (t2.a * t1.b - t2.b * t1.a);
  r.x = (t1.b * r.y + t1.c) / (-t1.a);
  return r;
}
//    if (isnan(x) || isnan(y)) return true;


int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);
#endif // LOCAL
  int n;
  cin >> n;
  n *= 2;
  point a[n];
  map<pair<int, int>, int> mp;
  for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;

  for (int i1 = 0; i1 < n; i1++){
    for (int i2 = 0; i2 < i1; i2++){
      for (int j1 = 0; j1 < n; j1++){
        if (j1 == i1 || j1 == i2) continue;
        for (int j2 = 0; j2 < j1; j2++){
          if (j2 == i1 || j2 == i2) continue;
          line A(a[i1], a[i2]);
          line B(a[j1], a[j2]);
          point cur = intersect(A, B);
          if (cur.isNull()) continue;
          bool f = true;
          for (int i = 0; i < n; i++){
            if (cur == a[i]) f = false;
          }
          if (!f) continue;
//          cout << i1 << ' ' << i2 << ' ' << j1 << ' ' << j2 << ' ' << cur.x << ' ' << cur.y << endl;
          if (toint(cur.x) < -1000000 || toint(cur.x) > 1000000) continue;
          if (toint(cur.y) < -1000000 || toint(cur.y) > 1000000) continue;
          mp.clear();
          for (int i = 0; i < n; i++){
            if (i == i1 || i == i2 || i == j1 || i == j2) continue;
            point nw = (cur - a[i]);
            int x = toint(nw.x);
            int y = toint(nw.y);
            int g;
//            if (x == 0 || y == 0){
//              g = 1;
//            } else {
              g = __gcd(x, y);
//            }
            x /= g;
            y /= g;
            if (x < 0) {
              x = -x;
              y = -y;
            }
            mp[{x, y}]++;
          }
//          if (i1 == 1 && i2 == 0 && j1 == 5 && j2 == 4) cerr << cur.x << ' ' << cur.y << endl;
//          bool f = true;
          for (auto &it : mp) {
            if (it.S & 1){
              f = false;
              break;
            }
          }
          if (f){
            cout << "Yes" << endl;
            cout << toint(cur.x) << ' ' << toint(cur.y) << endl;
            return 0;
          }
        }
      }
    }
  }
  cout << "No" << endl;
#ifdef LOCAL
  cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
  return 0;
}
