#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

struct pt {
	ll x, y;
};

ll gcd(ll a, ll b) {
	a = abs(a), b = abs(b);
	while (b) a %= b, swap(a, b);
	return a;
}

pair<ll, ll> get(pt A, pt B) {
	ll dx = B.x - A.x;
	ll dy = B.y - A.y;
	
	ll t = gcd(dx, dy);
	dx /= t, dy /= t;
	
	if (dx < 0) dx *= -1, dy *= -1;
	if (dx == 0 && dy < 0) dx *= -1, dy *= -1;
	return { dx, dy };
}

pt inter(pt A, pt B, pt C, pt D) {
	
	ll a1 = B.y - A.y;
	ll b1 = A.x - B.x;
	ll c1 = -(a1 * A.x + b1 * A.y);
	
	ll a2 = D.y - C.y;
	ll b2 = C.x - D.x;
	ll c2 = -(a2 * C.x + b2 * C.y);
	
	ll opr = a1 * b2 - a2 * b1;
	if (opr == 0) return { (ll)1e18, (ll)1e18 };
	
	ll x1 = c1 * b2 - c2 * b1;
	if (x1 % opr) return { (ll)1e18, (ll)1e18 };
	
	ll y1 = a1 * c2 - a2 * c1;
	if (y1 % opr) return { (ll)1e18, (ll)1e18 };
	
	return { -x1 / opr, -y1 / opr };
}

ll get(pair<ll, ll> c) {
	return c.first * (ll)1e7 + c.second;
}

bool check(pt O, vector<pt> &P) {
	if (abs(O.x) > (int)1e6 || abs(O.y) > (int)1e6) return false;
	for (auto c : P) if (c.x == O.x && c.y == O.y) return false;
	
	unordered_map<ll, int > M;
	
	for (auto p : P) {
		auto c = get(O, p);
		M[get(c)]++;
	}
	for (auto c : M) if (c.second != 2) return false;
	return true;
}

int cnt;
bool tl() {
	if (++cnt == 10) {
		if (clock() > 4.8 * CLOCKS_PER_SEC) return true;
		cnt = 0;
	}
	return false;
}

int main() {
	int n;
	cin >> n;
	
	vector<pt> P(2 * n);
	for (int i = 0; i < 2 * n; i++) cin >> P[i].x >> P[i].y;
	
	if (n == 1) {
		cout << "Yes\n";
		cout << P[1].x + (P[1].x - P[0].x) << " " << P[1].y + (P[1].y - P[0].y) << "\n";
		//assert(0);
		return 0;
	}
	
	for (int i = 2 * n - 1; i > 0; i--) {
		int j = (i == 1 ? 2 : 1);
		for (int k = 1; k < 2 * n; k++) if (k != j && k != i) {
			
			pt O = inter(P[0], P[i], P[j], P[k]);
			
			if (O.x == (ll)1e18) continue;
					
			if (check(O, P)) {
				cout << "Yes\n";
				cout << O.x << " "<< O.y << "\n";
				return 0;
			}
		}
		if (tl()) break;
	}
	
	cout << "No\n";
	return 0;
} 