#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define MAX(a, b) (((a) > (b)) ? (a): (b))
#define MIN(a, b) (((a) < (b)) ? (a): (b))
#define m_p make_pair
#define m_t make_tuple
#define ft first
#define sd second
#define ll long long
#define forn(i, j, n) for(ll i = j; i < n; ++i)
#define forc(i, n, j) for(ll i = n-1; i >= j; --i)
#define forr(i, j, n, d) for(auto i = j; i != n; d)

using namespace std;


class point {
public:
	ll x, y;
	point() {
		x = y = 0;
	}
	point(long a, long b) {
		x = a; y = b;
	}
	point(pair<long, long> p) {
		x = p.ft; y = p.sd;
	}
	point(pair<ll, ll> p) {
		x = p.ft; y = p.sd;
	}
};
vector<point> points;
class vect {
public:
	ll x, y;
	vect() {
		x = y = 0;
	}
	vect(long a, long b) {
		x = a; y = b;
	}
	vect(pair<long, long> p) {
		x = p.ft; y = p.sd;
	}
	vect(pair<ll, ll> p) {
		x = p.ft; y = p.sd;
	}
	vect(point beg, point end) {
		x = end.x - beg.x;
		y = end.y - beg.y;
	}
	ll operator*(vect b) {
		return x * b.y - y * b.x;
	}
	ll operator%(vect b) {
		return x * b.x + y * b.y;
	}

	vect operator*(long b) {
		return vect(x*b, y*b);
	}
};

class line {
public:
	//                                           dd
	point p1, p2;
	long a, b, c;
	line(point t1, point t2) {
		p1 = t1; p2 = t2;
		a = (t2.y - t1.y);
		b = (t1.x - t2.x);
		c = t1.x*t2.y - t2.x*t1.y;
	}
};

point peres(line l1, line l2, bool &z) {
	z = false;
	ll dx = - l1.c*l2.b + l2.c*l1.b;
	ll dy = l1.c*l2.a - l2.c*l1.a;
	ll dd = l1.b*l2.a - l2.b*l1.a;
	if (dd == 0) {
		z = false;
		return point(0, 0);
	}
	if (dx % dd != 0 || dy % dd != 0) {
		z = false;
		return point(0, 0);
	}
	point k;
	k.x = dx / dd; k.y = dy / dd;
	if (abs(k.x) > 1e6 || abs(k.y) > 1e6) {
		z = false; return k;
	}
	z = true; return k;
}

vector<vect> vects;

int main()
{
	long n;
	cin >> n; n <<= 1;
	if (n == 2) {
		cout << "azaz";
	} else {

		points.resize(n);
		vects.resize(n);
		forn(u, 0, n) {
			cin >> points[u].x >> points[u].y;
		}
		bool f = false;
		// step 1
		// zero and one is line, 2 and q is line
		line l1(points[0], points[1]);
		forn(q, 3, n) {
			line l2(points[2], points[q]);

			point moon = peres(l1, l2, f);
			if (f) {
				forn(u, 0, n) {
					vects[u] = vect(moon, points[u]);
					if (vects[u].x < 0 || (vects[u].x == 0 && vects[u].y < 0)) vects[u] = vects[u] * (-1);
					if (vects[u].x == 0 && vects[u].y == 0) {
						f = false; break;
					}
				}
				sort(vects.begin(), vects.end(), [](vect a, vect b) {
					return a * b > 0;
				});
				long kol = 1;
				forn(u, 0, n) {
					if (vects[u] * vects[u + 1] == 0) {
						++kol;
					} else {
						if (kol != 2) {
							f = false;
							break;
						}
						kol = 1;
					}
				}
				if (kol != 2) {
					f = false;
				}
			}
			if (f) {
				cout << "Yes" << endl << moon.x << ' ' << moon.y << endl;
				break;
			}
		}


		//step 2
		// zero and p is line, 1 and q is line
		if (!f) {
			forn(p, 2, n) {
				line l1(points[0], points[p]);
				forn(q, 2, n) {
					line l2(points[1], points[q]);

					point moon = peres(l1, l2, f);
					if (f) {
						forn(u, 0, n) {
							vects[u] = vect(moon, points[u]);
							if (vects[u].x < 0 || (vects[u].x == 0 && vects[u].y < 0)) vects[u] = vects[u] * (-1);
							if (vects[u].x == 0 && vects[u].y == 0) {
								f = false; break;
							}
						}
						if (f) {
							sort(vects.begin(), vects.end(), [](vect a, vect b) {
								return a * b > 0;
							});
							long kol = 1;
							forn(u, 0, n-1) {
								if (vects[u] * vects[u + 1] == 0) {
									++kol;
								} else {
									if (kol != 2) {
										f = false;
										break;
									}
									kol = 1;
								}
							}
							if (kol != 2) {
								f = false;
							}
						}
					}
					if (f) {
						cout << "Yes" << endl << moon.x << ' ' << moon.y << endl;
						break;
					}
				}
			}
		}
		if (!f) {
			cout << "No" << endl;
		}
	}
	cin >> n;

	return 0;
}