//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const ll inf = (ll)9e+18;
const ll bound = (ll)1e+6;

struct vec
{
	ll x, y;
	vec()
	{
		this->x = 0ll;
		this->y = 0ll;
	}
	vec(ll nx, ll ny)
	{
		this->x = nx;
		this->y = ny;
	}

	vec operator+(const vec &b)
	{
		return vec(x + b.x, y + b.y);
	}
	vec operator-(const vec &b)
	{
		return vec(x - b.x, y - b.y);
	}
	ll operator%(const vec &b)
	{
		return x * b.y - b.x * y;
	}
	ll operator*(const vec &b)
	{
		return x * b.x + y * b.y;
	}

	vec ort()
	{
		return vec(-y, x);
	}
};

struct line
{
	ll a, b, c;
	
	void set(vec a, vec b)
	{
		vec d = (a - b);
		this->a = d.ort().x;
		this->b = d.ort().y;
		this->c = -a.x * this->a - a.y * this->b;
	}
};

bool any;
pair<ll, ll> intersect(line x, line y)
{
	ll det = x.a * y.b - y.a * x.b;
	if (det == 0ll)
	{
		any = false;
		return mp(inf, inf);
	}

	ll ux = x.c * y.b - y.c * x.b;
	ll uy = x.a * y.c - y.a * x.c;

	if (ux % det != 0ll || uy % det != 0ll)
	{
		any = false;
		return mp(inf, inf);
	}

	any = true;
	return mp(-ux / det, -uy / det);
}

int main()
{
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n;
	cin >> n;
	n *= 2;

	set < pair<ll, ll> > havep;
	vector < pair<ll, ll> > arr(n);
	forn(i, n)
	{
		cin >> arr[i].first >> arr[i].second;
		havep.insert(arr[i]);
	}

	sort(arr.begin(), arr.end());

	vector <vec> now(n);
	do
	{
		forn(i, n)
			now[i] = vec(arr[i].first, arr[i].second);

		vector <line> lines(n / 2);
		forn(i, (int)lines.size())
			lines[i].set(now[2 * i], now[2 * i + 1]);

		bool flag = true;
		set< pair<ll, ll> > points;
		forn(i, (int)lines.size())
		{
			for (int j = i + 1; j < (int)lines.size(); j++)
			{
				pair<ll, ll> nowinter = intersect(lines[i], lines[j]);
				flag &= any;
				flag &= (abs(nowinter.first) <= bound && abs(nowinter.second) <= bound);
				points.insert(nowinter);
			}
		}
		if (flag && (int)points.size() == 1)
		{
			if (havep.count(*points.begin()) == 0)
			{
				cout << "Yes\n";
				cout << points.begin()->first << " " << points.begin()->second;
				return 0;
			}
		}

	} 
	while (next_permutation(arr.begin(), arr.end()));

	cout << "No";

	return 0;
}