#include <iostream>
#include <vector>

using namespace std;

void sum(const char* data, int len, int* sums)
{
    for(int i = 0; i < len; i++)
        sums[data[i]-'a']++;
}

bool check(const char* data, int n, int frag_len)
{
    int sums[52];
    for(int i = 0; i < 52; i++)
        sums[i] = 0;
    sum(data, frag_len, sums);
    int c = 0;
    for(int i = frag_len; i < n; i += frag_len)
    {
        c++;
        sum(data + i, frag_len, sums + 26);
        for(int i = 0; i < 26; i++)
            if(sums[i + 26] != sums[i] * c)
                return false;
    }
    return true;
}

void factorize(int n, vector<pair<int, int> >& a)
{
    int i = 2;
    int prev = 1;
    while(i * i <= n)
        if(n % i == 0)
        {
            if(i == prev)
                a.back().second++;
            else
                a.push_back(make_pair(i, 1));
            prev = i;
            n /= i;
        }
        else
            i++;
}

int pow(int a, int b)
{
    if(b == 0)
        return 1;
    if(b & 1)
        return pow(a, b - 1) * a;
    return pow(a * a, b / 2);
}

int check_primepow(const string& s, int prime, int p)
{
    int low = 0;
    int high = p + 1;
    while(high - low > 1)
    {
        int mid = (low + high) / 2;
        if(check(s.c_str(), s.size(), s.size() / pow(prime, mid)))
            low = mid;
        else
            high = mid;
    }
    return pow(prime, low);
}

int main()
{
    string s;
    cin >> s;
    int ans = 1;
    vector<pair<int, int> > factor;
    factorize(s.size(), factor);
    for(pair<int, int> i : factor)
        ans *= check_primepow(s, i.first, i.second);
    cout << ans << endl;
    return 0;
}
