#include <iostream>

using namespace std;

bool check(const char* data, int n, int frag_len)
{
    for(int i = frag_len; i <= n; i += frag_len)
    {
        pair<int, int> a = prefsums[i];
        pair<int, int> b = prefsums[n];
        if(a.first * b.second != b.first * a.second)
            return false;
    }
    return true;
}

int main()
{
    string s;
    cin >> s;
    pair<int, int> prefsums[s.size() + 1];
    prefsums[0].first = prefsums[0].second = 0;
    for(int i = 0; i < s.size(); i++)
    {
        prefsums[i + 1] = prefsums[i];
        if(s[i] == 'a')
            prefsums[i + 1].first++;
        else
            prefsums[i + 1].second++;
    }
    int max_cnt = 1;
    for(int i = 1; i * i <= s.size(); i++)
        if(s.size() % i == 0)
        {
            if(check(prefsums, s.size(), i))
            {
                cout << (s.size() / i) << endl;
                return 0;
            }
            if(check(prefsums, s.size(), s.size() / i))
                max_cnt = max(max_cnt, i);
        }
    cout << max_cnt << endl;
    return 0;
}
