#include <iostream>
#include <vector>

using namespace std;

void sum(const char* data, int len, int* sums)
{
    for(int i = 0; i < len; i++)
        sums[data[i]-'a']++;
}

bool check(pair<int, int>* prefsums, int n, int frag_len)
{
    for(int i = frag_len; i <= n; i += frag_len)
    {
        pair<int, int> a = prefsums[i];
        pair<int, int> b = prefsums[n];
        if(a.first * b.second != b.first * a.second)
            return false;
    }
    return true;
}

int gcd(int a, int b)
{
    while(b != 0)
    {
        swap(a, b);
        b %= a;
    }
    return a;
}

void abize(string& s)
{
    int sums[26];
    for(int i = 0; i < 26; i++)
        sums[i] = 0;
    sum(s.c_str(), s.size(), sums);
    int sums2[26];
    for(int i = 0; i < 26; i++)
        sums2[i] = 0;
    vector<int> good_indexes(1, 0);
    for(int i = 0; i < s.size(); i++)
    {
        sum(s.c_str() + i, 1, sums2);
        int base_index = s[0] - 'a';
        for(int i = 0; i < 26; i++)
            if(sums[i] * sums2[base_index] != sums2[i] * sums[base_index])
                goto fail;
        good_indexes.push_back(i + 1);
    fail:;
    }
    int ans_gcd = good_indexes[1] - good_indexes[0];
    for(int i = 1; i < good_indexes.size(); i++)
        ans_gcd = gcd(ans_gcd, good_indexes[i] - good_indexes[i - 1]); 
    for(int i = 1; i < good_indexes.size(); i++)
    {
        int r = good_indexes[i];
        int l = good_indexes[i - 1];
        int acnt = (r - l) / ans_gcd;
        for(int i = l; i < l + acnt; i++)
            s[i] = 'a';
        for(int i = l + acnt; i < r; i++)
            s[i] = 'b'; 
    }
}

int main()
{
    string s;
    cin >> s;
    abize(s);
    pair<int, int> prefsums[s.size() + 1];
    prefsums[0].first = prefsums[0].second = 0;
    for(int i = 0; i < s.size(); i++)
    {
        prefsums[i + 1] = prefsums[i];
        if(s[i] == 'a')
            prefsums[i + 1].first++;
        else
            prefsums[i + 1].second++;
    }
    int max_cnt = 1;
    for(int i = 1; i * i <= s.size(); i++)
        if(s.size() % i == 0)
        {
            if(check(prefsums, s.size(), i))
            {
                cout << (s.size() / i) << endl;
                return 0;
            }
            if(check(prefsums, s.size(), s.size() / i))
                max_cnt = max(max_cnt, i);
        }
    cout << max_cnt << endl;
    return 0;
}
