#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<int> operator+(vector<int> &a, vector<int> &b)
{
    vector<int> ans(a.size());
    for (int i = 0; i < a.size(); i++)
        ans[i] = a[i] + b[i];

    return ans;
}

vector<int> operator-(vector<int> &a, vector<int> &b)
{
    vector<int> ans(a.size());
    for (int i = 0; i < a.size(); i++)
        ans[i] = a[i] - b[i];

    return ans;
}

bool operator==(vector<int> &a, vector<int> &b)
{
    for (int i = 0; i < a.size(); i++)
        if (a[i] != b[i])
            return false;

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    string s;
    cin >> s;
    n = s.size();

    vector<vector<int>> hashes(n, vector<int>(26, 0));
    for (i = 0; i < n; i++)
        hashes[i][s[i] - 'a']++;

    vector<vector<int>> pfx_hashes(n + 1, vector<int>(26, 0));
    for (i = 0; i < n; i++)
        pfx_hashes[i + 1] = pfx_hashes[i] + hashes[i];

    int ans = 0;
    for (int k = 1; k <= n; k++)
    {
        if (n % k != 0)
            continue;

        bool ok = true;
        for (i = k; i < n; i += k)
        {
            if (pfx_hashes[i + k] - pfx_hashes[i] !=
                pfx_hashes[i] - pfx_hashes[i - k])
            {
                ok = false;
                break;
            }
        }

        if (ok)
        {
            ans = n / k;
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
