#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

vector<int> operator+(vector<int> &a, vector<int> &b)
{
    vector<int> ans(a.size());
    for (int i = 0; i < a.size(); i++)
        ans[i] = a[i] + b[i];

    return ans;
}

vector<int> operator-(vector<int> &a, vector<int> &b)
{
    vector<int> ans(a.size());
    for (int i = 0; i < a.size(); i++)
        ans[i] = a[i] - b[i];

    return ans;
}

bool operator==(vector<int> &a, vector<int> &b)
{
    for (int i = 0; i < a.size(); i++)
        if (a[i] != b[i])
            return false;

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    string s;
    cin >> s;
    n = s.size();

    int maxchar = -1;
    for (i = 0; i < n; i++)
        maxchar = max(maxchar, s[i] - 'a' + 1);

    int ans = 0;
    if (maxchar == 2)
    {
        vector<pii> hashes(n + 1, {0, 0});

        for (i = 0; i < n; i++)
        {
            if (s[i] == 'a')
                hashes[i + 1].first++;
            else
                hashes[i + 1].second++;
        }

        for (i = 0; i < n; i++)
        {
            hashes[i + 1].first += hashes[i].first;
            hashes[i + 1].second += hashes[i].second;
        }

        for (int k = 1; k <= n; k++)
        {
            if (n % k != 0)
                continue;

            bool ok = true;
            for (i = k; i < n; i += k)
            {
                if ((hashes[i + k].first - hashes[i].first
                    != hashes[i].first - hashes[i - k].first) ||
                        (hashes[i + k].second - hashes[i].second
                         != hashes[i].second - hashes[i - k].second))
                {
                    ok = false;
                    break;
                }
            }

            if (ok)
            {
                ans = n / k;
                break;
            }
        }
    }
    else
    {
        vector<vector<int>> hashes(n + 1, vector<int>(maxchar, 0));

        for (i = 0; i < n; i++)
            hashes[i + 1][s[i] - 'a']++;

        for (i = 0; i < n; i++)
            hashes[i + 1] = hashes[i + 1] + hashes[i];

        for (int k = 1; k <= n; k++)
        {
            if (n % k != 0)
                continue;

            bool ok = true;
            for (i = k; i < n; i += k)
            {
                if (hashes[i + k] - hashes[i] != hashes[i] - hashes[i - k])
                {
                    ok = false;
                    break;
                }
            }

            if (ok)
            {
                ans = n / k;
                break;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
