#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int LOG = 20;
const int N = 2e3;
int tin[N], tout[N], timer = 0;
vector<vector<int>> g(N), up(N, vector<int>(LOG));
vector<int> cs(N);
vector<vector<pair<int, int>>> cnt(N);
int n;

void dfs(const int &v, const int &par = 0) {
	tin[v] = timer++;
	up[v][0] = par;
	for (int i = 1; i < LOG; ++i) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (int to : g[v]) {
		dfs(to, v);
	}
	tout[v] = timer++;
}

inline bool isPar(const int &v, const int &u) {
	return tin[v] < tin[u] && tout[v] > tout[u];
}

inline int get_lca(int v, int u) {
	for (int i = LOG - 1; i >= 0; --i) {
		if (!isPar(up[v][i], u)) {
			v = up[v][i];
		}
	}
	return up[v][0];
}

struct edge {
	int v, u, c;
};

inline bool cmp(const edge &a, const edge &b) {
	return a.c < b.c;
}

inline int calc(const vector<pair<int, int>> &arr) {
	vector<edge> es;
	set<int> have;
	for (auto i : arr) {
		es.push_back({ i.first, i.second, cs[i.first] + cs[i.second] });
        have.insert(i.first);
        have.insert(i.second);
	}
	int res = 0;
	sort(es.begin(), es.end(), cmp);
    bitset<N> used;
    for (auto e : es) {
        if (!used[e.v] || !used[e.u]) {
            res += e.c;
            used[e.v] = 1;
            used[e.u] = 1;
        }
    }
    return res;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> cs[i];
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (!isPar(i, j) && !isPar(j, i)) {
                int lca = get_lca(i, j);
                cnt[lca].push_back({i, j});
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += calc(cnt[i]);
    }
    cout << ans;

    return 0;
}
