#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

typedef long long ll;

using namespace std;

ll ans = 0;

ll dfs(int v, vector<vector<int>> &g) {
    ll sum = 0;
    ll maxi = 0;
    for (int &to : g[v]) {
        ll curr = dfs(to, g);
        sum += curr;
        maxi = max(curr, maxi);
    }
    if (maxi > sum - maxi) {
        ans += 2 * (sum - maxi) + 2 * (maxi - (sum - maxi));
    } else {
        ans += (sum + 1) / 2 * 2;
    }
    return sum + 1;
}

vector<ll> c;

pair<pair<ll, ll>, ll> dfs2(int v, vector<vector<int>> &g) {
    ll sum = 0;
    ll size = 0;
    ll maxi = 0;
    int maxiid = 0;
    ll cmin = 1e18;
    vector<ll> cmins(g[v].size());
    for (int i = 0; i < g[v].size(); ++i) {
        pair<pair<ll, ll>, ll> curr = dfs2(g[v][i], g);
        size += curr.first.first;
        sum += curr.first.second;
        if (maxi < curr.first.first) {
            maxiid = i;
            maxi = curr.first.first;
        }
        cmin = min(cmin, curr.second);
        cmins[i] = curr.second;
    }
    if (maxi > sum - maxi) {
        ll minii = 1e18;
        for (int i = 0; i < g[v].size(); ++i) {
            if (i != maxiid) {
                minii = min(minii, cmins[i]);
            }
        }
        ans += sum + (maxi - (size - maxi)) * minii;
    } else if (size % 2 == 0) {
        ans += sum;
    } else {
        ans += sum + cmin;
    }
    return {{size + 1, sum + c[v]}, min(cmin, c[v])};
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        g[x].push_back(i);
    }

    ll sumc = 0;
    c.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
        sumc += c[i];
    }

    if (sumc > n - 1) {
        dfs2(0, g);
    } else {
        dfs(0, g);
    }
    cout << ans;
    return 0;
}