#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

typedef long long ll;

using namespace std;

const ll INF = 2e18;

pair<ll, ll> solve(ll a11, ll a12, ll b1, ll a21, ll a22, ll b2) {
    if (a11 * a22 == a21 * a12 || (a22 * b1 - a12 * b2) % (a11 * a22 - a21 * a12) != 0 || (a11 * b2 - a21 * b1) % (a11 * a22 - a21 * a12) != 0) {
        return {-INF, -INF};
    }
    return {(a22 * b1 - a12 * b2) / (a11 * a22 - a21 * a12), (a11 * b2 - a21 * b1) / (a11 * a22 - a21 * a12)};
}

bool online(ll a, ll b, ll c, ll x, ll y) {
    return (a * x + b * y + c == 0);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n;
    cin >> n;
    vector<pair<ll, ll>> a(2 * n);
    vector<int> per(2 * n);
    for (int i = 0; i < 2 * n; ++i) {
        per[i] = i;
        cin >> a[i].first >> a[i].second;
    }

    do {
        int i = 0;
        ll x1 = a[per[i]].first, y1 = a[per[i]].second;
        ll x2 = a[per[i + 1]].first, y2 = a[per[i + 1]].second;
        ll x3 = a[per[i + 2]].first, y3 = a[per[i + 2]].second;
        ll x4 = a[per[i + 3]].first, y4 = a[per[i + 3]].second;

        bool fl = 1;
        for (int j = 0; j < 2 * n; ++j) {
            if (j != i && j != i + 1 && online(y2 - y1, x1 - x2, (y1 - y2) * x1 + (x2 - x1) * y1, a[per[j]].first, a[per[j]].second)) {
                fl = false;
                break;
            }
        }
        if (!fl) continue;
        for (int j = 0; j < 2 * n; ++j) {
            if (j != i + 2 && j != i + 3 && online(y4 - y3, x3 - x4, (y3 - y4) * x3 + (x4 - x3) * y3, a[per[j]].first, a[per[j]].second)) {
                fl = false;
                break;
            }
        }
        if (!fl) continue;

        pair<ll, ll> cr = solve(y2 - y1, x1 - x2, -(y1 - y2) * x1 - (x2 - x1) * y1,
                                y4 - y3, x3 - x4, -(y3 - y4) * x3 - (x4 - x3) * y3);
        ll x = cr.first, y = cr.second;
        if (cr == make_pair(-INF, -INF)) {
            fl = false;
        }
        for (i = 4; i < fl && 2 * n; i += 2) {
            int x1 = a[per[i]].first, y1 = a[per[i]].second;
            int x2 = a[per[i + 1]].first, y2 = a[per[i + 1]].second;
            if (!online(y2 - y1, x1 - x2, (y1 - y2) * x1 + (x2 - x1) * y1, x, y)) {
                fl = false;
            } else {
                for (int j = 0; j < 2 * n; ++j) {
                    if (j != i && j != i + 1 && online(y2 - y1, x1 - x2, (y1 - y2) * x1 + (x2 - x1) * y1, a[per[j]].first, a[per[j]].second)) {
                        fl = false;
                        break;
                    }
                }
            }
        }
        if (fl) {
            cout << "Yes\n" << x << ' ' << y;
            return 0;
        }
    } while (next_permutation(per.begin(), per.end()));
    cout << "No";
    return 0;
}