//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

int dfs(int v, vector <vector <int> > &g, vector <long long> &ans) {
	int sum_in_node = 1;
	int balance_in_node = 0;
	int ans_for_node = 0;
	for (int i = 0; i < g[v].size(); i++) {
		int cnst = dfs(g[v][i], g, ans);
		sum_in_node += cnst;
		if (cnst > balance_in_node) {
			ans_for_node += cnst - balance_in_node;
		}
		balance_in_node = abs(cnst - balance_in_node);
	}
	ans[v] = ans_for_node;
	return sum_in_node;
}

long long gcd(long long a, long long b) {
	return b ? gcd(b, a % b) : a;
}

void solve() {
	string s;
	cin >> s;
	vector <int> count(26);
	for (int i = 0; i < s.size(); i++) {
		count[s[i] - 'a']++;
	}
	if (count[0] + count[1] == s.size()) {
		vector <int> prefix(s.size() + 1);
		for (int i = 0; i < s.size(); i++) {
			if (s[i] == 'a') {
				prefix[i + 1] = prefix[i] + 1;
			}
		}
		int best;
		for (int i = 1; i <= sqrt(s.size()); i++) {
			if (s.size() % i == 0) {
				int sum = prefix[i];
				bool bad = true;
				for (int j = 2 * i; j <= s.size() && bad; j += i) {
					if (prefix[j] - prefix[i] != sum) {
						bad = false;
					}
				}
				if (bad) {
					best = i;
				}
			}
		}
		cout << best;
		return;
	}
	for (int len = 1; len <= s.size(); len++) {
		if (s.size() % len != 0) continue;
		vector <vector <int> > cnt(s.size() / len, vector <int>(26));
		for (int i = 0; i < s.size(); i++) {
			cnt[i / len][s[i] - 'a']++;
		}
		bool bad = true;
		for (int i = 0; i < s.size() / len && bad; i++) {
			for (int j = 0; j < 26 && bad; j++) {
				if (cnt[i][j] != cnt[0][j]) {
					bad = false;
				}
			}
		}
		if (bad) {
			cout << s.size() / len;
			return;
		}
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}