#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef unsigned long long ll;

const ll INF = (ll) 1e18;

struct Graph {
    int n;
    vector<vector<int>> g;
    vector<ll> sz;
    vector<ll> sumc;
    vector<pair<ll, ll>> mins;
    vector<pair<int, int>> indMins;
    vector<ll> cs;

    void add(int v, int u) {
        g[v].push_back(u);
    }

    void readCs() {
        cs[0] = 0;
        for (int i = 1; i < n; ++i) {
            cin >> cs[i];
        }
    }

    ll dfs(int v) {
        mins[v].first = INF, mins[v].second = INF;
        sz[v] = 1;
        sumc[v] = cs[v];
        ll here = 0;
        set<pair<ll, int>> s;
        for (auto to : g[v]) {
            here += dfs(to);
            if (mins[to].first < mins[v].first) {
                mins[v].second = mins[v].first;
                indMins[v].second = indMins[v].first;
                mins[v].first = mins[to].first;
                indMins[v].first = to;
            } else if (mins[to].first < mins[v].second) {
                mins[v].second = mins[to].first;
                indMins[v].second = to;
            }
            sz[v] += sz[to];
            sumc[v] += sumc[to];
            s.insert({sz[to], to});
            here += sumc[to];
        }
//        ll firstVar = 0;
        auto sr = s;
        ll res = !g[v].empty() * INF;
        while (s.size() > 1) {
            auto p = *s.rbegin();
            s.erase(--s.end());
            auto pp = *s.rbegin();
            s.erase(--s.end());
            p.first -= pp.first;
            if (p.first) {
                s.insert(p);
            }
        }
        if (!s.empty()) {
            auto p = *s.begin();
            if (p.second != indMins[v].first) {
                res = min(res, p.first * mins[v].first);
            } else {
                res = min(res, p.first * mins[v].second);
            }
            if (sz[indMins[v].first] <= sz[v] / 2) {
                res = min(res, p.first * mins[v].first);
            }
        } else {
            res = 0;
        }
        if (!g[v].empty()) {
            if (sz[indMins[v].first] > sz[v] / 2) {
                res = min(res, sz[indMins[v].first] - (sz[v] - sz[indMins[v].first]) * mins[v].second, res);
            }
        }
//        ll secondVar = INF;
//        if (!g[v].empty()) {
//            auto ost = sz[indMins[v].first];
//            sr.erase({sz[indMins[v].first], indMins[v].first});
//            while (ost && !sr.empty()) {
//                auto p = *sr.rbegin();
//                sr.erase(--sr.end());
//                ll db = min(ost, p.first);
//                p.first -= db;
//                ost -= db;
//                if (p.first) {
//                    sr.insert(p);
//                }
//            }
//            if (!sr.empty()) {
//                while (sr.size() > 1) {
//                    auto p = *sr.rbegin();
//                    sr.erase(--sr.end());
//                    auto pp = *sr.rbegin();
//                    sr.erase(--sr.end());
//                    p.first -= pp.first;
//                    if (p.first) {
//                        sr.insert(p);
//                    }
//                }
//                if (!sr.empty()) {
//                    auto p = *sr.begin();
//                    res = min(res, p.first * mins[v].first);
//                } else {
//                    res = 0;
//                }
//            } else {
//                res = min(res, ost * mins[v].second);
//            }
//        }
//        here += min(firstVar, secondVar);
//        for (auto to : g[v]) {
//            auto sr = s;
//            sr.erase({sz[to], to});
//            while (sr.size() > 1) {
//                auto p = *sr.rbegin();
//                sr.erase(--sr.end());
//                auto pp = *sr.rbegin();
//                sr.erase(--sr.end());
//                p.first -= pp.first;
//                if (p.first) {
//                    sr.insert(p);
//                }
//            }
//            ll num = sz[to];
//            if (!sr.empty()) {
//                auto p = *sr.begin();
//                if (p.first > sz[to]) continue;
//                num -= p.first;
//            }
//            if (indMins[v].first == to) {
//                res = min(res, num * mins[v].second);
//            } else {
//                res = min(res, num * mins[v].first);
//            }
//        }
        here += res;
        if (cs[v] < mins[v].first) {
            mins[v].first = cs[v];
        } else if (cs[v] < mins[v].second) {
            mins[v].second = cs[v];
        }
        return here;
    }

    Graph(int n) :
            n(n), g(n), sz(n), sumc(n),
            mins(n), indMins(n), cs(n) {}
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n;
    cin >> n;
    Graph g(n);
    for (int i = 1, p; i < n; ++i) {
        cin >> p;
        g.add(--p, i);
    }
    g.readCs();
    cout << g.dfs(0) << "\n";
    return 0;
}
/*
5
1 2 2 1
1 1 1 1

6
1 1 1 4 4
1 2 3 4 5

8
1 1 1 3 3 4 4
1 1000 1000 1000 1000 1000 1000
 */