import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    class Line {
        long a, b, c;

        Line(long x1, long y1, long x2, long y2) {
            a = y2 - y1;
            b = x1 - x2;
            c = x2 * y1 - x1 * y2;
        }

        boolean is(long x, long y){
            if(a * x + b * y + c == 0) return true;
            return false;
        }
    }
    long gcd(long a, long b){
        if(b == 0) return a;
        if(a < b) return gcd(b, a);
        return gcd(b, a % b);
    }

    public void solve() throws IOException {
        int n = 2 * nextInt();
        long x[] = new long[n], y[] = new long[n];
        for (int i = 0; i < n; i++) {
            x[i] = nextInt();
            y[i] = nextInt();
        }
        for (int i = 1; i < n; i++) {
            Line l = new Line(x[0], y[0], x[i], y[i]);
            if(l.a < 0){
                l.a *= -1;
                l.b *= -1;
                l.c *= -1;
            }
            long gc = gcd(gcd(l.a, l.b), l.c);
            for(int xx = -1000000; xx <= 1000000; xx++){
                if(l.b == 0){
                    if(xx != -l.c/l.a) continue;
                    boolean t = true;
                    for (int q = 1; q < n && t; q++) {
                        if(q == i) continue;
                        Line l1 = new Line(xx, 0, x[q], y[q]);
                        int cnt= 0;
                        for(int e = 1; e < n; e++){
                            if(e == i)continue;
                            if(e == q) continue;
                            if(l1.is(x[e], y[e])) cnt++;
                        }
                        if(cnt != 1){
                            t= false;
                        }
                    }
                    if(t){
                        out.print("YES\n");
                        out.print(xx + " " + 0);
                        return;
                    }
                    continue;
                }
                if((l.c + l.a * xx) % l.b != 0) continue;
                boolean t = true;
                for (int q = 1; q < n && t; q++) {
                    if(q == i) continue;
                    Line l1 = new Line(xx, (-l.c - l.a*xx)/l.b, x[q], y[q]);
                    int cnt= 0;
                    for(int e = 1; e < n; e++){
                        if(e == i)continue;
                        if(e == q) continue;
                        if(l1.is(x[e], y[e])) cnt++;
                    }
                    if(cnt != 1){
                        t= false;
                    }
                }
                if(t){
                    out.print("YES\n");
                    out.print(xx + " " + ((-l.c - l.a*xx)/l.b));
                    return;
                }
            }
        }
        out.print("NO");
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}