//~ #pragma GCC optimize("O3")
//~ #pragma GCC target("popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

template<typename A, typename B> bool mini(A &x, const B &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

template<typename A, typename B> bool maxi(A &x, const B &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = 5205;

struct Vect {
	ll x, y;
	
	Vect() : x(0), y(0) {}
	
	Vect(ll x, ll y) : x(x), y(y) {}
	
	Vect(const Vect &a, const Vect &b) : x(b.x - a.x), y(b.y - a.y) {}
	
	Vect dir() const {
		ll g = __gcd(x, y);
		ll xx = x / g;
		ll yy = y / g;
		if (xx < 0) {
			xx = -xx;
			yy = -yy;
		}
		if (xx == 0 && yy < 0) {
			yy = -yy;
		}
		return Vect(xx, yy);
	}
	
	bool operator==(const Vect &b) const {
		return x == b.x && y == b.y;
	}
	
	bool operator!=(const Vect &b) const {
		return x != b.x || y != b.y;
	}
	
	bool operator<(const Vect &b) const {
		return mp(x, y) < mp(b.x, b.y);
	}
};

struct Line {
	ll a, b, c;
	
	Line(const Vect &u, const Vect &v) {
		a = v.y - u.y;
		b = u.x - v.x;
		c = -a * u.x - b * u.y;
		#ifdef LOCAL
		assert(a * v.x + b * v.y + c == 0);
		#endif
	}
};

// a b
// c d
ll det(ll a, ll b, ll c, ll d) {
	return a * d - b * c;
}

pair<Vect, bool> inter(const Line &a, const Line &b) {
	ll d = det(a.a, a.b, b.a, b.b);
	if (d == 0) {
		return {Vect(), false};
	}
	ll dx = det(-a.c, a.b, -b.c, b.b);
	ll dy = det(a.a, -a.c, b.a, -b.c);
	if (dx % d != 0 || dy % d != 0) {
		return {Vect(), false};
	}
	#ifdef LOCAL
	Vect p = {dx / d, dy / d};
	assert(a.a * p.x + a.b * p.y + a.c == 0);
	assert(b.a * p.x + b.b * p.y + b.c == 0);
	#endif
	return {{dx / d, dy / d}, true};
}

int n;
Vect p[N];
int used[N];
int tmr;
vector<pair<Vect, int>> can[N];

const int C = 1000000;

set<Vect> checked;

void check(Vect mid) {
	if (abs(mid.x) > C || abs(mid.y) > C) {
		return;
	}
	if (checked.count(mid)) return;
	checked.insert(mid);
	
	tmr++;
	rep(i, 0, n) {
		if (p[i].x == mid.x && p[i].y == mid.y) {
			return;
		}
		if (used[i] == tmr) continue;
		Vect what = Vect(p[i], mid).dir();
		int ind = (int) (lower_bound(all(can[i]), mp(what, -1)) - can[i].begin());
		if (ind == n - 1 || can[i][ind].first != what || (ind + 1 < n - 1 && can[i][ind + 1].first == what)) {
			return;
		}
		used[can[i][ind].second] = tmr;
	}
	
	cout << "Yes\n";
	cout << mid.x << " " << mid.y << "\n";
	exit(0);
}

void run() {
	cin >> n;
	n *= 2;
	rep(i, 0, n) {
		cin >> p[i].x >> p[i].y;
	}
	shuffle(p, p + n, mt19937(5325));
	rep(i, 0, n) {
		rep(j, 0, n) {
			if (i == j) continue;
			can[i].pb({Vect(p[i], p[j]).dir(), j});
		}
		sort(all(can[i]));
	}
	rep(i, 2, n) {
		rep(j, 2, n) {
			if (i == j) continue;
			auto it = inter(Line(p[0], p[i]), Line(p[1], p[j]));
			if (it.second) {
				check(it.first);
			}
		}
	}
	rep(i, 3, n) {
		auto it = inter(Line(p[0], p[1]), Line(p[2], p[i]));
		if (it.second) {
			check(it.first);
		}
	}
	
	cout << "No\n";
}
