#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x)*(x))
#define pw(x) (1ll << (x))
#define _ inline

ll logn(ll n) { return ll(log2(ld(n))); }
ll rnd() { return (rand() << 16) + rand(); }
ll gcd(ll a, ll b) { return (b ? gcd(b, a % b) : a); }

const ll INF = 1e9;

struct V {
    ll x, y;
    V() {}
    V(ll x, ll y): x(x), y(y) {}
};

ll operator * (V a, V b) { return (a.x * b.x) + (a.y * b.y); }
ll operator % (V a, V b) { return (a.x * b.y) - (a.y * b.x); }

struct Line {
    ll A, B, C;
    V a, b;
    ll i, j;
    Line() {}
    Line(V a1, V b1, ll i1, ll j1) {
        a= a1, b = b1;
        i = i1, j = j1;
        A = b.y - a.y;
        B = a.x - b.x;
        C = -(A * a.x + B * a.y);
    }
};

V Intersect(Line a, Line b) {
    ll d = V(a.A, a.B) % V(b.A, b.B);
    if (!d) return V(INF, INF);
    V ans;
    ll xx1 = -(a.C * b.B - b.C * a.B);
    ll yy1 = -(b.C * a.A - a.C * b.A);
    if(xx1 % d) return V(INF, INF);
    if(yy1 % d) return V(INF, INF);
    return V(xx1 / d, yy1 / d);
}

const ll SZB = 100;

int source() {
    ll n;
    cin >> n;
    vector<V> p(2 * n);
    set<par> forb;
    for (int i = 0; i < 2 * n; ++i) {
        cin >> p[i].x >> p[i].y;
        forb.insert({p[i].x, p[i].y});
    }
    vector<Line> L;
    map<par, bitset<SZB>> a;
    for (int i = 0; i < 2 * n; ++i) {
        for (int j = i + 1; j < 2 * n; ++j) {
            L.push_back(Line(p[i], p[j], i, j));
        }
    }
    for (int i = 0; i < L.size(); ++i) {
        for (int j = i + 1; j < L.size(); ++j) {
            if (L[i].i == L[j].i || L[i].i == L[j].j) continue;
            if (L[i].j == L[j].i || L[i].j == L[j].j) continue;
            V cur = Intersect(L[i], L[j]);
            if (cur.x == INF) continue;
            /*
            //cout << L[i].A << ' ' << L[i].B << ' '<<  L[i].C << '\n';
            //cout << L[j].A << ' ' << L[j].B << ' '<<  L[j].C << '\n';
            cout << L[i].i << ' ' << L[i].j << '\n';
            cout << L[j].i << ' ' << L[j].j << '\n';
            cout << cur.x << ' ' << cur.y << '\n';
            cout << '\n';
            */
            par v = {cur.x, cur.y};
            if (forb.count(v)) continue;
            bitset<SZB> &it = a[v];
            bool f1 = (it[L[i].i] ^ it[L[i].j]) | (it[L[j].i] ^ it[L[j].j]);
            if (f1) {
                //cerr << L[i].i;
                //cerr << v.X << ' ' << v.Y << '\n';
                continue;
            } else {
                it[L[i].i] = it[L[i].j] = it[L[j].i] = it[L[j].j] = 1;
            }
        }
    }
    bitset<SZB> best;
    for (int i = 0; i < 2 * n; ++i) best[i] = 1;
    for (auto x : a) {
        if (x.Y == best) {
            cout << "Yes\n";
            cout << x.X.X << ' ' << x.X.Y;
            return 0;
        }
    }
    cout << "No";
    return 0;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    ll test = 1;
#ifdef aokigahara
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    //cin >> test;
#endif // aokigahara

    for (int i = 0; i < test; ++i) {
        source();
        cout << '\n';
        cerr << '\n';
    }

#ifdef aokigahara
    cerr << fixed << setprecision(12) << "\n\nTIME : " << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
