#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

struct point
{
    int x;
    int y;
};

long double EPS = 1e-6, INF = 1e9;
int n;
vector<point> s;
pair<long double, long double> ans;
pair<int, int> real_ans;



pair<long double , long double> get_line(int ax, int ay, int bx, int by)
{
    if (ax != bx)
    {
        long double k1 = (ay - by) / (ax - bx);
        long double b1 = ay - k1 * ax;
        return make_pair(k1, b1);
    }
}


bool check(vector<pair<point, point>> p)
{
    vector < pair<long double, long double>> lines;
    vector <pair<point, point>> one_line;
    int num = 0;
    for (int i = 0; i < p.size(); i++)
    {
        if (p[i].first.y == p[i].second.y)
        {
            one_line.push_back(p[i]);
            lines.push_back(make_pair(-INF, INF));
            num++;
        }
        else
        {
            pair<long double, long double> t = get_line(p[i].first.x, p[i].first.y, p[i].second.x, p[i].second.y);
            lines.push_back(t);
        }
    }
    if (num > lines.size() - 2)
    {
        if (lines.size() == num)
            return 0;
        int j = 0;
        while (lines[j].first == -INF && lines[j].second == INF)
            j++;
        if (one_line.size() != 1)
            return 0;
        if (lines[j].first == 0)
        {
            ans = make_pair(one_line[0].first.x, lines[j].second);
            return 1;
        }
        long double cross_x = (one_line[0].first.y - lines[j].second) / lines[j].first;
        long double cross_y = one_line[0].first.y;
        ans = make_pair(cross_x, cross_y);
        return 1;
    }
    if (num > 1)
        return 0;
    int i = 1;
    while (i < lines.size() && lines[i].first == lines[i - 1].first)
        i++;
    if (i == lines.size())
        return 0;
    if (lines[i].first == lines[i - 1].first) // is there any troubles???
    {
        long double cross_x = (lines[0].second - lines[1].second) / (lines[1].first - lines[0].first);
        long double cross_y = lines[0].first * cross_x + lines[0].second;
        for (int i = 0; i < lines.size(); i++)
        {
            if (lines[i].first != -INF && lines[i].second != INF)
            {
                if (lines[i].first * cross_x + lines[i].second != cross_y)
                    return 0;
            }
        }
        if (one_line.size() != 0)
        {
            if (one_line[0].first.y != cross_y)
                return 0;
        }
        ans = make_pair(cross_x, cross_y);
        return 1;
    }
    return 0;
}

bool small_check()
{ 
    if (abs(ans.first - (int)ans.first) > EPS)
        return 0;
    if (abs(ans.second - (int)ans.second) > EPS)
        return 0;
    for (int i = 0; i < s.size(); i++)
    {
        if (s[i].x == ans.first && s[i].y == ans.second)
            return 0;
    }
    return 1;
}

void rec(vector<bool> used, vector<pair<point, point>> p)
{
    if (p.size() == n)
    {
        if (check(p))
        {
            if (small_check())
                real_ans = ans;
        }
        return;
    }
    for (int i = 0; i < 2 * n; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            if (!used[i] && !used[j] && i != j)
            {
                used[i] = 1;
                used[j] = 1;
                p.push_back(make_pair(s[i], s[j]));
                rec(used, p);
                p.pop_back();
                used[i] = 0;
                used[j] = 0;
            }
        }
    }
}

int main()
{
    cin >> n;
    real_ans = make_pair(INF, INF);
    for (int i = 0; i < 2 * n; i++)
    {
        point p;
        cin >> p.x >> p.y;
        s.push_back(p);
    }
    vector<pair<point, point>> p;
    vector<bool> used (2 * n, 0);
    rec(used, p);
    if (!(real_ans.first == INF && real_ans.second == INF))
        cout << "Yes\n" << real_ans.first << " " << real_ans.second;
    else
        cout << "No";
    return 0;
}