#include <bits/stdc++.h>

typedef long long ll;

const int N = 5500;

class Point {
public:
    int x, y;
    Point()
            : x()
            , y()
    {}
    Point(int x, int y)
            : x(x)
            , y(y)
    {}
    Point operator+(const Point& pt) const {
        return Point(x + pt.x, y + pt.y);
    }
    Point operator-(const Point& pt) const {
        return Point(x - pt.x, y - pt.y);
    }
    Point operator*(const int& k) const {
        return Point(x * k, y * k);
    }
    Point operator/(const int& k) const {
        assert(x % k == 0);
        return Point(x / k, y / k);
    }
    double operator*(const Point& pt) const {
        return x * pt.x + y * pt.y;
    }
    double operator%(const Point& pt) const {
        return x * pt.y - y * pt.x;
    }
    bool operator==(const Point& pt) const {
        return x == pt.x && y == pt.y;
    }
};

class Line {
public:
    int a, b, c;
    Line()
            : a()
            , b()
            , c()
    {}
    Line(Point A, Point B) {
        a = A.y - B.y;
        b = B.x - A.x;
        c = -A.x * a - A.y * b;
    }
    bool checkPoint(const Point& pt) const {
        return pt.x * a + pt.y * b + c == 0;
    }
    bool intersectLines(const Line& ln, Point& res) const {
        int p1 = b * ln.c - ln.b * c;
        int q1 = a * ln.b - ln.a * b;
        int p2 = a * ln.c - ln.a * c;
        int q2 = b * ln.a - a * ln.b;
        if (q1 == 0 || q2 == 0 || p1 % q1 != 0 || p2 % q2 != 0) {
            return false;
        }
        res = Point(p1 / q1, p2 / q2);
        return true;
    }
};

Point a[N];

int main(void) {
    int n;
    scanf("%d", &n);
    for (int i = 0; i < 2 * n; ++i) {
        scanf("%d%d", &a[i].x, &a[i].y);
    }
    for (int i = 0; i < 2 * n; ++i) {
        for (int j = i + 1; j < 2 * n; ++j) {
            Line curLine = Line(a[i], a[j]);
            for (int k = 0; k < 2 * n; ++k) {
                if (k == i || k == j) {
                    continue;
                }
                for (int l = k + 1; l < 2 * n; ++l) {
                    if (l == i || l == j) {
                        continue;
                    }
                    Line curLine2 = Line(a[k], a[l]);
                    Point M;
                    if (!curLine.intersectLines(curLine2, M)) {
                        continue;
                    }
                    if (abs(M.x) > 1000000 || abs(M.y) > 1000000) {
                        continue;
                    }
                    bool fl = true;
                    for (int o = 0; o < 2 * n; ++o) {
                        Line chkLine = Line(a[o], M);
                        int cnt = 1;
                        for (int p = 0; p < 2 * n; ++p) {
                            if (p != o && chkLine.checkPoint(a[p])) {
                                ++cnt;
                            }
                        }
                        if (cnt != 2) {
                            fl = false;
                            break;
                        }
                    }
                    if (fl) {
                        printf("Yes\n%d %d\n", M.x, M.y);
                        return 0;
                    }
                }
            }
        }
    }
    printf("No\n");
    return 0;
}