#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e6, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

struct Point
{
    int x, y;

    Point()
    {
        x = 0, y = 0;
    }
    Point(int a, int b)
    {
        x = a, y = b;
    }

    Point operator +(const Point &ot) const
    {
        return Point(x + ot.x, y + ot.y);
    }
    Point operator -(const Point &ot) const
    {
        return Point(x - ot.x, y - ot.y);
    }
    Point operator *(const ld &k) const
    {
        return Point(x * k, y * k);
    }
    Point operator /(const ld &k) const
    {
        return Point(x / k, y / k);
    }
    bool operator <(const Point &ot) const
    {
        return x + EPS < ot.x || (abs(x - ot.x) < EPS && y + EPS < ot.y);
    }
    bool operator ==(const Point &ot) const
    {
        return abs(x - ot.x) < EPS && abs(y - ot.y) < EPS;
    }
};

struct Line
{
    ld a, b, c;

    Line()
    {
        a = 0.0, b = 0.0, c = 0.0;
    }
    Line(ld x, ld y, ld z)
    {
        a = x, b = y, c = z;
    }
    Line(Point &n, Point &m)
    {
        a = m.y - n.y;
        b = n.x - m.x;
        c = -a * n.x - b * n.y;
    }

    bool operator <(const Line &ot) const
    {
        return a + EPS < ot.a || (abs(a - ot.a) < EPS && b + EPS < ot.b) || (abs(a - ot.a) < EPS && abs(b - ot.b) < EPS && c + EPS < ot.c);
    }

    bool check(const Point &p) const
    {
        return (a * p.x + b * p.y + c) < EPS;
    }
    Point norm() const
    {
        return Point(a, b);
    }
};

istream &operator >>(istream &in, Point &p)
{
    in >> p.x >> p.y;
    return in;
}

ostream &operator <<(ostream &out, Point &p)
{
    out << p.x << " " << p.y;
    return out;
}

ld dot_p(Point &a, Point &b)
{
    return a.x * b.x + a.y * b.y;
}

ld cross_p(Point &a, Point &b)
{
    return a.x * b.y - a.y * b.x;
}

ld dist(Point &a, Point &b)
{
    return hypot(a.x - b.x, a.y - b.y);
}

ld line_dist(Line &ln, Point &p)
{
    return (ln.a * p.x + ln.b * p.y + ln.c) / hypot(ln.a, ln.b);
}

Point line_intersect(Line l1, Line l2)
{
    int down = l1.b * l2.a - l2.b * l1.a;
    int up1 = l1.c * l2.b - l2.c * l1.b;
    int up2 = l2.c * l1.a - l1.c * l2.a;
    if (down == 0 || up1 % down || up2 % down)
        return Point(INF, INF);
    return Point(up1 / down, up2 / down);
}

int n;
vector<Point> stars;

bool check(Point p)
{
    //cout << p << endl;
    map<Line, int> counter;
    for (int i = 0; i < n; ++i) {
        if (p == stars[i])
            return false;
        Line ln(p, stars[i]);
        ld del = hypot(ln.a, ln.b);
        ln.a /= del;
        ln.b /= del;
        ln.c /= del;
        if (ln.a < -EPS || (ln.a == 0 && ln.b < -EPS)) {
            ln.a *= -1;
            ln.b *= -1;
            ln.c *= -1;
        }
        //if (p == Point(2, 2))
        //    cout << ln.a << " " << ln.b << " " << ln.c << endl;
        counter[ln]++;
    }

    for (auto &elem : counter)
        if (elem.second != 2)
            return false;
    return true;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    n *= 2;
    stars.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> stars[i];

    if (n == 2) {
        Point ans = (stars[0] * 2 - stars[1]);
        cout << "Yes" << endl;
        cout << ans << endl;
        return 0;
    }

    set<Point> maybe;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                for (int x = k + 1; x < n; ++x) {
                    //if (i == j || i == k || i == x || j == k || j == x || k == x)
                    //    continue;
                    Line l1(stars[i], stars[j]), l2(stars[k], stars[x]);
                    Point p = line_intersect(l1, l2);
                    if (abs(p.x) <= INF && abs(p.y) <= INF)
                        maybe.insert(p);

                    l1 = Line(stars[i], stars[k]), l2 = Line(stars[j], stars[x]);
                    p = line_intersect(l1, l2);
                    if (abs(p.x) <= INF && abs(p.y) <= INF)
                        maybe.insert(p);

                    l1 = Line(stars[i], stars[x]), l2 = Line(stars[j], stars[k]);
                    p = line_intersect(l1, l2);
                    if (abs(p.x) <= INF && abs(p.y) <= INF)
                        maybe.insert(p);
                }
            }
        }
    }

    for (auto &elem : maybe) {
        if (check(elem)) {
            cout << "Yes" << endl;
            cout << elem.x << " " << elem.y << endl;
            return 0;
        }
    }

    cout << "No" << endl;

    return 0;
}
