import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {
    int gcd(int a, int b) {
        if (b == 0) return a;
        return gcd(b, a % b);
    }

    public class pair implements Comparable<pair> {
        int x, y;

        pair(int a, int b) {
            x = a;
            y = b;
        }

        public int compareTo(pair p) {
            if (x == p.x) return y - p.y;
            return x - p.x;
        }
    }

    public void solve() throws IOException {
        String s = nextToken();
        int n = s.length();
        int x = 0;
        int[] d = new int[26];
        for (int i = 0; i < n; i++) {
            d[s.charAt(i) - 'a']++;
        }
        for (int i = 25; i >= 0; i--) {
            if (d[i] != 0) {
                x = gcd(d[i], x);
            }
        }
        if (n < 500001) {
            for (int i = x; i > 1; i--) {
                if (x % i == 0) {
                    int p1 = 0;
                    int[] d1 = new int[26];
                    for (int j = 0; j < 26; j++) {
                        d1[j] = d[j] / i;
                        if (d1[j] != 0) p1++;
                    }
                    int[] d2 = new int[26];
                    int z = 1;
                    int p2 = 0;
                    boolean t = true;
                    for (int j = 0; j < n; j++) {
                        int h = s.charAt(j) - 'a';
                        d2[h]++;
                        if (d2[h] == z * d1[h]) {
                            p2++;
                            if (p2 == p1) {
                                z++;
                                p2 = 0;
                            }
                        } else {
                            if (d2[h] > z * d1[h]) {
                                t = false;
                                break;
                            }
                        }
                    }
                    if (t) {
                        out.print(i);
                        return;
                    }
                }
            }
            out.print(1);
        } else {
            TreeSet<pair> g = new TreeSet<>();
            pair d3 = new pair(0,0);
            for (int i = 0; i < n; i++) {
                if (s.charAt(i) == 'a') {
                    d3.x++;
                } else {
                    d3.y++;
                }
                g.add(d3);
            }
            for (int i = x; i > 1; i++) {
                if (x % i == 0) {
                    boolean t = true;
                    for (int j = 1; j <= x / i; j++) {
                        if(!g.contains(new pair(d[0] / i * j,d[1] / i * j))){
                            t = false;
                            break;
                        }
                    }
                    if (t){
                        out.print(i);
                        return;
                    }
                }
            }
            out.print(1);
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
