#include <bits/stdc++.h>

using namespace std;

struct point{
    __int128 x, y;
    point () {}
    point(__int128 x, __int128 y) : x(x), y(y) {};
};

bool operator < (point a, point b){
    return a.x < b.x || a.x == b.x && a.y < b.y;
}

struct line{
    __int128 a, b, c;
    line () {}
    line(__int128 a, __int128 b, __int128 c) : a(a), b(b), c(c) {}
};

line make_line(point a, point b){
    __int128 A = b.y - a.y;
    __int128 B = a.x - b.x;
    __int128 C = -A * a.x - B * a.y;

    return line(A, B, C);
}

pair<bool, point> intersect(line a, line b){
    if (a.a * b.b - b.a * a.b == 0 || a.a * b.b - b.a * a.b == 0)
        return {0, {-1, -1}};
    if (abs(a.c * b.b - b.c * a.b) % abs(a.a * b.b - b.a * a.b) != 0)
        return {0, {-1, -1}};
    if (abs((a.a * b.c - b.a * a.c)) % abs(a.a * b.b - b.a * a.b) != 0)
        return {0, {-1, -1}};

    __int128 x = -(a.c * b.b - b.c * a.b) / (a.a * b.b - b.a * a.b);
    __int128 y = -(a.a * b.c - b.a * a.c) / (a.a * b.b - b.a * a.b);

    return {1, {x, y}};
}

int n;
vector<point> pts;

void print(__int128 x){
    if (x == 0){
        cout << 0;
        return;
    }
    string ans;
    while (x > 0){
        ans.push_back(x % 10 + '0');
        x /= 10;
    }
    reverse(ans.begin(), ans.end());
    cout << ans;
}

void check(){
    line pr;
    point now;
    for (int i = 0; i < 2 * n; i += 2){
        line a = make_line(pts[i], pts[i + 1]);
        if (i != 0){
            auto tmp = intersect(a, pr);

            if (!tmp.first)
                return;
            if (i > 2 && (now.x != tmp.second.x || now.y != tmp.second.y)){
                return;
            }
            now = tmp.second;
        }

        pr = a;
    }

    for (int i = 0; i < 2 * n; ++i)
        if (now.x == pts[i].x && now.y == pts[i].y)
            return;

    if (abs(now.x) > 1e6 || abs(now.y) > 1e6)
        return;

    cout << "Yes\n";
    print(now.x);
    cout << ' ';
    print(now.y);
    cout << '\n';
    exit(0);
}

int main()
{
    cin >> n;
    for (int i = 0; i < 2 * n; ++i){
        long long x, y;
        cin >> x >> y;
        pts.push_back({x, y});
    }
    sort(pts.begin(), pts.end());

    check();
    while (next_permutation(pts.begin(), pts.end())){
        check();
    }

    cout << "No\n";
    return 0;
}
