#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 1e4 + 239;
const int N = 2 * 1e3 + 239;
const ll MX = 1e6;

struct point
{
    int x, y;

    point()
    {
        x = y = 0;
    }

    point(int _x, int _y)
    {
        x = _x, y = _y;
    }

    bool operator==(const point &p) const
    {
        return (x == p.x && y == p.y);
    }
};

const point bad = point(MX + 1, MX + 1);

struct vect
{
    int x, y;

    vect()
    {
        x = y = 0;
    }

    vect(int _x, int _y)
    {
        x = _x, y = _y;
    }

    vect(point a, point b)
    {
        x = b.x - a.x, y = b.y - a.y;
    }

    bool operator==(const vect &p) const
    {
        return (x == p.x && y == p.y);
    }

    ll operator*(const vect &v) const
    {
        return ((ll)x * (ll)v.x + (ll)y * (ll)v.y);
    }

    ll operator^(const vect &v) const
    {
        return ((ll)x * (ll)v.y - (ll)y * (ll)v.x);
    }
};

struct line
{
    ll a, b, c;

    line()
    {
        a = b = c = 0;
    }

    line(ll _a, ll _b, ll _c)
    {
        a = _a, b = _b, c = _c;
    }

    line(point p, vect v)
    {
        a = -v.y;
        b = v.x;
        c = (ll)v.y * (ll)p.x - (ll)v.x * (ll)p.y;
    }
};

point inter(line l1, line l2)
{
    ll d = l1.a * l1.b - l1.b * l2.a;
    ll dx = -l1.c * l2.b + l2.c * l1.b;
    ll dy = -l1.a * l2.c + l2.a * l1.c;
    if (d < 0) d = -d, dx = -dx, dy = -dy; /// ????
    if (d == 0 || dx % d != 0 || dy % d != 0) return bad;
    if (abs(dx / d) > MX || abs(dy / d) > MX) return bad;
    return point((int)(dx / d), (int)(dy / d));
}

bool cmp(vect v1, vect v2)
{
    return ((v1 ^ v2) > 0);
}

int n;
point p[M];
vect v[M];

bool check(point t)
{
    for (int i = 0; i < 2 * n; i++)
    {
        v[i] = vect(t, p[i]);
        if (v[i] == vect(0, 0)) return false;
        if (v[i].y < 0)
            v[i].x = -v[i].x, v[i].y = -v[i].y;
        if (v[i].y == 0 && v[i].x < 0)
            v[i].x = -v[i].x;
    }
    sort(v, v + (2 * n), cmp);
    for (int i = 0; i < 2 * n; i += 2)
        if ((v[i] ^ v[i + 1]) != 0)
            return false;
    for (int i = 1; i < 2 * n - 1; i += 2)
        if ((v[i] ^ v[i + 1]) == 0)
            return false;
    return true;
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n;
    for (int i = 0; i < 2 * n; i++)
    {
        int x, y;
        cin >> x >> y;
        p[i] = point(x, y);
    }
    for (int i = 1; i < 2 * n; i++)
    {
        int x = (i == 1 ? 2 : 1);
        line l1 = line(p[0], vect(p[0], p[i]));
        for (int y = 1; y < 2 * n; y++)
            if (y != x && y != i)
            {
                line l2 = line(p[x], vect(p[x], p[y]));
                point nw = inter(l1, l2);
                if (nw == bad) continue;
                if (check(nw))
                {
                    cout << "Yes\n" << nw.x << " " << nw.y;
                    return 0;
                }
            }
    }
    cout << "No\n";
    return 0;
}
