#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_ll (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const ll BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const ll M = 1e4 + 239;
const ll N = 2 * 1e3 + 239;
const ll MX = 1e6;

struct poll
{
    ll x, y;

    poll()
    {
        x = y = 0;
    }

    poll(ll _x, ll _y)
    {
        x = _x, y = _y;
    }

    bool operator==(const poll &p) const
    {
        return (x == p.x && y == p.y);
    }
};

const poll bad = poll(MX + 1, MX + 1);

struct vect
{
    ll x, y;

    vect()
    {
        x = y = 0;
    }

    vect(ll _x, ll _y)
    {
        x = _x, y = _y;
    }

    vect(poll a, poll b)
    {
        x = b.x - a.x, y = b.y - a.y;
    }

    bool operator==(const vect &p) const
    {
        return (x == p.x && y == p.y);
    }

    ll operator*(const vect &v) const
    {
        return ((ll)x * (ll)v.x + (ll)y * (ll)v.y);
    }

    ll operator^(const vect &v) const
    {
        return ((ll)x * (ll)v.y - (ll)y * (ll)v.x);
    }
};

struct line
{
    ll a, b, c;

    line()
    {
        a = b = c = 0;
    }

    line(ll _a, ll _b, ll _c)
    {
        a = _a, b = _b, c = _c;
    }

    line(poll p, vect v)
    {
        a = -v.y;
        b = v.x;
        c = (ll)v.y * (ll)p.x - (ll)v.x * (ll)p.y;
    }
};

inline ll md(ll a, ll b)
{
    if (a % b == 0) return 0;
    if (a >= 0) return (a % b);
    return -(abs(a) % b) - 1;
}

inline ll dv(ll a, ll b)
{
    return (a - md(a, b)) / b;
}

poll ller(line l1, line l2)
{
    ll d = l1.a * l1.b - l1.b * l2.a;
    if (d == 0) return bad;
    ll kk = 1;
    if (d < 0) kk = -1, d = -d;
    if (md(l2.c * l1.b, d) != md(l1.c * l2.b, d)) return bad;
    ll dx = -dv(l1.c * l2.b, d) + dv(l2.c * l1.b, d);
    if (md(l1.a * l2.c, d) != md(l2.a * l1.c, d)) return bad;
    ll dy = -dv(l1.a * l2.c, d) + dv(l2.a * l1.c, d);
    if (abs(dx) > MX || abs(dy) > MX) return bad;
    return poll(dx * kk, dy * kk);
}

bool cmp(vect v1, vect v2)
{
    return ((v1 ^ v2) > 0);
}

ll n;
poll p[M];
vect v[M];

bool check(poll t)
{
    for (ll i = 0; i < 2 * n; i++)
    {
        v[i] = vect(t, p[i]);
        if (v[i] == vect(0, 0)) return false;
        if (v[i].y < 0)
            v[i].x = -v[i].x, v[i].y = -v[i].y;
        if (v[i].y == 0 && v[i].x < 0)
            v[i].x = -v[i].x;
    }
    sort(v, v + (2 * n), cmp);
    for (ll i = 0; i < 2 * n; i += 2)
        if ((v[i] ^ v[i + 1]) != 0)
            return false;
    for (ll i = 1; i < 2 * n - 1; i += 2)
        if ((v[i] ^ v[i + 1]) == 0)
            return false;
    return true;
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n;
    for (ll i = 0; i < 2 * n; i++)
    {
        ll x, y;
        cin >> x >> y;
        p[i] = poll(x, y);
    }
    for (ll i = 1; i < 2 * n; i++)
    {
        ll x = (i == 1 ? 2 : 1);
        line l1 = line(p[0], vect(p[0], p[i]));
        for (ll y = 1; y < 2 * n; y++)
            if (y != x && y != i)
            {
                line l2 = line(p[x], vect(p[x], p[y]));
                poll nw = ller(l1, l2);
                if (nw == bad) continue;
                if (check(nw))
                {
                    cout << "Yes\n" << nw.x << " " << nw.y;
                    return 0;
                }
            }
    }
    cout << "No\n";
    return 0;
}
