#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 1e4 + 239;
const int N = 2 * 1e3 + 239;
const ll MX = 1e6;

struct point
{
    int x, y;

    point()
    {
        x = y = 0;
    }

    point(int _x, int _y)
    {
        x = _x, y = _y;
    }

    bool operator==(const point &p) const
    {
        return (x == p.x && y == p.y);
    }

    bool operator<(const point &p) const
    {
        return ((x != p.x) ? (x < p.x) : (y < p.y));
    }

    ll func()
    {
        return (x * MX + y);
    }
};

const point bad = point(MX + 1, MX + 1);

struct vect
{
    int x, y;

    vect()
    {
        x = y = 0;
    }

    vect(int _x, int _y)
    {
        x = _x, y = _y;
    }

    vect(point a, point b)
    {
        x = b.x - a.x, y = b.y - a.y;
    }

    bool operator==(const vect &p) const
    {
        return ((ll)x * (ll)p.y == (ll)y * (ll)p.x);
    }

    ll operator*(const vect &v) const
    {
        return ((ll)x * (ll)v.x + (ll)y * (ll)v.y);
    }

    ll operator^(const vect &v) const
    {
        return ((ll)x * (ll)v.y - (ll)y * (ll)v.x);
    }

    vect norm()
    {
        int x1 = x;
        int y1 = y;
        if (y1 < 0) y1 = -y1, x1 = -x1;
        if (y1 == 0 && x1 < 0) x1 = -x1;
        return vect(x1, y1);
    }

    bool operator<(const vect &v) const
    {
        return (((ll)x * (ll)v.y - (ll)y * (ll)v.x) > 0);
    }
};

struct line
{
    ll a, b, c;

    line()
    {
        a = b = c = 0;
    }

    line(ll _a, ll _b, ll _c)
    {
        a = _a, b = _b, c = _c;
    }

    line(point p, vect v)
    {
        a = -v.y;
        b = v.x;
        c = (ll)v.y * (ll)p.x - (ll)v.x * (ll)p.y;
    }

    bool in(point p)
    {
        return ((a * (ll)p.x + b * (ll)p.y + c) == 0);
    }
};

point inter(line l1, line l2)
{
    ll d = l1.a * l2.b - l1.b * l2.a;
    if (d == 0) return bad;
    ll dx = -l1.c * l2.b + l2.c * l1.b;
    ll dy = -l1.a * l2.c + l2.a * l1.c;
    if (dx % d != 0 || dy % d != 0) return bad;
    dx /= d, dy /= d;
    if (abs(dx) > MX || abs(dy) > MX) return bad;
    return point(dx, dy);
}

int n;
point p[M];
vect v[M];

bool check(point t)
{
    for (int i = 0; i < 2 * n; i++)
    {
        v[i] = vect(t, p[i]);
        if (v[i].x == 0 && v[i].y == 0) return false;
        v[i] = v[i].norm();
    }
    for (int u = 0; u < 3; u++)
    {
        int tt = (rand_int % (2 * n));
        int kol = 0;
        for (int i = 0; i < 2 * n; i++)
            kol += ((v[i] ^ v[tt]) == 0);
        if (kol != 2) return false;
    }
    sort(v, v + (2 * n));
    for (int i = 0; i < 2 * n; i += 2)
        if ((v[i] ^ v[i + 1]) != 0)
            return false;
    for (int i = 1; i < 2 * n - 1; i += 2)
        if ((v[i] ^ v[i + 1]) == 0)
            return false;
    return true;
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n;
    for (int i = 0; i < 2 * n; i++)
    {
        int x, y;
        cin >> x >> y;
        p[i] = point(x, y);
    }
    set<vect> b1;
    for (int i = 1; i < 2 * n; i++)
    {
        int x = (i == 1 ? 2 : 1);
        if (b1.find(vect(p[0], p[i]).norm()) != b1.end()) continue;
        b1.insert(vect(p[0], p[i]).norm());
        line l1 = line(p[0], vect(p[0], p[i]));
        set<vect> be;
        for (int y = 1; y < 2 * n; y++)
            if (y != x && y != i)
            {
                if (l1.in(p[x]) || l1.in(p[y])) continue;
                if (be.find(vect(p[x], p[y]).norm()) != be.end()) continue;
                line l2 = line(p[x], vect(p[x], p[y]));
                be.insert(vect(p[x], p[y]).norm());
                point nw = inter(l1, l2);
                if (nw == bad) continue;
                if (check(nw))
                {
                    cout << "Yes\n" << nw.x << " " << nw.y;
                    return 0;
                }
            }
    }
    cout << "No\n";
    //cerr << TIME << "\n";
    return 0;
}
