#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>
#include <set>
#include <map>

#define y1 ups
#define int long long

using namespace std;

const int maxn = 2e5 + 88;
const int inf = 1e9 + 88;

int x[maxn], y[maxn];
int n;

bool is(int x, int y, int px, int py, int dx, int dy)
{
    return (x - px)*dy == (y - py)*dx;
}

bool check(int px, int py)
{
    int i, j;
    for (i = 0; i < n; i++)
        if (px == x[i] && py == y[i])
            return false;
    for (i = 0; i < n; i++)
    {
        int x1 = px, y1 = py;
        int dx = x[i] - px, dy = y[i] - py;
        int g = __gcd(abs(dx), abs(dy));
        dx /= g;
        dy /= g;
        int cnt = 0;
        for (j = 0; j < n; j++)
            if (i != j && is(x[j], y[j], x1, y1, dx, dy))
                cnt++;
        if (cnt != 1)
            return false;
    }
    return true;
}

#undef int

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
    int i, j, k, a, b;
    cin >> n;
    n *= 2;
    for (i = 0; i < n; i++)
        cin >> x[i] >> y[i];
    for (a = 0; a < n; a++)
        for (b = a + 1; b < n; b++)
        {
            int x1 = x[a], y1 = y[a];
            int dx = x[b] - x[a], dy = y[b] - y[a];
            int g = __gcd(abs(dx), abs(dy));
            dx /= g;
            dy /= g;
            int curx = x1, cury = y1;
            while (abs(curx) <= (int)1e6 && abs(cury) <= (int)1e6)
            {
                if (check(curx, cury))
                {
                    cout << "Yes\n";
                    cout << curx << " " << cury;
                    return 0;
                }
                curx += dx;
                cury += dy;
            }
            curx = x1, cury = y1;
            while (abs(curx) <= (int)1e6 && abs(cury) <= (int)1e6)
            {
                if (check(curx, cury))
                {
                    cout << "Yes\n";
                    cout << curx << " " << cury;
                    return 0;
                }
                curx -= dx;
                cury -= dy;
            }
        }
    cout << "No";
    return 0;
}
