// ConsoleApplication1.cpp: определяет точку входа для консольного приложения.
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <time.h>
#include <bitset>
typedef long long ll;
typedef long double db;
using namespace std;
#define fs first
#define sc second
#define endl '\n'
#define sz(g) int(g.size())
#define all(g) (g.begin()),(g.end())
#define mp make_pair
#define int ll

struct Vector {
	int x, y;
	Vector(int xx = 0, int yy = 0) :x(xx), y(yy) {}
	Vector operator +(Vector d) {
		return Vector(x + d.x, y + d.y);
	}
	friend istream& operator >>(istream &in, Vector &d) {
		in >> d.x >> d.y;
		return in;
	}
};

struct Line {
	int a, b, c;
	Line(Vector d, Vector e) {
		a = d.y - e.y;
		b = e.x - d.x;
		c = d.x*e.y - e.x*d.y;
	}
	Line(int aa = 0, int bb = 0, int cc = 0) :a(aa), b(bb), c(cc) {}
};

Vector merge(Line a, Line b) {
	int del = a.a*b.b - b.a*a.b;
	if (del == 0) return Vector(1e9, 1e9);
	if (abs(b.b*a.c + b.c*a.b) % abs(del) == 0 && abs(-b.c*a.a - b.a*a.c) % abs(del) == 0) {
		return Vector(-(b.b*a.c - b.c*a.b) / (del), -(b.c*a.a - b.a*a.c) / del);
	}
	return Vector(1e9, 1e9);
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(NULL));
	int n;
	cin >> n;
	n = n * 2;
	set<pair<int, int>> s;
	vector<Vector> w(n);
	map<int, map<int, int>> m;
	for (int i = 0; i < n; i++) {
		cin >> w[i];
		s.insert(mp(w[i].x, w[i].y));
	}random_shuffle(all(w));
	Line c = Line(w[0], w[2]);
	Line d = Line(w[1], w[3]);
	Vector res = merge(c, d);
	if (int(abs(res.x)) <= int(1e6) && int(abs(res.y)) <= int(1e6) && s.find(mp(res.x, res.y)) == s.end()) {
		cout << "Yes" << endl << res.x << ' ' << res.y << endl;
		return 0;
	}
	c = Line(w[0], w[1]);
	d = Line(w[2], w[3]);
	res = merge(c, d);
	if (int(abs(res.x)) <= int(1e6) && int(abs(res.y)) <= int(1e6) && s.find(mp(res.x, res.y)) == s.end()) {
		cout << "Yes" << endl << res.x << ' ' << res.y << endl;
		return 0;
	}
	c = Line(w[0], w[3]);
	d = Line(w[1], w[2]);
	res = merge(c, d);
	if (int(abs(res.x)) <= int(1e6) && int(abs(res.y)) <= int(1e6) && s.find(mp(res.x, res.y)) == s.end()) {
		cout << "Yes" << endl << res.x << ' ' << res.y << endl;
		return 0;
	}
	cout << "No" << endl;
	return 0;
	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int e = 0; e < n; e++) {
				for (int r = 0; r < n; r++) {
					if (i == j || i == e || i == r || j == e || j == r || e == r)continue;
					Line c = Line(w[i], w[j]);
					Line d = Line(w[e], w[r]);
					Vector res = merge(c, d);
					if (abs(res.x) <= 1e6 && abs(res.y) <= 1e6)
						m[res.x][res.y]++;
				}
			}
		}
	}
	for (map<int, map<int, int>>::iterator p = m.begin(); p != m.end(); p++) {
		for (map<int, int>::iterator q = p->sc.begin(); q != p->sc.end(); q++) {
			if (q->sc >= ((n / 2)*((n / 2) - 1) * 2)) {
				if (s.find(mp(p->fs, q->fs)) != s.end())continue;
				cout << "Yes" << endl;
				cout << p->fs << ' ' << q->fs << endl;
#ifdef _MSC_VER
				system("pause");
#endif
				return 0;
			}
		}
	}
	cout << "No" << endl;
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}


/*
vector<vector<int>> Edge;
vector<int> c;
int ans = 0;


struct Node {
	int sum, minn, col;
	Node(int ss, int mm, int cc) :sum(ss), minn(mm), col(cc) {}
};

Node dfs(int v) {
	set<pair<int, int>> s;
	multiset<int> w;
	int sum = 0;
	int col = 0;
	for (int i = 0; i < Edge[v].size(); i++) {
		Node res = dfs(Edge[v][i]);
		sum += res.sum;
		col += res.col;
		s.insert(mp(res.col, res.minn));
		w.insert(res.minn);
	}
	if (s.size() == 0)
		return Node(c[v], c[v], 1);
	int del = 0;
	if (col - s.rbegin()->fs >= s.rbegin()->fs)
		del += sum + (col % 2 == 1 ? *w.begin() : 0);
	else {
		w.erase(w.find(s.rbegin()->sc));
		del += sum + (s.rbegin()->fs * 2LL - col)*(*w.begin());
		w.insert(s.rbegin()->sc);
	}
	ans += del;
	return Node(sum + c[v], min(c[v], *w.begin()), col + 1LL);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	Edge.resize(n);
	c.resize(n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		Edge[p].push_back(i);
	}
	c[0] = 0;
	for (int i = 1; i < n; i++)
		cin >> c[i];
	dfs(0);
	cout << ans << endl;
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}
*/

/*
const int siz = 5e6 + 5;
int alp[siz][2];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.size();
	if (n <= 5e5) {
		vector<int> del;
		for (int i = 1; i*i <= n; i++) {
			if (n%i == 0) {
				del.push_back(i);
				del.push_back(n / i);
			}
		}
		sort(all(del));
		del.resize(unique(all(del)) - del.begin());
		for (int i = 0; i < del.size(); i++) {
			int ans = n / del[i];
			vector<int> al(26, 0);
			bool answ = true;
			for (int j = 0; j < del[i]; j++) {
				al[s[j] - 'a']++;
			}
			for (int j = 1; j < ans; j++) {
				vector<int> al1(26, 0);
				for (int e = j * del[i]; e < (j + 1)*del[i]; e++) {
					al1[s[e] - 'a']++;
				}
				if (al1 != al) {
					answ = false;
					break;
				}
			}
			if (answ) {
				cout << ans << endl;
				return 0;
			}
		}
	}
	else {
		vector<int> del;
		for (int i = 1; i*i <= n; i++) {
			if (n%i == 0) {
				del.push_back(i);
				del.push_back(n / i);
			}
		}
		alp[0][0] = 0;
		alp[0][1] = 0;
		for (int i = 0; i < s.size(); i++) {
			alp[i + 1][0] = alp[i][0];
			alp[i + 1][1] = alp[i][1];
			alp[i + 1][s[i] - 'a']++;
		}
		sort(all(del));
		del.resize(unique(all(del)) - del.begin());
		for (int i = 0; i < del.size(); i++) {
			int ans = n / del[i];
			int al[2];
			al[0] = alp[del[i]][0];
			al[1] = alp[del[i]][1];
			bool answ = true;
			for (int j = 1; j < ans; j++) {
				vector<int> al1(26, 0);
				al1[0] = alp[del[i] * (j + 1)][0] - alp[del[i] * (j)][0];
				al1[1] = alp[del[i] * (j + 1)][1] - alp[del[i] * (j)][1];
				if (al1[0] != al[0] || al1[1] != al[1]) {
					answ = false;
					break;
				}
			}
			if (answ) {
				cout << ans << endl;
				return 0;
			}
		}
	}
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}
*/
/*
const int max_n = 1 << 17;
struct Node {
    int x;
    Node(int xx = 0) :x(xx) {}
    Node operator +(Node d) {
        return Node(x + d.x);
    }
};

struct Segment_Tree {
#define tm (tl+tr)/2
    vector<Node> t;
    Segment_Tree() {
        t.resize(max_n * 2, Node());
    }
    void add(int l, int r, int res) {
        add_el(0, max_n - 1, l, r, 1, res);
    }
    int get(int l, int r) {
        get_seg(0, max_n - 1, l, r, 1);
    }
    void add_el(int tl, int tr, int l, int r, int v,int res) {
        if (tl > r || tr < l)
            return;
        if (tl >= l && tr <= r) {
            t[v].x += res;
            return;
        }
        add_el(tl, tm, l, r, v * 2, res);
        add_el(tm + 1, tr, l, r, v * 2 + 1, res);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get_seg(int tl, int tr, int l, int r, int v) {
        if (tl > r || tr < l)
            return 0;
        if (tl >= l && tr <= r)
            return t[v].x;
        return get_seg(tl, tm, l, r, v * 2) + get_seg(tm + 1, tr, l, r, v * 2 + 1);
    }
#undef tm
};
*/
