#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <string>

using namespace std;
const int alf_len = 'z' - 'a' + 1;
const long long mod1 = 1000000007;
const long long mod2 = 1000000009;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

long long power(long long n, long long p, long long m) {
    long long tmp;
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        tmp = power(n, p / 2, m);
        return (tmp * tmp) % m;
    }
    tmp = power(n, p - 1, m);
    return (tmp * n) % m;
}

long long div(long long a, long long b, long long m) {
    long long tmp;
    tmp = power(b, m - 2, m);
    return (a * tmp) % m;
}

long long hash_(vector <long long> &h, int l, int r, long long mod) {
    return div(h[r], h[l], mod);
}

int main() {
    ifstream fin("input.txt");
    string s1;
    int n, m, len;
    long long need1, need2;
    bool flag;
    fin >> s1;
    n = s1.size();
    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = s1[i] - 'a';
    }
    vector <int> nums(alf_len, 0);
    vector <int> tmp_primes;
    tmp_primes.reserve(60);
    for (int i = 2; tmp_primes.size() < 60; i++) {
        //cout << i << ' ' << tmp_primes.size() << '\n';
        flag = true;
        for (int j = 2; j * j <= i; j++) {
            if (i % j == 0) {
                flag = false;
            }
        }
        if (flag) {
            tmp_primes.push_back(i);
        }
    }
/*
    for (int i = 0; i < 60; i++) {
        cout << tmp_primes[i] << ' ';
    }
*/
    vector <int> primes(alf_len);
    for (int i = 0; i < alf_len; i++) {
        primes[i] = tmp_primes[i + 15];
    }
    vector <long long> hash1(n + 1);
    vector <long long> hash2(n + 1);
    hash1[0] = 1;
    hash2[0] = 1;
    for (int i = 0; i < n; i++) {
        hash1[i + 1] = (hash1[i] * primes[s[i]]) % mod1;
        hash2[i + 1] = (hash2[i] * primes[s[i]]) % mod2;
        nums[s[i]]++;
    }
    m = 0;
    for (int i = 0; i < alf_len; i++) {
        m = gcd(m, nums[i]);
    }
    for (int i = m; i >= 1; i--) {
        if (m % i == 0) {
            need1 = 1;
            need2 = 1;
            len = n / i;
            for (int j = 0; j < alf_len; j++) {
                need1 = (need1 * power(primes[j], nums[j] / i, mod1)) % mod1;
                need2 = (need2 * power(primes[j], nums[j] / i, mod2)) % mod2;
            }
            flag = true;
            for (int j = 0; j < i; j++) {
                if ((need1 * hash1[j * len]) % mod1 != hash1[(j + 1) * len]) {
                    flag = false;
                    break;
                }
                if ((need2 * hash2[j * len]) % mod2 != hash2[(j + 1) * len]) {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                cout << i << '\n';
                return 0;
            }
        }
    }
    return 0;
}
