#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;
const long long max_coor = 1000000;

struct point{
    long long x, y;
};

bool operator < (point p1, point p2) {
    if (p1.x < p2.x) {
        return true;
    }
    if (p1.x == p2.x && p1.y < p2.y) {
        return true;
    }
    return false;
}

long long cross_prod(point p1, point p2) {
    return p1.x * p2.y - p1.y * p2.x;
}

point operator - (point p1, point p2) {
    point res;
    res.x = p1.x - p2.x;
    res.y = p1.y - p2.y;
    return res;
}

bool operator != (point p1, point p2) {
    if (p1.x == p2.x && p1.y == p2.y) {
        return false;
    }
    return true;
}

bool operator == (point p1, point p2) {
    if (p1.x == p2.x && p1.y == p2.y) {
        return true;
    }
    return false;
}

pair <point, bool> cross(point p1, point p2, point p3, point p4) {
    point res;
    bool flag;
    flag = true;
    if (cross_prod(p2 - p1, p3 - p4) == 0) {
        res.x = 0;
        res.y = 0;
        flag = false;
    }
    else {
        if ((cross_prod(p3, p4) * (p2.x - p1.x) - cross_prod(p1, p2) * (p4.x - p3.x)) % cross_prod(p3 - p4, p2 - p1)) {
            flag = false;
        }
        res.x = (cross_prod(p3, p4) * (p2.x - p1.x) - cross_prod(p1, p2) * (p4.x - p3.x)) / cross_prod(p3 - p4, p2 - p1);
        if ((cross_prod(p4, p3) * (p2.y - p1.y) - cross_prod(p2, p1) * (p4.y - p3.y)) % cross_prod(p2 - p1, p3 - p4)) {
            flag = false;
        }
        res.y = (cross_prod(p4, p3) * (p2.y - p1.y) - cross_prod(p2, p1) * (p4.y - p3.y)) / cross_prod(p2 - p1, p3 - p4);
    }
    if (abs(res.x) > max_coor || abs(res.y) > max_coor) {
        res.x = 0;
        res.y = 0;
        flag = false;
    }
    return make_pair(res, flag);
}

bool check(vector <point> &v, point p, int len) {
    for (int i = 0; i < len; i++) {
        if (v[i] == p) {
            return false;
        }
    }
    return true;
}

int main() {
    ifstream fin("input.txt");
    int n, len;
    fin >> n;
    len = n * 2;
    vector <point> v(len);
    for (int i = 0; i < len; i++) {
        fin >> v[i].x >> v[i].y;
    }
    vector <pair <point, bool> > res(6);
    res[0] = cross(v[0], v[1], v[2], v[3]);
    res[1] = cross(v[0], v[2], v[1], v[3]);
    res[2] = cross(v[0], v[3], v[2], v[1]);
    res[3] = cross(v[0], v[2], v[3], v[1]);
    res[4] = cross(v[0], v[3], v[1], v[2]);
    res[5] = cross(v[0], v[1], v[3], v[2]);
    for (int i = 0; i < 6; i++) {
        //cout << i << ' ' << res[i].second << ' ' << res[i].first.x << ' ' << res[i].first.y << '\n';
        if (res[i].second && check(v, res[i].first, len)) {
            //cout << i << ' ' << res[i].second << ' ' << res[i].first.x << ' ' << res[i].first.y << ' ' << check(v, res[i].first, len) << '\n';
            cout << "Yes\n";
            cout << res[i].first.x << ' ' << res[i].first.y << '\n';
            return 0;
        }
        //cout << i << ' ' << res[i].second << ' ' << res[i].first.x << ' ' << res[i].first.y << '\n';
    }
    cout << "No\n";
    return 0;
}
