#include <bits/stdc++.h>

using namespace std;

//#define int int64_t

template<typename _T>
inline void _DBG(const char *s, _T x);

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a);

#ifdef LOCAL
#define DBG(...) _DBG(#__VA_ARGS__, __VA_ARGS__)
#else
#define endl "\n"
#define DBG(...) (true)
#define cerr if(0) cout
#endif

template<typename type>
istream &operator>>(istream &in, vector<type> &a);

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a);

ostream &operator<<(ostream &out, const vector<int> &a);

ostream &operator<<(ostream &out, const vector<double> &a);

ostream &operator<<(ostream &out, const vector<bool> &a);

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a);

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a);

template<typename T, typename... args>
T max(const T &, args...);

template<typename T>
T max(const T &, const T &, const T &);

template<typename T>
T pow2(const T &);

template<typename T>
T Power(const T &, int, const T &);


// ********************** CODE ********************** //

void dfs(int v, vector<vector<int> > &gr, vector<int> &mn, vector<int> &dp, vector<int> &c, vector<int> &sz, vector<int> &sum) {
    mn[v] = c[v];
    for (auto &x : gr[v]) {
        dfs(x, gr, mn, dp, c, sz, sum);
        dp[v] += dp[x];
        sz[v] += sz[x];
        mn[v] = min(mn[v], mn[x]);
        sum[v] += sum[x];
    }
    sz[v] += 1;
    sum[v] += c[v];
    if (gr[v].size() == 0) return;
    sort(gr[v].begin(), gr[v].end(), [mn](int x, int y) { return mn[x] < mn[y]; });
    int maxs = sz[gr[v][0]], maxsind = 0;
    int res = sum[gr[v][0]];
    for (int i = 1; i < (int) gr[v].size(); ++i) {
        if (sz[gr[v][i]] > maxs) {
            maxs = sz[gr[v][i]];
            maxsind = i;
        }
        res += sum[gr[v][i]];
    }
    for (int i = 0; i < (int) gr[v].size(); ++i) {
        if (i != maxsind) {
            maxs -= sz[gr[v][i]];
        }
    }
    if (maxs < 0) {
        maxs = (-maxs) % 2;
        maxsind = -1;
    }
    if (maxsind == 0) {
        dp[v] += res + mn[gr[v][1]] * maxs;
    } else {
        dp[v] += res + mn[gr[v][0]] * maxs;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int> > gr(n);
    vector<int> c(n);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        gr[x - 1].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }
    vector<int> dp(n);
    vector<int> mn(n);
    vector<int> sz(n);
    vector<int> sum(n);
    dfs(0, gr, mn, dp, c, sz, sum);
    cout << dp[0] << endl;
    return 0;
}


// ********************* END OF CODE ********************* //


template<typename T>
T Power(const T &a, int n, const T &mod) {
    if (n == 0) {
        return 1;
    }
    if (n % 2) {
        return (a * Power(a, n - 1, mod)) % mod;
    }
    T res = Power(a, n / 2, mod);
    return (res * res) % mod;
}

template<typename T>
T pow2(const T &a) {
    return a * a;
}

template<typename _T>
inline void _DBG(const char *s, _T x) {
    cout << s << " = " << x << "\n";
}

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a) {
    int b = 0;
    while (*s != ',' || b != 0) {
        b += (*s) == '(';
        b -= (*s) == ')';
        cout << *s++;
    }
    cout << " = " << x << ',';
    _DBG(s + 1, a...);
}

template<typename T>
T max(const T &a) {
    return a;
}


template<typename T>
T max(const T &a, const T &b, const T &c) {
    return max(max(a, b), c);
}


template<typename T, typename... args>
T max(const T &a, args... b) {
    T res = ::max(b...);
    return a > res ? a : res;
}

ostream &operator<<(ostream &out, const vector<bool> &a) {
    for (auto x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a) {
    out << a.first << " " << a.second;
    return out;
}

ostream &operator<<(ostream &out, const vector<double> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

template<typename type>
istream &operator>>(istream &in, vector<type> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

