#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll INF = 1e18;
const ll SZ = 2e5 + 10;

ll n;
ll price[SZ];
vector<ll> graph[SZ];

ll size_of[SZ];
ll res[SZ];
ll min_val[SZ];
ll sum[SZ];

void dfs(ll v)
{
    min_val[v] = INF;
    ll max_son = 0;
    for (ll to : graph[v]) {
        dfs(to);
        size_of[v] += size_of[to];
        sum[v] += sum[to];
        min_val[v] = min(min_val[v], min_val[to]);
        if (max_son == 0 || size_of[to] > size_of[max_son])
            max_son = to;
    }
    res[v] = sum[v];
    if (size_of[max_son] * 2 > size_of[v]) {
        ll min_now = INF;
        for (ll to : graph[v]) {
            if (to != max_son)
                min_now = min(min_now, min_val[to]);
        }
        res[v] += (size_of[max_son] * 2 - size_of[v]) * min_now;
    }
    else if (size_of[v] & 1)
        res[v] += min_val[v];

    size_of[v]++;
    sum[v] += price[v];
    min_val[v] = min(min_val[v], price[v]);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (ll i = 2; i <= n; i++) {
        ll a;
        cin >> a;
        graph[a].push_back(i);
    }
    for (ll i = 2; i <= n; i++)
        cin >> price[i];
    dfs(1);
    ll ans = 0;
    for (ll i = 1; i <= n; i++)
        ans += res[i];
    cout << ans;
    return 0;
}
