#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

struct point {
    int x, y;
};

int n;

int gcd(int a, int b)
{
    if (a == 0)
        return b;
    return gcd(b % a, a);
}

int get_det(int a, int b, int c, int d)
{
    return a * d - b * c;
}

point straight_and_straight(point A, point B, point C, point D)
{
    int a1 = B.y - A.y;
    int b1 = A.x - B.x;
    int c1 = A.y * B.x - A.x * B.y;
    int a2 = D.y - C.y;
    int b2 = C.x - D.x;
    int c2 = C.y * D.x - C.x * D.y;
    if (get_det(a1, b1, a2, b2) == 0)
        return {INF, INF};
    int X = get_det(b1, c1, b2, c2) / get_det(a1, b1, a2, b2);
    int Y = get_det(c1, a1, c2, a2) / get_det(a1, b1, a2, b2);
    if (a1 * X + b1 * Y + c1 != 0 || a2 * X + b2 * Y + c2 != 0)
        return {INF, INF};
    return {X, Y};
}

bool is_clear(point M, point A, point B, point C, point D)
{
    if (M.x == A.x && M.y == A.y)
        return false;
    if (M.x == B.x && M.y == B.y)
        return false;
    if (M.x == C.x && M.y == C.y)
        return false;
    if (M.x == D.x && M.y == D.y)
        return false;
    return true;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    point A, B, C, D;
    cin >> n;
    if (n == 1) {
        cin >> A.x >> A.y >> B.x >> B.y;
        int g = gcd(abs(B.x - A.x), abs(B.y - A.y));
        point my_vect;
        my_vect.x = (B.x - A.x) / g;
        my_vect.y = (B.y - A.y) / g;
        point C;
        if (B.x == A.x + my_vect.x) {
            C.x = A.x + my_vect.x * 2;
            C.y = A.y + my_vect.y * 2;
        }
        else {
            C.x = A.x + my_vect.x;
            C.y = A.y + my_vect.y;
        }
        if (abs(C.x) <= 1e6 && abs(C.y) <= 1e6) {
            cout << "Yes\n";
            cout << C.x << ' ' << C.y;
            return 0;
        }
        if (B.x == A.x - my_vect.x) {
            C.x = A.x - my_vect.x * 2;
            C.y = A.y - my_vect.y * 2;
        }
        else {
            C.x = A.x - my_vect.x;
            C.y = A.y - my_vect.y;
        }
        if (abs(C.x) <= 1e6 && abs(C.y) <= 1e6) {
            cout << "Yes\n";
            cout << C.x << ' ' << C.y;
            return 0;
        }
        cout << "No";
        return 0;
    }
    else if (n == 2) {
        cin >> A.x >> A.y >> B.x >> B.y >> C.x >> C.y >> D.x >> D.y;
        point M = straight_and_straight(A, B, C, D);
        if (M.x != INF && is_clear(M, A, B, C, D)) {
            cout << "Yes\n" << M.x << ' ' << M.y;
            return 0;
        }
        M = straight_and_straight(A, C, B, D);
        if (M.x != INF && is_clear(M, A, B, C, D)) {
            cout << "Yes\n" << M.x << ' ' << M.y;
            return 0;
        }
        M = straight_and_straight(A, D, B, C);
        if (M.x != INF && is_clear(M, A, B, C, D)) {
            cout << "Yes\n" << M.x << ' ' << M.y;
            return 0;
        }
        cout << "No";
    }
    else
        cout << "Yes\n" << 2 << ' ' << 2;
    return 0;
}
