#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

#define endl '\n'

vector<vector<int> > grph;
vector<int> cnt;
vector<vector<multiset<int> > > child;

void dfs(int v) {
	for (auto u : grph[v]) {
		dfs(u);
		child[v].resize(child[v].size() + 1);
		for (int i = 0; i < child[u].size(); i++) {
			for (auto j = child[u][i].begin(); j != child[u][i].end(); j++) {
				child[v].back().insert(*j);
			}
		}
		child[v].back().insert(cnt[u]);
	}
	return;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;

	int p;
	grph.resize(n);
	cnt.resize(n);
	child.resize(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> p;
		grph[p - 1].push_back(i + 1);
	}

	for (int i = 1; i < n; i++) {
		cin >> cnt[i];
	}

	dfs(0);

	int ans = 0;
	const int INF = 1e6;
	for (int i = 0; i < n; i++) {
		if (grph[i].size() > 0) {
			multiset<pair<int, int> > weight;
			auto child2 = child;
			for (int j = 0; j < child2[i].size(); j++) {
				weight.insert({ *child2[i][j].rbegin(), j });
			}
			while (weight.size() > 1) {
				int ind1 = weight.rbegin()->second;
				int el = weight.rbegin()->first;
				ans += el;
				weight.erase(*weight.rbegin());
				child2[i][ind1].erase(child2[i][ind1].find(el));
				int ind2 = weight.rbegin()->second;
				el = weight.rbegin()->first;
				ans += el;
				weight.erase(*weight.rbegin());
				child2[i][ind2].erase(child2[i][ind2].find(el));
				if (!child2[i][ind1].empty()) {
					weight.insert({ *child2[i][ind1].rbegin(), ind1 });
				}
				if (!child2[i][ind2].empty()) {
					weight.insert({ *child2[i][ind2].rbegin(), ind2 });
				}
			}
			if (weight.size() > 0) {
				int mn = INF;
				for (int j = 0; j < child[i].size(); j++) {
					if (j != weight.begin()->second) {
						mn = min(mn, *child[i][j].begin());
					}
				}
				for (auto j = child2[i][weight.begin()->second].begin(); j != child2[i][weight.begin()->second].end(); j++) {
					ans += mn + *j;
				}
			}
		}
	}
	cout << ans;
}