#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 510;
const long long MAXK = 1000000;

struct point
{
	long long x, y;
	point()
	{
		x = 0;
		y = 0;
	}
	point(long long x, long long y)
	{
		this->x = x;
		this->y = y;
	}
};

struct line
{
	long long a, b, c;
	line()
	{
		a = 0;
		b = 0;
		c = 0;
	}
	line(point a, point b)
	{
		this->a = a.y - b.y;
		this->b = b.x - a.x;
		this->c = -(this->a) * a.x - (this->b) * a.y;
	}
};

int n;
point poi[MAXN];
set< long long > w;

bool para(line l1, line l2);

bool pereze(line l1, line l2);

point pere(line l1, line l2);

long long konv(point p);

bool nali(point p, line l);

bool cheklu(point p);

bool kans(line l1, line l2);

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	//cout << fixed << setprecision(20);
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; i++)
	{
		cin >> poi[i].x >> poi[i].y;
		w.insert(konv(poi[i]));
	}

	if (kans(line(poi[0], poi[1]),
		line(poi[2], poi[3])))
		return 0;

	if (kans(line(poi[0], poi[2]),
		line(poi[1], poi[3])))
		return 0;

	if (kans(line(poi[0], poi[3]),
		line(poi[1], poi[2])))
		return 0;

	cout << "No\n";
    return 0;
}

bool para(line l1, line l2)
{
	return (l1.a * l2.b == l2.a * l1.b);
}

bool pereze(line l1, line l2)
{
	if (para(l1, l2))
		return false;
	long long kok = l1.a * l2.b - l2.a * l1.b;
	long long xp, yp;
	xp = (l1.c * l2.b - l2.c * l1.b);
	yp = (l1.a * l2.c - l2.a * l1.c);
	return (xp % kok == 0 && yp % kok == 0);
}

point pere(line l1, line l2)
{
	long long kok = l1.a * l2.b - l2.a * l1.b;
	point per;
	per.x = -(l1.c * l2.b - l2.c * l1.b) / kok;
	per.y = -(l1.a * l2.c - l2.a * l1.c) / kok;
	return per;
}

long long konv(point p)
{
	return p.x * (MAXK + 1) + p.y;
}

bool nali(point p, line l)
{
	return (l.a * p.x + l.b * p.y + l.c == 0);
}

bool cheklu(point p)
{
	return (!w.count(konv(p))
		&& abs(p.x) <= MAXK
		&& abs(p.y) <= MAXK);
}

bool kans(line l1, line l2)
{
	point ans;
	int kal = 0;
	for (int i = 0; i < n; i++)
	{
		if (nali(poi[i], l1))
			kal++;
	}
	if (kal != 2)
		return false;

	kal = 0;
	for (int i = 0; i < n; i++)
	{
		if (nali(poi[i], l2))
			kal++;
	}
	if (kal != 2)
		return false;

	if (pereze(l1, l2))
	{
		ans = pere(l1, l2);
		if (cheklu(ans))
		{
			cout << "Yes\n" << ans.x << " " << ans.y;
			return true;
		}
	}
	return false;
}