#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 3010;
const long long MAXK = 1000000;

struct point
{
	long long x, y;
	point()
	{
		x = 0;
		y = 0;
	}
	point(long long x, long long y)
	{
		this->x = x;
		this->y = y;
	}
};

struct line
{
	long long a, b, c;
	line()
	{
		a = 0;
		b = 0;
		c = 0;
	}
	line(point a, point b)
	{
		this->a = a.y - b.y;
		this->b = b.x - a.x;
		this->c = -(this->a) * a.x - (this->b) * a.y;
	}
};

int n;
point poi[MAXN];
set< long long > w;
map< pair<long long, long long>, int > q;
bool used[MAXN];
point ans;
line kok;
long long obsh, kek;

long long nod(long long a, long long b)
{
	a = abs(a);
	b = abs(b);
	if (b < a)
		swap(a, b);
	while (a > 0)
	{
		b %= a;
		swap(a, b);
	}
	return b;
}

bool para(line l1, line l2);

bool pereze(line l1, line l2);

point pere(line l1, line l2);

long long konv(point p);

bool nali(point p, line l);

bool cheklu(point p);

bool kans(line l1, line l2);

bool solve(int i1, int i2, int i3, int i4)
{
	if (!kans(line(poi[i1], poi[i2]), line(poi[i3], poi[i4])))
		return false;
	q.clear();
	kek = 0;
	for (int i = 0; i < n; i++)
	{
		kok = line(poi[i], ans);
		obsh = nod(kok.a, kok.b);
		kok.a /= obsh;
		kok.b /= obsh;
		if (kok.a == 0)
			kok.b = 1;
		else if (kok.b == 0)
			kok.a = 1;
		else if (kok.a < 0 && kok.b < 0)
		{
			kok.a *= -1;
			kok.b *= -1;
		}
		else if (kok.b < 0 && kok.a > 0)
		{
			kok.a *= -1;
			kok.b *= -1;
		}

		q[{kok.a, kok.b}]++;
		if (q[{kok.a, kok.b}] == 2)
			kek++;
		if (q[{kok.a, kok.b}] == 3)
			return false;
	}
	if (kek != n / 2)
		return false;

	cout << "Yes\n" << ans.x << " " << ans.y;
	return true;
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	//cout << fixed << setprecision(20);
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; i++)
	{
		cin >> poi[i].x >> poi[i].y;
		w.insert(konv(poi[i]));
	}

	int in1, in2, in3, in4;

	in1 = 0;
	used[in1] = true;

	for (in2 = 0; in2 < n; in2++)
	{
		if (used[in2])
			continue;

		used[in2] = true;

		for (in3 = 0; in3 < n; in3++)
		{
			if (used[in3])
				continue;

			used[in3] = true;
			break;
		}

		for (in4 = 0; in4 < n; in4++)
		{
			if (used[in4])
				continue;
			if (solve(in1, in2, in3, in4))
				return 0;
		}
		used[in2] = false;
		used[in3] = false;
	}

	cout << "No\n";
    return 0;
}

bool para(line l1, line l2)
{
	return (l1.a * l2.b == l2.a * l1.b);
}

bool pereze(line l1, line l2)
{
	if (para(l1, l2))
		return false;
	long long kok = l1.a * l2.b - l2.a * l1.b;
	long long xp, yp;
	xp = (l1.c * l2.b - l2.c * l1.b);
	yp = (l1.a * l2.c - l2.a * l1.c);
	return (xp % kok == 0 && yp % kok == 0);
}

point pere(line l1, line l2)
{
	long long kok = l1.a * l2.b - l2.a * l1.b;
	point per;
	per.x = -(l1.c * l2.b - l2.c * l1.b) / kok;
	per.y = -(l1.a * l2.c - l2.a * l1.c) / kok;
	return per;
}

long long konv(point p)
{
	return p.x * (MAXK + 1) + p.y;
}

bool nali(point p, line l)
{
	return (l.a * p.x + l.b * p.y + l.c == 0);
}

bool cheklu(point p)
{
	return (!w.count(konv(p))
		&& abs(p.x) <= MAXK
		&& abs(p.y) <= MAXK);
}

bool kans(line l1, line l2)
{
	if (pereze(l1, l2))
	{
		ans = pere(l1, l2);
		if (cheklu(ans))
		{
			return true;
		}
	}
	return false;
}