#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 5e6 + 7;
const double EPS = 1e-6;
const int Q = 31;

string s;
int n;

vector <int> d(MAXN, -1);
vector <int> p;

void init() {
    for (int i = 2; i < MAXN; i++) {
        if (d[i] == -1) {
            p.push_back(i);
            d[i] = p.size() - 1;
        }
        for (int j = 0; j <= d[i]; j++) {
            if (i * p[j] >= MAXN) break;
            d[i * p[j]] = j;
        }
    }
}

inline bool check(int len) {
    if (n % len) {
        return false;
    }
    vector <int> cnt(Q, 0);
    for (int i = 0; i < len; i++) {
        cnt[s[i] - 'a']++;
    }
    for (int st = len; st < n; st += len) {
        vector <int> cnt1(Q, 0);
        for (int i = 0; i < len; i++) {
            int k = s[st + i] - 'a';
            cnt1[k]++;
            if (cnt1[k] > cnt[k]) {
                return false;
            }
        }
    }
    return true;
}

void solve1() {
    for (int len = 1; len <= n; len++) {
        if (check(len)) {
            cout << n / len << "\n";
            return;
        }
    }
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    init();
    cin >> s;
    n = s.size();
    if (n <= 500000) {
        solve1();
        return 0;
    }
    vector <int> a[Q];
    for (int i = 0; i < n; i++) {
        a[s[i] - 'a'].push_back(i);
    }
    for (int len = 1; len <= n; len++) {
        if (n % len) continue;
        bool can = true;
        for (int j = 0; j < Q; j++) {
            int cnt1 = lower_bound(a[j].begin(), a[j].end(), len) - a[j].begin();
            int cntp = cnt1;
            for (int i = len; i < n; i += len) {
                int cntn = lower_bound(a[j].begin(), a[j].end(), i + len) - a[j].begin();
                if (cntp + cnt1 != cntn) {
                    can = false;
                    break;
                }
                cntp = cntn;
            }
            if (!can) {
                break;
            }
        }
        if (can) {
            cout << n / len << "\n";
            return 0;
        }
    }
}
