#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <bitset>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

struct pt {
	ll x, y;
	pt() {};
	pt(long long x, long long y) : x(x), y(y) {};
	pt operator -(pt b) {
		return pt(x - b.x, y - b.y);
	}
	pt operator +(pt b) {
		return pt(x + b.x, y + b.y);
	}
	bool operator != (pt b) {
		return x != b.x || y != b.y;
	}
};
struct line {
	ll a, b, c;
	line() {}
	line(pt p1, pt p2) {
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = -a * p1.x - b * p1.y;
	}
};

ll det(ll a, ll b, ll c, ll d) {
	return a * d - b * c;
}
bool intersect(line m, line n, pt & res) {
	ll zn = det(m.a, m.b, n.a, n.b);
	if (abs(zn) == 0)
		return false;
	ll a = det(m.c, m.b, n.c, n.b), b = det(m.a, m.c, n.a, n.c);
	if (a % zn != 0)
		return false;
	if (b % zn != 0)
		return false;
	res.x = -a / zn;
	res.y = -b / zn;
	return true;
}

bool parallel(line m, line n) {
	return abs(det(m.a, m.b, n.a, n.b)) <= 0;
}
bool equivalent(line m, line n) {
	return abs(det(m.a, m.b, n.a, n.b)) <= 0
		&& abs(det(m.a, m.c, n.a, n.c)) <= 0
		&& abs(det(m.b, m.c, n.b, n.c)) <= 0;
}
const ll MSIZE = 1000000;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	vector<pt> v(2 * n);
	for (int i = 0; i < 2 * n; ++i)
		cin >> v[i].x >> v[i].y;
	if (n == 1) {
		pt p = v[0] - v[1];
		p = p + v[0];
		if (abs(p.x) > MSIZE || abs(p.y) > MSIZE)
			while (true);
		cout << "Yes\n" << p.x << " " << p.y << endl;
		return 0;
	}
	n *= 2;
	for (int i = 1; i < n; ++i) {
		map<pair<ll, ll>, vector<int> > mp;
		line a(v[0], v[i]);
		char flag = 1;
		for (int j = 1; j < n; ++j) {
			for (int z = j + 1; z < n; ++z) {
				line b(v[j], v[z]);
				pt p;
				if (intersect(a, b, p) && p != v[j] && p != v[z] && p != v[0] && p != v[i]) {
					mp[{p.x, p.y}].push_back(j);
					mp[{p.x, p.y}].push_back(z);
				}
			}
		}
		if (flag) {
			for (auto vec : mp) {
				sort(vec.second.begin(), vec.second.end());
				int sz = vec.second.size();
				for (int j = 1; j < vec.second.size(); ++j)
					if (vec.second[j] == vec.second[j - 1]) {
						flag = 0;
						break;
					}
				if (flag && sz == n - 2 && abs(vec.first.first) <= MSIZE && abs(vec.first.second) <= MSIZE) {
					cout << "Yes\n" << vec.first.first << " " << vec.first.second << '\n';
					return 0;
				}
			}
		}
	}
	cout << "No";
#ifndef ONLINE_JUDGE
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

