#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#define X first
#define Y second
#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()

#ifdef REK
#define dbg(...) cout << __VA_ARGS__
#define stddbg(...) printf(__VA_ARGS__)
#else
#define dbg(...) ((void) 0)
#define stddbg(...) ((void) 0)
#endif

constexpr ll MOD = 1000000007;
mt19937 rnd (228);
constexpr ld pi = acos(-1.0);

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}

template <typename T>
T gcd(T a, T b) {
	a = abs(a);
	b = abs(b);
	while (b) {
		a %= b;
		swap(a, b);
	}

	return a;
}

constexpr int N = 5210;
pii points [N];
set<pair<ll, ll>> coords;
int n;

struct line {
	ll a, b, c;

public:
	line(const pii &x1, const pii &x2) {
		int dx = x1.X - x2.X;
		int dy = x2.Y - x1.Y;

		int g = gcd(dx, dy);
		a = dy / g;
		b = dx / g;

		c = - a * (ll) (x1.X) - b * (ll) (x1.Y);
	}

	pair<bool, ll> eval(int x) const {
		ll top = -c - a*x;
		if (b == 0) return mp(false, MOD);
		if (top % b != 0) {
			return mp(false, MOD);
		} else {
			return mp(true, top / b);
		}
	}

	pair<bool, ll> root(int y) const {
		ll top = -c - b*y;
		if (a == 0) return mp(false, MOD);
		if (top % a != 0) {
			return mp(false, MOD);
		} else {
			return mp(true, top / a);
		}
	}

	bool operator==(const line &other) const {
		return (a == other.a && b == other.b && c == other.c) || ((-a) == other.a && (-b) == other.b && (-c) == other.c);
	}

	pair<bool, pair<ll, ll>> intersect(const line &other) {
		ll top = -a * other.c + other.a * c;
		ll bot = a * other.b - other.a * b;

		if (bot == 0) return mp(false, mp(MOD, MOD));
		if (top % bot != 0) return mp(false, mp(MOD, MOD));

		ll y = top / bot;
		auto res = root(y);
		if (!res.X) res = other.root(y);

		if (!res.X) return mp(false, mp(MOD, MOD));
		return mp(true, mp(res.Y, y));
	}
};

pair<int, int> try_solve(int i1, int i2) {

	for (int j1 = 0; j1 < 2*n; j1++) {
		if (j1 == i1 || j1 == i2) continue;
		for (int gg = 0; gg < 2*n; gg++) {
			if (gg == i1 || gg == i2 || gg == j1) continue;

			line l1 (points[i1], points[j1]);
			line l2 (points[i2], points[gg]);

			if (l1 == l2) continue;

			auto res = l1.intersect(l2);

			if (!res.X) break;
			auto int_point = res.Y;

			if (abs(int_point.X) > 1000000 || abs(int_point.Y) > 1000000 || coords.find(int_point) != coords.end()) {
				continue;
			}

			map<pll, int> pts;

			for (int k1 = 0; k1 < 2*n; k1++) {
				if (k1 == i1 || k1 == i2 || k1 == gg || k1 == j1) continue; 
				auto dx = points[k1].X - int_point.X;
				auto dy = points[k1].Y - int_point.Y;

				auto g = gcd(dx, dy);

				dx /= g;
				dy /= g;

				if (dx < 0) {
					dx = -dx;
					dy = -dy;
				}

				pts[mp(dx, dy)] += 1;
			}

			for (const auto &p : pts) {
				if (p.Y != 2) {
					continue;
				}
			}

			return int_point;
		}
	}

	return mp(MOD, MOD);
}

int main(void) {

	scanf("%d", &n);

	for (int i = 0; i < 2*n; i++) {
		int x, y;
		scanf("%d%d", &x, &y);

		points[i] = mp(x, y);
	}

	for (int i = 0; i < n*2; i++) {
		coords.insert(mp(points[i].X, points[i].Y));
	}

	pair<int, int> res;

	for (int i = 0; i < n*2; i++) {
		for (int j = 0; j < n*2; j++) {
			if (i == j) continue;
			res = try_solve(i, j);
			if (res.X != MOD) break;
		}
		if (res.X != MOD) break;
	}

	if (res.X == MOD) {
		puts("No");
	} else {
		printf("Yes\n%d %d\n", res.X, res.Y);
	}

	return 0;
}