import java.io.*;
import java.util.*;

public class Gamma {

    public Gamma() throws FileNotFoundException {
    }

    class Inreader {
        BufferedReader in;

        Inreader() {
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        Inreader(String s) throws FileNotFoundException {
            in = new BufferedReader(new FileReader(s));
        }

        StringTokenizer st = new StringTokenizer("");

        void update() throws IOException {
            if (!st.hasMoreTokens()) {
                String a = in.readLine();
                if (a != null) st = new StringTokenizer(a);
            }
        }

        String next() throws IOException {
            update();
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }

        double nextDouble() throws IOException {
            return Double.parseDouble(next());
        }
    }

    Inreader in;

    class Decart {
        class node {
            node l;
            node r;
            long x;
            double y;
            int size;

            node(long x) {
                this.x = x;
                y = Math.random();
            }
        }

        Decart(int[] x) {
            tree = new node(x[0]);
            for (int i = 1; i < x.length; i++) {
                tree = merge(tree, new node(x[i]));
            }

        }

        void update(node t) {
            t.size = size(t.l) + size(t.r) + 1;
        }

        int size(node t) {
            if (t == null) return 0;
            return t.size;
        }

        node tree;

        node merge(node t1, node t2) {
            if (t1 == null) return t2;
            if (t2 == null) return t1;
            if (t1.y > t2.y) {
                t1.r = merge(t1.r, t2);
                update(t1.r);
                update(t1);
                return t1;
            }
            t2.l = merge(t1, t2.l);
            update(t2.l);
            update(t2);
            return t2;
        }

        node[] split(node t, int k) {
            if (t == null) return new node[]{null, null};
            int l = size(t.l);
            if (l >= k) {
                node[] d = split(t.l, k);
                t.l = d[1];
                update(t);
                return new node[]{d[0], t};
            }
            node[] d = split(t.r, k - l - 1);
            t.r = d[0];
            update(t);
            return new node[]{t, d[1]};
        }

        ArrayList<Long> print(node t) {
            if (t == null) return new ArrayList();
            ArrayList<Long> a = print(t.l);
            ArrayList<Long> b = print(t.r);
            ArrayList<Long> ans = a;
            ans.add(t.x);
            ans.addAll(b);
            return ans;
        }

        void del(int a, int b) {
            node[] t = split(tree, b);
            node[] d = split(t[0], a - 1);
            tree = merge(d[0], t[1]);
        }

    }

    long c2n(int n) {
        if (n % 2 == 0) return (n / 2) * (n - 1);
        else return (n - 1) / 2 * n;
    }

    PrintWriter out;

    HashMap<Integer, Integer> raz(int x) {
        int i = 2;
        HashMap<Integer, Integer> ans = new HashMap<>();
        while (x != 1) {
            if (x % i != 0) continue;
            int c = 0;
            while (x % i == 0) {
                x /= i;
                c++;
            }
            ans.put(i, c);
        }
        return ans;
    }

//    HashMap<Integer, Integer> sum(HashMap<Integer, Integer> t1, HashMap<Integer, Integer> t2) {
//        for (int e : t1.keySet()) {
//            if (!t2.containsKey(e)) {
//                t1.remove(e);
//                continue;
//            }
//            t1.replace(e, Math.min(t1.get(e), t2.get(e)));
//        }
//        return t1;
//    }

    int kek(int[] pref, int c) {
        if (c == -1) return 0;
        else return pref[c];
    }

    int gcd(int a, int b) {
        if (a == 0 || b == 0) return a + b;
        if (a > b) return gcd(a % b, b);
        else return gcd(a, b % a);
    }

    void solve() throws IOException {
        String s = in.next();
        TreeMap<Character, Integer> sub = new TreeMap<>();
        int key = s.length();
        for (char c : s.toCharArray()) {
            if (sub.containsKey(c)) {
                sub.replace(c, sub.get(c) + 1);
            } else sub.put(c, 1);
        }

        int[][] pref = new int[sub.size()][s.length()];
        Object[] suub = sub.keySet().toArray();
        for (int i = 0; i < s.length(); i++)
            for (int j = 0; j < suub.length; j++)
                if (s.charAt(i) == (char) suub[j]) {
                    if (i == 0) pref[j][i] = 1;
                    else pref[j][i] = pref[j][i - 1] + 1;
                } else {
                    if (i == 0) pref[j][i] = 0;
                    else pref[j][i] = pref[j][i - 1];
                }

        for (int e : sub.values()) {
            key = gcd(key, e);
        }
        ArrayList<Integer> bf = new ArrayList<>();
        for (int i = 1; i <= Math.sqrt(key); i++) {
            if (key % i != 0) continue;
            bf.add(i);
            if (key / i != i) bf.add(key / i);
        }
        bf.sort(new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                return o1.intValue() - o2.intValue();
            }
        });
        for (int i = bf.size() - 1; i >= 0; i++) {
            int k = bf.get(i);
            int size = s.length() / k;
            boolean exit = false;

            for (int t2 = 0; t2 < suub.length; t2++) {
                for (int t1 = 0; t1 < k; t1++) {
                    if (kek(pref[t2], (t1 + 1) * size - 1) - kek(pref[t2], t1 * size - 1) != sub.get((char) suub[t2]) / k) {
                        exit = true;
                        break;
                    }
                }
                if (exit) break;
            }
            if (exit) break;
            out.print(k);
            return;
        }
        out.print(1);
    }

    void run() throws IOException {
        File f = new File("input.txt");
        if (f.exists())
            in = new Inreader("input.txt");
        else in = new Inreader();
        out = new PrintWriter("output.txt");
        solve();
        out.close();
    }

    public static void main(String args[]) throws IOException {
        new Gamma().run();
    }
}
