#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef long double ld;

const int N = (int)1e6+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;
const ld eps = 1e-9;

struct point {
    ld x, y;
    point() {x=0,y=0;}
    point(ld x, ld y):
        x(x), y(y) {}
    friend bool operator ==(point lhs, point rhs) {
        return floor(lhs.x) == floor(rhs.x)
         && floor(lhs.y) == floor(rhs.y);
    }
};

struct line {
    point a, b;
    line() {}
    line(point a, point b):
        a(a), b(b) {}
    pair<ld,ld> get() {
        if (a.x == b.x) return mp(-LLINF, -LLINF-a.x);
        ld k = (a.y-b.y) / (a.x-b.x);
        ld b = a.y-a.x*k;
//        cout << k << ' ' << b << endl;
        return mp(k, b);
    }
};

point intersect(line a, line b) {
    pair<ld, ld> exp1 = a.get();
    pair<ld, ld> exp2 = b.get();
//    if (exp1.fst < -LLINF && exp2.fst < -LLINF) return a.x == b.x;
//    cout << exp1.fst << ' ' << exp1.snd << endl;
//    cout << exp2.fst << ' ' << exp2.snd << endl;
//    cout.precision(3);
    if (exp1 == exp2) return point(-LLINF, -LLINF);
    if (exp1.fst == exp2.fst && exp1.snd != exp2.snd) return point(-LLINF, -LLINF);
    if (exp1.fst == -LLINF) return point(a.a.x, a.a.x * exp2.fst + exp2.snd);
    if (exp2.fst == -LLINF) return point(b.a.x, b.a.x * exp1.fst + exp1.snd);
    ld x = (exp2.snd-exp1.snd) / (exp1.fst-exp2.fst);
    ld y = exp1.fst * x + exp1.snd;
//    cout << a.a.x << ' ' << a.a.y << endl;
//    cout << a.b.x << ' ' << a.b.y << endl;
//    cout <<  exp1.fst << ' ' << exp1.snd << endl;
//    cout <<  exp2.fst << ' ' << exp2.snd << endl;
//    cout << x << '_'  << y << endl << endl;
    return point(x, y);
}


int n, q;
point p[N];
set<pair<ld,ld> > was;


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n;
//    if (n == 2) {
//        assert(false);
//    }
    rep(i, 0, 2*n) cin >> p[i].x >> p[i].y;
    n += n;
    rep(fst, 0, n) {
        rep(snd, fst+1, n) {
            rep(trd, 0, n) {
                if (trd == fst || trd == snd) continue;
                rep(frt, trd+1, n) {
                    if (frt == fst || frt == snd) continue;
                    point center = intersect(line(p[fst], p[snd]), line(p[trd], p[frt]));
                    if (center == p[fst] || center == p[snd] || center == p[trd] || center == p[frt]) continue;
//                    cout << fst << ' ' << snd << ' ' << trd << ' ' << frt << endl;
//                    cout << center.x << ' ' << center.y << endl;
                    if (center.x == -LLINF && center.y == -LLINF) continue;
                    if (floor(center.x) != center.x || floor(center.y) != center.y) continue;
                    was.clear();
                    rep(i, 0, n) {
                        if (i == fst || i == snd || i == trd || i == frt) continue;
                        pair<ld,ld> expr = line(center, p[i]).get();
                        if (was.count(expr)) was.erase(expr);
                        else was.insert(expr);
                    }
                    if (!was.empty()) continue;
                    cout << "Yes" << endl;
                    cout << floor(center.x) << ' ' << floor(center.y) << endl;
                    return 0;
                }
            }
        }
    }
//    point t = intersect(line(p[0], p[3]), line(p[1], p[2]));
//    cout << t.x << ' ' << t.y << endl;
//    assert(false);
    cout << "No" << endl;

    return 0;
}
