#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

int **cnt;
int Get(int l, int r, char ch) {
    int ind = ch-'a';
    if (l==0) return cnt[ind][r];
    else return cnt[ind][r] - cnt[ind][l-1];
}

vector<int> GetDivisors(int n) {
    vector<int> res;
    for (int i=1; i*i<=n; i++) {
        if (n%i==0) {
            res.pb(i);
            if (n/i != i) res.pb(n/i);
        }
    }
    return res;
}

vector<int> GetVector(int l, int r, int max_ch) {
    vector<int> res;
    for (int i=0; i<max_ch; i++)
        res.pb(Get(l, r, i+'a'));
    return res;
}

int main()
{
    //os_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int max_ch = 0;
    string s; fin >> s;
    int n = s.length();
    for (int i=0; i<n; i++)
        max_ch = max(max_ch, s[i]-'a');

    cnt = new int*[max_ch];
    for (int i=0; i<max_ch; i++)
        cnt[i] = new int[n];

    int cur;
    for (int i=0; i<max_ch; i++) {
        cur = 0;
        for (int j=0; j<n; j++) {
            if (s[j]-'a' == i) cur++;
            cnt[i][j] = cur;
        }
    }

    vector<int> div = GetDivisors(n);
    sort(div.begin(), div.end());

    //or (int i=0; i<div.size(); i++)
    //    cout << div[i] << ' ';
    //cout << endl;

    for (int i=0; i<n; i++) {
        /// check all segments
        bool ok = 1;
        int l=0, r=div[i]-1;
        vector<int> t, v;
        t = GetVector(l, r, max_ch);
        for (int j=1; j<n/div[i]; j++) {
            l += div[i]; r += div[i];
            v = GetVector(l, r, max_ch);
            if (t!=v) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            fout << n/div[i]; /// otherwise n itself
            return 0;
        }
    }

    fin.close();
    fout.close();
    return 0;
}
