#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define int long long

const int INF = 1e9;

struct Su
{
    vector <int> P;

    Su(string &s, char &c)
    {
        P.resize(s.size() + 1);
        for (int i = 0; i < s.size(); ++i)
        {
            P[i + 1] = P[i] + (int)(s[i] == c);
        }
    }

    int get(int l, int r)
    {
        return P[r] - P[l];
    }
};

void fill1(vector <int> &D, int a, int n)
{
    vector <int> Buf;
    for (int i = 1; i * i <= n; ++i)
    {
        if (n % i == 0) {
            if (i >= a)
                D.push_back(i);
            if (n / i >= a)
                Buf.push_back(n / i);
        }
    }
    for (int i = (int)Buf.size() - 1; i >= 0; --i)
    {
        D.push_back(Buf[i]);
    }
}

int gcd(int a, int b)
{
    if (b == 0)
    {
        return a;
    }
    return gcd(b, a % b);
}

int get(int n, vector <Su*> &T)
{
    int cur = n;
    for (int i = 0; i < T.size(); ++i)
    {
        cur = gcd(cur, T[i]->get(0, n));
    }
    return n / cur;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    vector <bool> B(29);
    for (int i = 0; i < s.size(); ++i)
    {
        B[s[i] - 'a'] = true;
    }
    vector <char> C;
    for (int i = 0; i < 29; ++i)
    {
        if (B[i]) C.push_back('a' + i);
    }
    vector <Su*> T(C.size());
    for (int i = 0; i < C.size(); ++i)
    {
        T[i] = new Su(s, C[i]);
    }
    vector <int> D;
    fill1(D, get(s.size(), T), s.size());
    for (int i = 0; i < D.size(); ++i)
    {
        bool f = true;
        for (int ch = 0; ch < T.size(); ++ch)
        {
            for (int j = D[i]; j <= s.size(); j += D[i])
            {
                if (T[ch]->get(0, D[i]) != T[ch]->get(j - D[i], j))
                {
                    f = false;
                    break;
                }
            }
            if (!f)
            {
                break;
            }
        }
        if (f)
        {
            cout << s.size() / D[i] << endl;
            return 0;
        }
    }
    return 0;
}