#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

#define int long long

const int INF = 1e9;


int gcd(int a, int b)
{
    if (b == 0)
    {
        return a;
    }
    return gcd(b, a % b);
}

struct point
{
    int x, y;

    point (int x, int y)
    {
        this->x = x;
        this->y = y;
    }

    point() {}
};
point operator-(const point &a, const point &b)
{
    return point(a.x - b.x, a.y - b.y);
}

struct line
{
    int a, b, c;
    point v;
    point st;
    line(const point &a1, const point &b1)
    {
        v = a1 - b1;
        st = b1;
        a = v.y;
        b = -v.x;
        c = -(a * st.x + b * st.y);
        int buf = abs(a);
        buf = gcd(buf, abs(b));
        buf = gcd(buf, abs(c));
        a /= buf;
        b /= buf;
        c /= buf;
    }

    pair <point, bool> cross(const line &l)
    {
        if (a == l.a || b == l.b) return {point(), false};
        if ((l.c * a - c * l.a) % (b * l.a - l.b * a) != 0)
        {
            return {point(), false};
        }
        if ((l.c * b - c * l.b) % (a * l.b - l.a * b) != 0)
        {
            return {point(), false};
        }
        return {point((l.c * a - c * l.a) / (b * l.a - l.b * a), (l.c * b - c * l.b) / (a * l.b - l.a * b)), true};
    }
};


istream& operator>>(istream &in, point& a)
{
    in >> a.x >> a.y;
    return in;
}


signed main()
{
    int n;
    vector <point> B(2 * n);
    for (int i = 0; i < 2 * n; ++i)
    {
        cin >> B[i];
    }
    map <pair <int, int>, int> M;
    for (int i = 1; i < B.size(); ++i)
    {
        line l(B[0], B[i]);
        for (int j = 1; j < B.size(); ++j)
        {
            for (int k = 1; k < B.size(); ++k)
            {
                if (i == j || i == k || j == k) continue;
                line e(B[j], B[k]);
                pair <point, bool> p = l.cross(e);
                if (p.second) M[{p.first.x, p.first.y}]++;
            }
        }
    }
    for (int i = 0; i < B.size(); ++i)
    {
        M[{B[i].x, B[i].y}] = 0;
    }
    for (auto pr : M)
    {
        if (pr.second == 2 * n) {
            cout << "Yes" << endl;
            cout << pr.first.first << " " << pr.first.second << endl;
        }
        return 0;
    }
    cout << "No" << endl;
    return 0;
}