#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const long long SIZE = 2 * 1e5, INF = 1e16;
long long min_perf[SIZE], perf_sum[SIZE], perf[SIZE], cnt[SIZE], ans[SIZE];
bool checked[SIZE];
vector<int> graph[SIZE];

long long find_min_left(int v, int i, long long left, int excl)
{
    if (i >= graph[v].size())
        return left;
    if (i == excl)
        return find_min_left(v, i + 1, left, excl);
    return min(find_min_left(v, i + 1, left + cnt[graph[v][i]], excl),
        find_min_left(v, i + 1, max(left, cnt[graph[v][i]]) - min(left, cnt[graph[v][i]]), excl));
}

void dfs(int v)
{
    long long left = 0;

    min_perf[v] = perf[v];
    for (int u : graph[v])
    {
        dfs(u);
        min_perf[v] = min(min_perf[v], min_perf[u]);
        perf_sum[v] += perf_sum[u];
        cnt[v] += cnt[u];
    }
    ans[v] = INF;
    for (int i = 0; i < graph[v].size(); i++)
    {
        left = find_min_left(v, 0, 0, i);
        //cout << v << ' ' << graph[v][i] << ' ' << left << ' ' << cnt[graph[v][i]] << endl;
        if (left >= cnt[graph[v][i]])
            ans[v] = min(ans[v], min_perf[graph[v][i]] * (left - cnt[graph[v][i]]) + perf_sum[v]);
    }
    //if (graph[v].size() != 0)
        //cout << v << ' ' << ans[v] << ' ' << endl;
    perf_sum[v] += perf[v];
    cnt[v]++;
    if (graph[v].size() == 0)
        ans[v] = 0;
}

int main()
{
    long long n, par, ans_sum = 0;

    cin >> n;
    for (int i = 1; i < n; i++)
    {
        cin >> par;
        graph[par - 1].push_back(i);
    }
    perf[0] = 0;
    for (int i = 1; i < n; i++)
        cin >> perf[i];
    dfs(0);
    for (int i = 0; i < n; i++)
        ans_sum += ans[i];
    cout << ans_sum;
    cin >> n;
}