#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const long long SIZE = 2 * 1e5, INF = 1e16;
long long min_perf[SIZE], perf_sum[SIZE], perf[SIZE], cnt[SIZE], ans[SIZE];
bool checked[SIZE];
vector<int> graph[SIZE];

long long find_min_left(int v, int i, long long left, int excl, long long left_excl)
{
    long long ans;

    if (i >= graph[v].size())
        if (left_excl == 0)
            return left;
        else
            return INF;
    if (i == excl)
    {
        if (left >= cnt[graph[v][i]])
            ans = find_min_left(v, i + 1, left - cnt[graph[v][i]], excl, 0);
        else
            ans = find_min_left(v, i + 1, cnt[graph[v][i]] - left, excl, cnt[graph[v][i]] - left_excl);
        ans = min(ans, find_min_left(v, i + 1, cnt[graph[v][i]] + left, excl, cnt[graph[v][i]]));
        return ans;
    }
    ans = find_min_left(v, i + 1, left + cnt[graph[v][i]], excl, left_excl);
    if (cnt[graph[v][i]] >= left)
        ans = min(ans, find_min_left(v, i + 1, cnt[graph[v][i]] - left, excl, 0));
    else
        ans = min(ans, find_min_left(v, i + 1, left - cnt[graph[v][i]], excl, max(0LL, left_excl - cnt[graph[v][i]])));
    return ans;
}

void dfs(int v)
{
    long long left = 0;

    min_perf[v] = perf[v];
    for (int u : graph[v])
    {
        dfs(u);
        min_perf[v] = min(min_perf[v], min_perf[u]);
        perf_sum[v] += perf_sum[u];
        cnt[v] += cnt[u];
    }
    ans[v] = INF;
    for (int i = 0; i < graph[v].size(); i++)
    {
        left = find_min_left(v, 0, 0, i, 0);
        //cout << v << ' ' << graph[v][i] << ' ' << left << ' ' << cnt[graph[v][i]] << endl;
        if (left <= cnt[v])
            ans[v] = min(ans[v], min_perf[graph[v][i]] * left + perf_sum[v]);
    }
    //if (graph[v].size() != 0)
        //cout << v << ' ' << ans[v] << ' ' << endl;
    perf_sum[v] += perf[v];
    cnt[v]++;
    if (graph[v].size() == 0)
        ans[v] = 0;
}

int main()
{
    long long n, par, ans_sum = 0;

    cin >> n;
    for (int i = 1; i < n; i++)
    {
        cin >> par;
        graph[par - 1].push_back(i);
    }
    perf[0] = 0;
    for (int i = 1; i < n; i++)
        cin >> perf[i];
    dfs(0);
    for (int i = 0; i < n; i++)
        ans_sum += ans[i];
    cout << ans_sum << endl;
    cin >> n;
}