#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const long long SIZE = 2 * 1e5 + 1, INF = 1e14;
long long min_perf[SIZE], perf_sum[SIZE], perf[SIZE], cnt[SIZE], ans[SIZE];
vector<bool> checked[SIZE];
vector<long long> graph[SIZE], func_ans[SIZE];

void find_min_left(int v, int i, long long left)
{
    //cout << v << ' ' << i << ' ' << left << endl;
    if (checked[i][left])
        return;
    checked[i][left] = 1;
    if (i == graph[v].size())
    {
        func_ans[i][left] = left;
        return;
    }
    func_ans[i][left] = INF;
    for (int j = max(left, cnt[graph[v][i]]) - min(left, cnt[graph[v][i]]); j <= left + cnt[graph[v][i]]; j += 2)
    {
        find_min_left(v, i + 1, j);
        func_ans[i][left] = min(func_ans[i][left], func_ans[i + 1][j]);
    }
}

void dfs(int v)
{
    if (graph[v].size() == 0)
    {
        cnt[v] = 1;
        return;
    }
    for (int u : graph[v])
    {
        dfs(u);
        cnt[v] += cnt[u];
    }
    for (int i = 0; i <= graph[v].size(); i++)
    {
        checked[i].clear();
        checked[i].resize(cnt[v] + 1);
        for (int j = 0; j < cnt[v] + 1; j++)
            checked[i][j] = 0;
        func_ans[i].clear();
        func_ans[i].resize(cnt[v] + 1);
    }
    find_min_left(v, 0, 0);
    ans[v] = cnt[v] +  func_ans[0][0];
    //if (graph[v].size() != 0)
        //cout << v << ' ' << ans[v] << ' ' << func_ans[0][0] << endl;
    cnt[v]++;
}

int main()
{
    long long n, par, ans_sum = 0;

    cin >> n;
    for (int i = 1; i < n; i++)
    {
        cin >> par;
        graph[par - 1].push_back(i);
    }
    perf[0] = 0;
    for (int i = 1; i < n; i++)
        cin >> perf[i];
    dfs(0);
    for (int i = 0; i < n; i++)
        ans_sum += ans[i];
    cout << ans_sum << endl;
    cin >> n;
}