import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Set;

public class D {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while(i < n) {
            int c = r.read();
            if(c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
              neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while(i < n) {
            int c = r.read();
            if(c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
        String s = r.readLine();
        int[] charCount = new int['z' - 'a' + 1];
        Set<Integer> presentChars = new HashSet<>();
        for(char c : s.toCharArray()) {
            charCount[c - 'a']++;
            presentChars.add(c - 'a');
        }
        int frac = getFrac(presentChars, charCount);
        if(frac == -1) {
            System.out.println(1);
            return;
        }
        int[] reqChars = new int['z' - 'a' + 1];
        int partLen = 0;
        for(int c : presentChars) {
            partLen += reqChars[c] = charCount[c] / frac;
        }
        int estimateFrag = s.length() / partLen;
        while(s.length() >= partLen) {
            char[] ca = s.toCharArray();
            char[] partCount = new char['z' - 'a' + 1];
            for(int i = 0; i < partLen; i++) {
                int c = ca[i] - 'a';
                if(++partCount[c] > reqChars[c]) {
                    System.out.println(1);
                    return;
                }
            }
            for(int c : presentChars) {
                if(partCount[c] != reqChars[c]) {
                    System.out.println(1);
                    return;
                }
            }
            s = s.substring(partLen);
        }
        System.out.println(estimateFrag);
    }

    private static int getFrac(Set<Integer> presentChars, int[] charCount) {
        int frac = -1;
        for(int i : presentChars) {
            for(int j : presentChars) {
                if(i == j) continue;
                BigInteger ic = BigInteger.valueOf(charCount[i]), jc = BigInteger.valueOf(charCount[j]);
                int gcd = ic.gcd(jc).intValue();
                if(frac == -1) {
                    frac = gcd;
                } else if (frac != gcd) {
                    return -1;
                }
            }
        }
        return frac;
    }

}
