import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class B {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static class Node {
        Node parent;
        List<Node> children = new LinkedList<>();
        int id;
        int c;

        Node(int id, int c, Node parent) {
            this.id = id;
            this.parent = parent;
            this.c = c;
        }

    }

    public static void main(String[] args) throws IOException {
        InputStreamReader r = new InputStreamReader(System.in);
        int n = readArgsInt(r, 1)[0];
        int[] p = readArgsInt(r, n - 1);
        int[] c = readArgsInt(r, n - 1);
        Node[] nodes = new Node[n];
        nodes[0] = new Node(0, 0, null);
        for (int i = 0; i < n - 1; i++) {
            Node parent = nodes[p[i] - 1];
            Node child = new Node(i + 1, c[i], parent);
            parent.children.add(child);
            nodes[i + 1] = child;
        }
        int minC = 0;
        for (Node nd : nodes) {
            List<Node> ns = new LinkedList<>();
            Queue<Node> nq = new LinkedList<>();
            nq.add(nd);
            Node cur;
            while ((cur = nq.poll()) != null) {
                ns.addAll(cur.children);
                nq.addAll(cur.children);
            }
            int localMin = Integer.MAX_VALUE;
            for (Node ndd : ns) {
                minC += ndd.c;
                if (ndd.c < localMin) {
                    localMin = ndd.c;
                }
            }
            if(!ns.isEmpty()) {
                minC += localMin * (ns.size() - 2);

            }
        }
        System.out.println(minC);
    }

}
