import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.StringTokenizer;

public class B8 {

	public static class Vector implements Comparable<Vector> {
		long x;
		long y;

		public Vector(long x, long y) {
			this.x = x;
			this.y = y;
		}

		public String toString() {
			return x + " " + y;
		}

		public boolean Zero() {
			return x == 0 && y == 0;
		}

		public void normalise() {
			if (x < 0) {
				x = -x;
				y = -y;
			} else if (x == 0 && y < 0) {
				y = -y;
			}
			long gcd = gcd(x, Math.abs(y));
			x /= gcd;
			y /= gcd;
		}

		public long toLong() {
			return 1000000007L * x + 1000003L * y;
			// return x ^ y;
		}

		public Vector subtract(Vector b) {
			return new Vector(x - b.x, y - b.y);
		}

		public Vector add(Vector b) {
			return new Vector(x + b.x, y + b.y);
		}

		@Override
		public int compareTo(Vector o) {
			if (y < 0 && o.y >= 0) {
				return -1;
			}
			if (y >= 0 && o.y < 0) {
				return 1;
			}
			long dp = x * o.y - y * o.x;
			if (dp > 0) {
				return 1;
			}
			if (dp < 0) {
				return -1;
			}
			return 0;
		}
	}

	// public static class Line {
	// long a;
	// long b;
	// long c;
	//
	// public Line(Vector m, Vector n) {
	// if (m.x == n.x) {
	// b = 0;
	// a = 1;
	// c = -m.x;
	// } else if (m.y == n.y) {
	// a = 0;
	// b = 1;
	// c = -m.y;
	// } else {
	// a = n.y - m.y;
	// b = m.x - n.x;
	// c = m.y * n.x - n.y * m.x;
	// }
	// normalise();
	// }
	//
	// public void normalise() {
	// if (a < 0) {
	// a = -a;
	// b = -b;
	// c = -c;
	// } else if (a == 0 && b < 0) {
	// b = -b;
	// c = -c;
	// }
	// long gcd = gcd(Math.abs(a), Math.abs(b));
	// gcd = gcd(gcd, Math.abs(c));
	// a /= gcd;
	// b /= gcd;
	// c /= gcd;
	// }
	//
	// public Vector cross(Line x) {
	// long div = b * x.a - a * x.b;
	// if (div == 0) {
	// return null;
	// }
	// long vx = c * x.b - b * x.c;
	// long vy = a * x.c - c * x.a;
	// if (vx % div == 0 && vy % div == 0) {
	// return new Vector(vx / div, vy / div);
	// }
	// return null;
	// }
	// }

	public static long gcd(long a, long b) {
		if (b == 0) {
			return a;
		}
		if (a == 0) {
			return b;
		}
		return gcd(b, a % b);
	}

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken());
		Vector[] v = new Vector[2 * n];
		ArrayList<Vector> list = new ArrayList<>();
		for (int i = 0; i < v.length; i++) {
			st = new StringTokenizer(in.readLine());
			list.add(new Vector(Long.parseLong(st.nextToken()), Long.parseLong(st.nextToken())));
		}
		Collections.shuffle(list);
		for (int i = 0; i < v.length; i++) {
			v[i] = list.get(i);
		}
		int i = 0;
		int j = 1;
		int i1 = 2;
		int j1 = 3;
		f: for (; j1 < v.length; j1++) {
			long a1;
			long b1;
			long c1;
			long a2;
			long b2;
			long c2;
			if (v[i].x == v[j].x) {
				b1 = 0;
				a1 = 1;
				c1 = -v[i].x;
			} else if (v[i].y == v[j].y) {
				a1 = 0;
				b1 = 1;
				c1 = -v[i].y;
			} else {
				a1 = v[j].y - v[i].y;
				b1 = v[i].x - v[j].x;
				c1 = v[i].y * v[j].x - v[j].y * v[i].x;
			}
			if (a1 < 0) {
				a1 = -a1;
				b1 = -b1;
				c1 = -c1;
			} else if (a1 == 0 && b1 < 0) {
				b1 = -b1;
				c1 = -c1;
			}
			long gcd = gcd(Math.abs(a1), Math.abs(b1));
			gcd = gcd(gcd, Math.abs(c1));
			a1 /= gcd;
			b1 /= gcd;
			c1 /= gcd;
			if (v[i1].x == v[j1].x) {
				b2 = 0;
				a2 = 1;
				c2 = -v[i1].x;
			} else if (v[i1].y == v[j1].y) {
				a2 = 0;
				b2 = 1;
				c2 = -v[i1].y;
			} else {
				a2 = v[j1].y - v[i1].y;
				b2 = v[i1].x - v[j1].x;
				c2 = v[i1].y * v[j1].x - v[j1].y * v[i1].x;
			}
			if (a2 < 0) {
				a2 = -a2;
				b2 = -b2;
				c2 = -c2;
			} else if (a2 == 0 && b2 < 0) {
				b2 = -b2;
				c2 = -c2;
			}
			gcd = gcd(Math.abs(a2), Math.abs(b2));
			gcd = gcd(gcd, Math.abs(c2));
			a2 /= gcd;
			b2 /= gcd;
			c2 /= gcd;
			// Line a = new Line(v[i], v[j]);
			// Line b = new Line(v[i1], v[j1]);
			Vector cross = null;
			while (true) {
				long div = b1 * a2 - a1 * b2;
				if (div == 0) {
					break;
				}
				long vx = c1 * b2 - b1 * c2;
				long vy = a1 * c2 - c1 * a2;
				if (vx % div == 0 && vy % div == 0) {
					cross = new Vector(vx / div, vy / div);
					break;
				}
				break;
			}
			// Vector cross = a.cross(b);
			if (cross == null) {
				continue;
			}
			if (Math.abs(cross.x) > 1000000 || Math.abs(cross.y) > 1000000) {
				continue;
			}
			Vector[] delta = new Vector[2 * n];
			// System.out.println(cross.toString());
			for (int k = 0; k < delta.length; k++) {
				delta[k] = v[k].subtract(cross);
				delta[k].normalise();
				// System.out.println(delta[k].toString());
				if (delta[k].Zero()) {
					continue f;
				}
			}
			Arrays.sort(delta);
			for (int k = 1; k < delta.length; k++) {
				if (k % 2 == 1 && delta[k].compareTo(delta[k - 1]) != 0) {
					continue f;
				}
				if (k % 2 == 0 && delta[k].compareTo(delta[k - 1]) == 0) {
					continue f;
				}
			}
			out.println("Yes");
			out.print(cross.toString());
			in.close();
			out.close();
			return;
		}
		i = 0;
		j = 2;
		i1 = 1;
		j1 = 2;
		for (; j < v.length; j++) {
			f: for (j1 = 2; j1 < v.length; j1++) {
				if (j1 == j) {
					continue;
				}
				long a1;
				long b1;
				long c1;
				long a2;
				long b2;
				long c2;
				if (v[i].x == v[j].x) {
					b1 = 0;
					a1 = 1;
					c1 = -v[i].x;
				} else if (v[i].y == v[j].y) {
					a1 = 0;
					b1 = 1;
					c1 = -v[i].y;
				} else {
					a1 = v[j].y - v[i].y;
					b1 = v[i].x - v[j].x;
					c1 = v[i].y * v[j].x - v[j].y * v[i].x;
				}
				if (a1 < 0) {
					a1 = -a1;
					b1 = -b1;
					c1 = -c1;
				} else if (a1 == 0 && b1 < 0) {
					b1 = -b1;
					c1 = -c1;
				}
				long gcd = gcd(Math.abs(a1), Math.abs(b1));
				gcd = gcd(gcd, Math.abs(c1));
				a1 /= gcd;
				b1 /= gcd;
				c1 /= gcd;
				if (v[i1].x == v[j1].x) {
					b2 = 0;
					a2 = 1;
					c2 = -v[i1].x;
				} else if (v[i1].y == v[j1].y) {
					a2 = 0;
					b2 = 1;
					c2 = -v[i1].y;
				} else {
					a2 = v[j1].y - v[i1].y;
					b2 = v[i1].x - v[j1].x;
					c2 = v[i1].y * v[j1].x - v[j1].y * v[i1].x;
				}
				if (a2 < 0) {
					a2 = -a2;
					b2 = -b2;
					c2 = -c2;
				} else if (a2 == 0 && b2 < 0) {
					b2 = -b2;
					c2 = -c2;
				}
				gcd = gcd(Math.abs(a2), Math.abs(b2));
				gcd = gcd(gcd, Math.abs(c2));
				a2 /= gcd;
				b2 /= gcd;
				c2 /= gcd;
				// Line a = new Line(v[i], v[j]);
				// Line b = new Line(v[i1], v[j1]);
				Vector cross = null;
				while (true) {
					long div = b1 * a2 - a1 * b2;
					if (div == 0) {
						break;
					}
					long vx = c1 * b2 - b1 * c2;
					long vy = a1 * c2 - c1 * a2;
					if (vx % div == 0 && vy % div == 0) {
						cross = new Vector(vx / div, vy / div);
						break;
					}
					break;
				}
				// Vector cross = a.cross(b);
				if (cross == null) {
					continue;
				}
				if (Math.abs(cross.x) > 1000000 || Math.abs(cross.y) > 1000000) {
					continue;
				}
				Vector[] delta = new Vector[2 * n];
				// System.out.println(cross.toString());
				for (int k = 0; k < delta.length; k++) {
					delta[k] = v[k].subtract(cross);
					delta[k].normalise();
					// System.out.println(delta[k].toString());
					if (delta[k].Zero()) {
						continue f;
					}
				}
				Arrays.sort(delta);
				for (int k = 1; k < delta.length; k++) {
					if (k % 2 == 1 && delta[k].compareTo(delta[k - 1]) != 0) {
						continue f;
					}
					if (k % 2 == 0 && delta[k].compareTo(delta[k - 1]) == 0) {
						continue f;
					}
				}
				out.println("Yes");
				out.print(cross.toString());
				in.close();
				out.close();
				return;
			}
		}
		out.println("No");
		in.close();
		out.close();
	}

}
