#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace std::chrono_literals;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("b.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

using ld = long double;

using V = ld;

const ld EPS = 1e-7;

ll safeRound(ld val) {

    ll app = (ld) val;
    if (app < val && (val  - app) > 0.5) ++app;
    if (app > val && (app -val) > 0.5) --app;
    return app;

}


struct Vector {
    V x;
    V y;
    Vector(V x = 0, V y = 0) : x(x), y(y) {}
    bool isInt() const {
        auto zx = safeRound(x);
        auto zy = safeRound(y);
        auto dx = x - zx;
        auto dy = y - zy;
        return abs(dx)   < EPS && abs(dy) < EPS;
    }

    bool isBase() const {
        return max(abs(x), abs(y)) < EPS;
    }

};

const Vector BASE(0, 0);

Vector operator-(const Vector& u, const Vector& v) {
    return Vector(u.x - v.x, u.y-v.y);
}

V dot(const Vector& u, const Vector& v) {
    return u.x*v.x + u.y*v.y;
}

V cross(const Vector& u, const Vector& v) {
    return u.x*v.y - u.y*v.x;
}

V dot(const Vector& u, const Vector& c, const Vector& v) {
    return dot(u-c, v-c);
}

V cross(const Vector& u, const Vector& c, const Vector& v) {
    return cross(u-c, v-c);
}

pair<V, V> mul(const Vector& u, const Vector& c, const Vector& v) {
    return make_pair(dot(u, c, v), cross(u, c, v));
}

struct Line {
    Vector u;
    Vector v;
    V a;
    V b;
    V c;
    Line(Vector u, Vector v) : u(u), v(v) {
        ll dx = v.x - u.x;
        ll dy = v.y - u.y;
        a = -dy;
        b = dx;
        //c = u.y - u.x*(dy/dx)
        //c*dx = u.y*dx - u.x*dy

        c = -cross(u, Vector(dx,dy));
    }

    bool has(Vector& p) {
        return abs(cross(u, p, v)) < EPS;
    }


};


int interection(const Line& l1, const Line& l2, Vector& out) {
    auto det0 = l1.a*l2.b - l2.a*l1.b;
    auto detY = l1.a*l2.c - l2.a*l1.c;
    auto detX = l1.c*l2.b - l2.c*l1.b;
    if (abs(det0) < EPS) {
        if (abs(detX) < EPS) {
            return 2;
        }
        return 0;
    }
    out.x = (detX) / det0;
    out.y = detY / det0;
    return 1;
}

void $main(ll testId) {
    int n;
    cin >> n;
    vector<Vector> p;
    n *= 2;
    for  (int i = 0; i < n; ++i) {
        ld x, y;
        cin >>x >> y;
        p.emplace_back(x, y);
    }
    for (int i1 = 0; i1 < n; ++i1) {
        for (int i2 = i1+1; i2 < n; ++i2) {
            for (int j1 = 0; j1 < n; ++j1) {
                if (j1 == i1 || j1 == i2) continue;
                for (int j2 = j1 + 1; j2 < n; ++j2) {
                     if (j2 == i1 || j2 == i2) continue;
                     Vector moon;
                     Line l1(p[i1], p[i2]);
                     Line l2(p[j1], p[j2]);
                     if (interection(l1, l2, moon) != 1) {
                        continue;
                     }
                     if (!moon.isInt()) {
                        continue;
                     }

                     if (max(moon.x, moon.y) > 1e6 + 0.1) {
                        continue;
                     }

                     bool ok = true;
                     for (auto s : p) {
                        if ((s - moon).isBase()) {
                            ok = false;
                            break;
                        }
                     }
                     if (!ok) continue;
                     for (auto s : p) {
                        vector<int> good;
                        Line l(s, moon);
                        for (int i = 0; i < n; ++i) {
                            if (l.has(p[i])) {
                                good.push_back(i);
                                if (good.size() == 3) break;
                            }
                        }
                        if (good.size() != 2) {
                            ok = false;
                            break;
                        }
                     }
                     if (!ok) continue;
                     cout << "Yes\n";
                     cout << safeRound(moon.x) << " " << safeRound(moon.y) << endl;
                     return;
                }
            }
        }
    }
    cout << "No";
}
