#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cmath>

#define endl '\n'

using namespace std;

typedef long long ll;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

bool check(string &s, vector<int> fv, int l, int r) {
    for (int i = l; i < r; ++i) {
        fv[s[i] - 'a']--;
    }
    for (int i = 0; i < 26; ++i) {
        if (fv[i] != 0) {
            return 0;
        }
    }
    return 1;
}

int main() {
    string s;
    cin >> s;
    int n = s.size();
    vector<int> v(26);
    for (int i = 0; i < n; ++i) {
        v[s[i] - 'a']++;
    }
    int var = -1;
    for (int i = 0; i < 26; ++i) {
        if (v[i] != 0) {
            if (var == -1) {
                var = v[i];
            }
            else {
                var = gcd(var, v[i]);
            }
        }
    }
    if (var == n) {
        cout << n << endl;
        return 0;
    }

    for (int i = var; i < var + 1; ++i) {
        if (var % i != 0) {
            continue;
        }
        int cs = n / i;
        vector<int> fv(26);
        for (int j = 0; j < cs; ++j) {
            fv[s[j] - 'a']++;
        }
        bool flag = 1;
        for (int j = cs; j < n; j += cs) {
            if (!check(s, fv, j, j + cs)) {
                flag = 0;
                break;
            }
        }
        if (flag) {
            cout << i << endl;
            return 0;
        }
    }


    for (int i = (int)sqrt(var); i > 1; --i) {
        if (var % i != 0) {
            continue;
        }
        int cs = n / i;
        vector<int> fv(26);
        for (int j = 0; j < cs; ++j) {
            fv[s[j] - 'a']++;
        }
        bool flag = 1;
        for (int j = cs; j < n; j += cs) {
            if (!check(s, fv, j, j + cs)) {
                flag = 0;
                break;
            }
        }
        if (flag) {
            cout << i << endl;
            return 0;
        }
    }
    cout << 1 << endl;
    return 0;
}