#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cmath>

#define endl '\n'

using namespace std;

typedef long long ll;

vector<vector<int>> pref;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int sum(int l, int r, int c) {
    return pref[c][r] - pref[c][l];
}

int main() {
    string s;
    cin >> s;
    int n = s.size();
    pref.resize(26, vector<int>(n + 1));
    vector<int> v(26);
    for (int i = 0; i < n; ++i) {
        v[s[i] - 'a']++;
        for (int j = 0; j < 26; ++j) {
            pref[j][i + 1] = pref[j][i];
        }
        pref[s[i] - 'a'][i + 1]++;
    }
    int var = -1;
    for (int i = 0; i < 26; ++i) {
        if (v[i] != 0) {
            if (var == -1) {
                var = v[i];
            }
            else {
                var = gcd(var, v[i]);
            }
        }
    }
    if (var == n) {
        cout << n << endl;
        return 0;
    }

    for (int i = var; i > 1; --i) {
        if (var % i != 0) {
            continue;
        }
        int cs = n / i;
        vector<int> fv(26);
        for (int j = 0; j < cs; ++j) {
            fv[s[j] - 'a']++;
        }
        bool flag = 1;
        for (int j = cs; j < n && flag; j += cs) {
            for (int k = 0; k < 26; ++k) {
                if (sum(j, j + cs, k) != v[k] / i) {
                    flag = 0;
                    break;
                }
            }
        }
        if (flag) {
            cout << i << endl;
            return 0;
        }
    }
    cout << 1 << endl;
    return 0;
}