#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cmath>

#define endl '\n'

using namespace std;

typedef long long ll;

struct three {
    ll sum, size, min;
    three(){}
    three(ll sum, ll size, ll min) : sum(sum), size(size), min(min){}
};

three dfs(vector<vector<int>> &g, vector<ll> &v, int cv, int anc, ll &ans) {
    vector<ll> sum(g[cv].size()), minv(g[cv].size()), vsize(g[cv].size());
    int cst = 0, mind = -1;
    ll mn = -1;
    for (int nv : g[cv]) {
        if (nv == anc) {
            continue;
        }
        auto res = dfs(g, v, nv, cv, ans);
        sum[cst] = res.sum;
        minv[cst] = res.min;
        vsize[cst] = res.size;
        if (mind == -1 || mn > minv[cst]) {
            mind = cst;
            mn = minv[cst];
        }
        cst++;
    }
    if (cst < 1) {
        return {v[cv], 1, v[cv]};
    }
    ll cursum = (cv == 0 ? 0 : v[cv]), cursize = 1;
    for (int i = 0; i < cst; ++i) {
        cursum += sum[i];
        cursize += vsize[i];
        if (i != mind) {
            ans += sum[i] + mn * vsize[i];
        }
    }
    int mind2 = -1;
    ll mn2 = -1;
    for (int i = 0; i < cst; ++i) {
        if (i == mind) {
            continue;
        }
        if (mind2 == -1 || mn2 > minv[i]) {
            mind2 = i;
            mn2 = minv[i];
        }
    }
    ans += sum[mind] + mn2 * vsize[mind] - mn2 - mn;
    mn = min(v[cv], mn);
    return {cursum, cursize, mn};
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int anc;
        cin >> anc;
        g[anc - 1].push_back(i + 1);
    }
    vector<ll> v(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> v[i + 1];
    }
    ll ans = 0;
    dfs(g, v, 0, 0, ans);
    cout << ans << endl;
}