#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int MAX_CRD = 510;

struct Point {
    int x, y;

    Point() {}

    Point(int x, int y) : x(x), y(y) {}
};

istream& operator>>(istream& in, Point &a) {
    in >> a.x >> a.y;
    return in;
}

ostream& operator<<(ostream& out, const Point &a) {
    out << a.x << " " << a.y;
    return out;
}

int sokr(int a, int b) {
    if (a == 0)
        return b;
    if (b == 0)
        return a;
    int res = __gcd(a, b);
    if (a / res < 0) {
        res *= -1;
    }
    return res;
}

struct Line {
    int a, b, c;

    Line() {}

    Point normal() {
        Point p(a, b);
        p.x /= sokr(a, b);
        p.y /= sokr(a, b);
        return p;
    }
};

Line make_line(const Point &p1, const Point &p2) {
    Line l;
    l.a = p1.y - p2.y;
    l.b = p2.x - p1.x;
    //l.c = -(p1.x * l.a + p1.y * l.b);
    //cout << l.a << " " << l.b << " " << l.c << "\n";
    return l;
}

bool operator<(const Point &a, const Point &b) {
    if (a.x == b.x)
        return a.y < b.y;
    return a.x < b.x;
}

bool operator==(const Point &a, const Point &b) {
    return (a.x == b.x && a.y == b.y);
}

int main() {
    //#undef KEK
    #ifdef KEK
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // KEK
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    n *= 2;
    vector<Point> star(n);
    for (int i = 0; i < n; i++)
        cin >> star[i];
    for (int moon_x = -MAX_CRD; moon_x <= MAX_CRD; moon_x++)
        for (int moon_y = -MAX_CRD; moon_y <= MAX_CRD; moon_y++) {
            Point moon(moon_x, moon_y);
            //if (!(moon == Point(3, 3)))
            //    continue;
            map<Point, int> normals;
            bool bad = false;
            for (int i = 0; i < n; i++) {
                if (moon == star[i]) {
                    bad = true;
                    break;
                }
                Point nrm = make_line(moon, star[i]).normal();
                if (normals[nrm] > 1) {
                    bad = true;
                    break;
                }
                normals[nrm]++;
                //cout << nrm << "\n";
            }
            if (bad)
                continue;
            //cout << "OK" << endl;
            for (auto nrm : normals) {
                //cout << nrm.first << " -> " << nrm.second << "\n";
                if (nrm.second != 2) {
                    bad = true;
                    break;
                }
            }
            if (bad)
                continue;
            cout << "Yes\n";
            cout << moon;
            return 0;
        }
    cout << "No";
    return 0;
}
