#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct Point {
    ll x, y;

    Point() {}

    Point(ll x, ll y) : x(x), y(y) {}
};

istream& operator>>(istream& in, Point &a) {
    in >> a.x >> a.y;
    return in;
}

ostream& operator<<(ostream& out, const Point &a) {
    out << a.x << " " << a.y;
    return out;
}

ll sokr(ll a, ll b) {
    if (a == 0)
        return b;
    if (b == 0)
        return a;
    ll res = __gcd(a, b);
    if (a / res < 0) {
        res *= -1;
    }
    return res;
}

struct Line {
    ll a, b;
    ll c;

    Line() {}

    Point normal() {
        Point p(a, b);
        p.x /= sokr(a, b);
        p.y /= sokr(a, b);
        return p;
    }
};

pair<Point, bool> intersection(const Line &l1, const Line &l2) {
    if (l1.b * l2.a - l1.a * l2.b == 0)
    return {Point(0, 0), false};
    Point res;
    if ((l1.a * l2.c - l1.c * l2.a) % (l1.b * l2.a - l1.a * l2.b))
        return {Point(0, 0), false};
    if ((l1.b * l2.c - l1.c * l2.b) % (l1.a * l2.b - l1.b * l2.a))
        return {Point(0, 0), false};
    res.y = (l1.a * l2.c - l1.c * l2.a) / (l1.b * l2.a - l1.a * l2.b);
    res.x = (l1.b * l2.c - l1.c * l2.b) / (l1.a * l2.b - l1.b * l2.a);
    return {res, true};
}

Line make_line(const Point &p1, const Point &p2) {
    Line l;
    l.a = p1.y - p2.y;
    l.b = p2.x - p1.x;
    l.c = -((ll)p1.x * l.a + p1.y * l.b);
    ll d = __gcd(__gcd(l.a, l.b), l.c);
    l.a /= d;
    l.b /= d;
    l.c /= d;
    //cout << l.a << " " << l.b << " " << l.c << "\n";
    return l;
}

bool operator<(const Point &a, const Point &b) {
    if (a.x == b.x)
        return a.y < b.y;
    return a.x < b.x;
}

bool operator==(const Point &a, const Point &b) {
    return (a.x == b.x && a.y == b.y);
}

int main() {
    //#undef KEK
    #ifdef KEK
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    #endif // KEK
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    n *= 2;
    vector<Point> star(n);
    for (int i = 0; i < n; i++)
        cin >> star[i];
    for (int p1 = 0; p1 < n; p1++)
        for (int p2 = 0; p2 < n; p2++)
            for (int p3 = 0; p3 < n; p3++)
    for (int p4 = 0; p4 < n; p4++) {
            if (p1 == p2 || p1 == p3 || p1 == p4)
            continue;
    if (p2 == p3 || p2 == p4)
        continue;
    if (p3 == p4)
        continue;
            auto q = intersection(make_line(star[p1], star[p4]), make_line(star[p3], star[p2]));
            if (!q.second)
                continue;
            Point moon = q.first;
            //if (!(moon == Point(3, 3)))
            //    continue;
            map<Point, int> normals;
            bool bad = false;
            for (int i = 0; i < n; i++) {
                if (moon == star[i]) {
                    bad = true;
                    break;
                }
                Point nrm = make_line(moon, star[i]).normal();
                if (normals[nrm] > 1) {
                    bad = true;
                    break;
                }
                normals[nrm]++;
                //cout << nrm << "\n";
            }
            if (bad)
                continue;
            //cout << "OK" << endl;
            for (auto nrm : normals) {
                //cout << nrm.first << " -> " << nrm.second << "\n";
                if (nrm.second != 2) {
                    bad = true;
                    break;
                }
            }
            if (bad)
                continue;
            cout << "Yes\n";
            cout << moon;
            return 0;
        }
    cout << "No";
    return 0;
}
