#include<iostream>
#include<vector>
#include<stdio.h>
#include<algorithm>
#include<stack>
#include<set>
#include<map>
#include<queue>
#include<tuple>
#include<string>

using namespace std;

const int INF=1e6;
long long DEG=1e7;


struct point{
	int x,y;
	point(){};
	point(int x,int y):x(x),y(y){};
	bool valid(){
		if(abs(x)>INF ||abs(y)>INF){
			return 0;
		}	
		return 1;
	}

	void out(){
		cout<<x<<' '<<y;
	}
};

struct line{
	long long a,b,c;
	line(){};
	line(long long a,long long b,long long c):a(a),b(b),c(c){};
	line(point p1,point p2){
		if(p1.x==p2.x){
			b=0;
			a=DEG;
			c=-p1.x*DEG;
		}
		else{
			b=DEG;
			a=(p1.y-p2.y)*DEG/(p2.x-p1.x);
			c=-p1.y*DEG-a*p1.x;
		}
	}
	point go(line l){
		if(a==l.a && b==l.b){
			return point(INF+1,INF+1);
		}
		if(!abs(b)){
			long long x=-c,y=-l.a*x-l.c;
			point p(x,y);
			if(p.x%DEG || p.y%DEG){
				return point(INF+1,INF+1);
			}
			else{
				p.x/=DEG;
				p.y/=DEG;
				return p;
			}
		}
		if(!abs(l.b)){
			long long x=-l.c,y=-a*x-c;
			point p(x,y);
			if(p.x%DEG || p.y%DEG){
				return point(INF+1,INF+1);
			}
			else{
				p.x/=DEG;
				p.y/=DEG;
				return p;
			}
		}
		if((c-l.c)%(a-l.a)){
			return point(INF+1,INF+1);
		}
		long long x=(c-l.c)/(l.a-a);
		long long y=-a*x-c;
		return point(x,y/DEG);
	}
};

bool operator<(const line&a,const line&b){
	return tie(a.a,a.b,a.c)<tie(b.a,b.b,b.c);
}

bool operator<(const point&a,const point&b){
	return tie(a.x,a.y)<tie(b.x,b.y);
}

int main(){
	int n;
	cin>>n;
	vector<point>v(2*n);
	map<point,bool>m;
	for(int i=0;i<2*n;i++){
		cin>>v[i].x>>v[i].y;
		m[v[i]]=1;
	}
	if(n==1){
		cout<<"Yes\n";
		point p1(2*v[0].x-v[1].x,2*v[0].y-v[1].y);
		point p2(2*v[1].x-v[0].x,2*v[1].y-v[0].y);
		if(p1.valid()){
			p1.out();
			return 0;
		}
		if(p2.valid()){
			p2.out();
			return 0;
		}
		int dx=v[0].x-v[1].x;
		int dy=v[0].y-v[1].y;
		for(int i=2;i*i<min(dx,dy);i++){
			if(!(dx%i) && !(dy%i)){
				point p(v[1].x+dx/i,v[1].y+dy/i);
				p.out();
				return 0;
			}
		}
	}
	for(int i=1;i<2*n;i++){
		line l(v[0],v[i]);
		map<point,int>mp;
		map<line,bool>ml;
		for(int j=1;j<2*n;j++){
			for(int k=j+1;j<2*n;j++){
				if((j-i) && (k-i)){
					line l1(v[j],v[k]);
					if(!ml.count(l1)){
						ml[l1]=1;
						point p=l.go(l1);
						if(p.valid() && !m.count(p)){
							if(!mp.count(p)){
								mp[p]=1;
							}
							mp[p]++;
							if(mp[p]==n){
								cout<<"Yes\n";
								p.out();
								return 0;
							}
						}
					}
				}
			}
		}
	}
	cout<<"No";
}