#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second

typedef long long ll;
typedef pair < ll, ll > pii;

ostream & operator << (ostream & out, vector < ll > & lst) {
    for (auto a : lst)
        out << a << ' ';
    return out;
}



struct Vec {
    ll x = 0, y = 0;
    Vec (ll x = 0, ll y = 0) : x(x), y(y) {};
    ll operator % (Vec a) {
        return (x * a.y) - (y * a.x);
    }
    ll operator * (Vec a) {
        return (x * a.x) + (y * a.y);
    }
    Vec operator + (Vec a) {
        return Vec(x + a.x, y + a.y);
    }
    Vec operator * (ll a) {
        return Vec(x * a, y * a);
    }
    Vec operator / (ll a) {
        return Vec(x / a, y / a);
    }
    Vec operator - (Vec a) {
        return Vec(x - a.x, y - a.y);
    }
    bool operator != (Vec a) {
        return (x != a.x) || (y != a.y);
    }
    bool operator == (Vec a) {
        return (x == a.x) && (y == a.y);
    }
};

ostream & operator << (ostream & out, Vec & lst) {
    out << lst.x << ' ' << lst.y;
    return out;
}

struct Line {
    Vec p, d;
    ll t;
    Line (Vec p, Vec d, ll t) : p(p), d(d), t(t) {};
};

const ll N = 205, inf = 12945678785;

Vec in_line (Line a, Line b) {
    ll cd = b.d % a.d, x = a.p % a.d, y = b.p % a.d;
    if (cd == 0 || (b.d.x * (x - y)) % cd != 0 || (b.d.y * (x - y)) % cd != 0) {
        return Vec(inf, inf);
    }
    assert(b.p + b.d * ((x - y) / cd) != Vec(inf, inf));
    return b.p + b.d * ((x - y) / cd);
}


ll n;
Vec lst[N];
vector < Line > res;
vector < Vec > ans;

ll gcd (ll a, ll b) {
    a = abs(a), b = abs(b);
    if (a < b)
        swap(a, b);
    while (a * b > 0) {
        ll c = b;
        b = a % b;
        a = c;
    }
    return max(1LL, max(a, b));
}

void f() {
    for (ll i = 0; i < n; ++i) {
        cin >> lst[i].x >> lst[i].y;
    }
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            if (j == i)
                continue;
            Vec P = (lst[j] - lst[i]);
            res.pb(Line(lst[i], P / gcd(P.x, P.y), gcd(P.x, P.y)));
            //cout << lst[i] << ' ' << lst[j] << endl;
        }
    }
}

bool ok(ll j, ll i) {
    if (res[j].p == res[i].p || res[j].p + res[j].d * res[j].t == res[i].p)
        return false;
    if (res[j].p == res[i].p + res[i].d * res[i].t)
        return false;
    if (res[j].p + res[j].d * res[j].t == res[i].p + res[i].d * res[i].t)
        return false;
    return true;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    n *= 2;
    assert(n <= 25);
    f();

    ll m = res.size();
    Vec INF(inf, inf);
    //Vec P = in_line(Line(Vec(1, 1), Vec(1, 1)), Line(Vec(1, 3), Vec(1, -1)));
    //cout << P.x << ' '<< P.y << endl;
    for (ll i = 0; i < m; ++i) {
        ll k = (i + 1) % m;
        while (!ok(i, k))
            k = (k + 1) % m;
        Vec P = in_line(res[i], res[k]);
        //cout << P.x << ' '<< P.y << endl;
        if (P == INF)
            continue;
        bool fl = true;
        for (ll i = 0; i < n; ++i) {
            if (P == lst[i])
                fl = false;
        }
        vector < Line > ou = {res[k]};
        for (ll j = 0; j < m; j++) {
            if (!ok(j, i) || !ok(j, k))
                continue;
            if (in_line(res[i], res[j]) != P) {
                fl = false;
                break;
            }
            ou.pb(res[j]);
        }
        if (fl) {
            for (ll i = 0; i < ou.size(); i++) {
                Line p = ou[i];
                for (ll j = 0; j < ou.size(); j++) {
                    if (i == j)
                        continue;
                    Line m = ou[j];
                    if (in_line(p, m) != P)
                        fl = false;
                        break;
                    }
                    if (!fl)
                        break;
                }
        }
        if (fl) {
            cout << "Yes\n";
            cout << P.x << ' ' << P.y;
            return 0;
        }
    }
    cout << "No";
    return 0;
}

