#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()
#define sz(x) x.size()
////

struct point
	{
		ld x, y;
		void scan()
		{
			cin >> x >> y;
		}
		point() {}
		point(ld _x, ld _y)
		{
			x = _x;
			y = _y;
		}

		point operator -(const point &other)const
		{
			return point(x - other.x, y - other.y);
		}

		ld lenght()
		{
			return sqrt(ld(x * x + y * y));
		}
		void to90()
		{
			int a = x;
			int b = y;
			x = -b;
			y = a;
		}
		bool operator <(const point &other)const
		{
			if (x != other.x)
				return x < other.x;
			return y < other.y;
		}
};

struct line
{
	ld a, b, c;
	void get_from_vector (point f, point s)
	{
		point lines = f - s;
		lines.to90();
		a = lines.x;
		b = lines.y;
		c = -(a * f.x + b * f.y);
	}
};

point ln_intersect(line f, line s)
{
	if (f.a * s.b == s.a * f.b)
		return point(-1e18, -1e18);
	ld bottom = -(f.a * s.b - s.a * f.b);
	ld x = (f.c * s.b - s.c * f.b) / bottom;
	ld y = (f.a * s.c - s.a * f.c) / bottom;
	return point(x, y);
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.precision(6);
	int n;
	cin >> n;
	vector <point> stars(n * 2);
	for (int i = 0; i < n * 2; i++)
	{
		stars[i].scan();
	}
	sort(all(stars));
	do
	{
		line first;
		line second;
		first.get_from_vector(stars[0], stars[1]);
		second.get_from_vector(stars[2], stars[3]);
		point ans = ln_intersect(first, second);
		if (ans.x == -1e18 && ans.y == -1e18)
			continue;
		if (ans.x != int(ans.x) || ans.y != int(ans.y))
			continue;
		cout << "Yes"<<endl;
		cout << int(ans.x)<<" "<<int(ans.y);
		return 0;
	}
	while(next_permutation(all(stars)));
	cout <<"No"<<endl;
	cout << -1;
	return 0;
}