#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

const int N = 5e6 + 7;

bool ck[N];

int cnt[26];
int n;
string s;

int gcd(int a, int b) {
    return (b == 0 ? a : gcd(b, a % b));
}

int nok(int a, int b) {
    if (a == -1) return b;
    return (ll)a * b / gcd(a, b);
}


int mass_gcd() {
    int cur = 0;
    for (int i = 0; i < 26; ++i) {
        cur = gcd(cur, cnt[i]);
    }
    return cur;
}

vector <int> all_div(int x) {
    vector <int> cur;
    for (int i = 1; i <= x; ++i) {
        if (x % i == 0) {
            cur.push_back(i);
        }
    }
    return cur;
}

bool check(int x) {
    vector <int> n_cnt(26);
    for (int i = 0; i < 26; ++i) {
        n_cnt[i] = cnt[i] / x;
    }
    int block_len = n / x;
    for (int i = 0; i < n; i += block_len) {
        vector <int> tmp(26);
        for (int j = 0; j < block_len; ++j) {
            ++tmp[s[i + j] - 'a'];
        }
        if (tmp != n_cnt) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; ++i) {
        ++cnt[s[i] - 'a'];
    }
    vector <int> cur = all_div(mass_gcd());
    int ans = 1;
    for (auto e : cur) {
        if (e <= ans) continue;
        if (check(e)) {
            ans = nok(ans, e);
        }
    }
    cout << ans << endl;
}
